VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Globals8"
Attribute VB_GlobalNameSpace = True
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'---------------------------
' TrueVision Global Class
'---------------------------
' Contains macro stuff

Dim CosTable(1440) As Single
Dim SinTable(1440) As Single




Public Enum CONST_TV_CULLING
  '##EN Defines the kind of face culling.
  TV_FRONT_CULL = D3DCULL_CCW
  '##EM TV_FRONT_CULL Front culling (the front of the faces are rendered)
  TV_BACK_CULL = D3DCULL_CW
  '##EM TV_BACK_CULL Backface culling (the back of the faces are rendered)
  TV_DOUBLESIDED = D3DCULL_NONE
  '##EM TV_DOUBLESIDED No culling (the front and the back of the faces are rendered)
End Enum
Function ActorPicking(Actor As Actor8, ByRef ReturnBoneTouched As String) As Boolean
   Dim mx As Long, my As Long, Nearv As D3DVECTOR, DirV As D3DVECTOR, Bone As Integer
   LocalInput.GetAbsMouseState mx, my
   GetProjetedVector mx, my, Nearv, DirV
   ActorPicking = Actor.Collide(Nearv, DirV, TV_TESTTYPE_MDL_HITBOXES, Bone)
   ReturnBoneTouched = ""
   If Bone > 0 Then
     ReturnBoneTouched = Actor.GetBoneNameFromID(Bone)
   End If
End Function

Function Colorkey(CKey As CONST_TV_COLORKEY) As Long
   Colorkey = CKey
End Function


Function CosT(DegreesAngle As Single) As Single
    CosT = CosTable(DegreesAngle \ 4)
End Function
Function CreateDecal(Position As D3DVECTOR, normal As D3DVECTOR, Texture As Texture8, Size As Single, Optional DeathTime As Single = 0) As Mesh8
   Set CreateDecal = LocalScene.CreateMeshBuilder("Decal")
   ' Calculate right component of view vector
   'L_dVR = VCrossProduct(L_dVDefaultUp, L_dVView)
   Dim V1 As D3DVECTOR, V2 As D3DVECTOR, v3 As D3DVECTOR
   V1 = Vector(0, 1, 0)
   V2 = normal
   D3DXVec3Cross v3, V1, V2
   
   ' Calculate up component of view vector
   D3DXVec3Cross V1, V2, v3
   
    'L_dVU = VCrossProduct(L_dVView, L_dVR)
        
   ' Normalize right and up
   V1 = VNormalize(V1)
   V2 = VNormalize(v3)
   
   'fix the y-plane bug
   If VCompare(normal, Vector(0, 1, 0)) <> 0 Then
     V1.x = 1
     V2.z = 1
   End If
   If VCompare(normal, Vector(0, -1, 0)) <> 0 Then
     V1.x = -1
     V2.z = -1
   End If
   
   Dim S As Single
   S = Size / 2
   
   
   Dim V(4) As D3DVECTOR
   V(1) = VScale(VAdd(VNegate(V1), VNegate(V2)), S)
   V(2) = VScale(VAdd(V1, VNegate(V2)), S)
   V(3) = VScale(VAdd(VNegate(V1), V2), S)
   V(4) = VScale(VAdd(V1, V2), S)
   
   
   CreateDecal.SetPosition Position.x + normal.x * 1, Position.y + normal.y * 1, Position.z + normal.z * 1
   CreateDecal.SetDeathTime DeathTime
   CreateDecal.AddFaceFromPoint Texture, V(1).x, V(1).y, V(1).z, V(2).x, V(2).y, V(2).z, V(3).x, V(3).y, V(3).z, V(4).x, V(4).y, V(4).z
   CreateDecal.SetPrimitiveType TV_TRIANGLESTRIP
   CreateDecal.SetVertexType TV_COLOR_VERTEX
   CreateDecal.SetBlendingMode TV_BLEND_COLOR
End Function


Public Function Direction2Ang(vx As Single, vz As Single) As Single
    If vz > 0 Then
      Direction2Ang = Atn(vx / vz)
    Else
      Direction2Ang = Atn(vx / vz) + 3.1415
    End If
    Direction2Ang = Rad2Deg(Direction2Ang)
End Function

Function GetShader(ShaderName As String) As Shader8
  Dim i As Long
  For i = 1 To NbShaders
     If UCase$(ShaderName) = UCase$(Shaders(i).ShaderName) Then
       Set GetShader = Shaders(i).Object
       Exit Function
     End If
  Next i
  Set GetShader = Nothing
End Function

Function GetTexNameFromId(TexIndex As Integer) As String
    GetTexNameFromId = Textures(TexIndex).TextureName
End Function
Function GetTexNameFromObject(Texture As Texture8) As String
     GetTexNameFromObject = GetTexNameFromId(Texture.GetTexIndex)
End Function


Sub MousePickVector(ByVal x As Long, ByVal y As Long, ByRef VOrigin As D3DVECTOR, ByRef VDest As D3DVECTOR)
  GetProjetedVector x, y, VOrigin, VDest
End Sub

Public Sub SaveTexture(Texture As Texture8, Filename As String)
  TexSave Filename, Texture
End Sub

Sub SetUserClipPlane(Enable As Boolean, planeID As Integer, normalx As Single, normaly As Single, normalz As Single, Dist As Single)
  Dim C As Long, Plane As D3DPLANE
  If planeID > -1 And planeID < 6 Then
    If Enable = True Then
     Plane.a = normalx
     Plane.b = normaly
     Plane.C = normalz
     Plane.d = Dist
     Device.SetClipPlane planeID, Plane
     ClipPlane(planeID) = True
    Else
     ClipPlane(planeID) = False
    End If
    C = 0
    For i = 0 To 5
     If ClipPlane(i) = True Then
       C = C + (2 ^ i)
     End If
    Next i
     Device.SetRenderState D3DRS_CLIPPLANEENABLE, C
  End If
End Sub

Function SinT(DegreesAngle As Single) As Single
    SinT = SinTable(DegreesAngle \ 4)
End Function

Function Deg2Rad(Degrees As Single) As Single
    DegToRad = Degrees * 3.141592653 / 180
End Function

Public Function GetDistance2D(x1, y1, X2, y2) As Single
    '##BD Get the distance between two 2D-point
    GetDistance2D = Sqr((x1 - X2) ^ 2 + (y1 - y2) ^ 2)
    
End Function
Public Function GetDistance3D(x1, y1, z1, X2, y2, z2) As Single
     '##BD Get the distance between two 3D-point
    GetDistance3D = Sqr((x1 - X2) ^ 2 + (y1 - y2) ^ 2 + (z1 - z2) ^ 2)
End Function



Function GetSprite(Name As String) As Integer
  For i = 1 To NBSprite
     If UCase$(Name) = UCase$(sprites(i).Name) Then
       GetSprite = i
       Exit Function
     End If
  Next i
  GetSprite = 0
End Function

Function Rad2Deg(Radian As Single) As Single
    Rad2Deg = Radian * 180 / 3.141592653
End Function
Function Vector3(x As Single, y As Single, z As Single) As D3DVECTOR
    Vector3.x = x
    Vector3.y = y
    Vector3.z = z
End Function

Function VModulus(V As D3DVECTOR) As Single
   If V.x = 0 And V.y = 0 And V.z = 0 Then
     VModulus = 0
   Else
     VModulus = D3DXVec3Length(V)
   End If
End Function

Public Function VNormalize(dVector As D3DVECTOR) As D3DVECTOR
  '##BD Returns the nomalized vector (unit vector)
  V = D3DXVec3Length(dVector)
  If V = 0 Then VNormalize = Vector(0, 0, 0): Exit Function
  
  VNormalize = Vector(dVector.x / V, dVector.y / V, dVector.z / V)
End Function
Public Function VScale(dV1 As D3DVECTOR, TScale As Single) As D3DVECTOR
 '##BD Scale the vector by a factor.
 '##PD dV1 Origin vector
 '##PD TScale Scale factor
 VScale = Vector(dV1.x * TScale, dV1.y * TScale, dV1.z * TScale)
End Function


Public Function VAdd(dV1 As D3DVECTOR, dV2 As D3DVECTOR) As D3DVECTOR
    '##BD Add two vectors
    VAdd.x = dV1.x + dV2.x
    VAdd.y = dV1.y + dV2.y
    VAdd.z = dV1.z + dV2.z
End Function


Public Function VSubtract(dV1 As D3DVECTOR, dV2 As D3DVECTOR) As D3DVECTOR
   '##BD Subtract two vectors.
    VSubtract.x = dV1.x - dV2.x
    VSubtract.y = dV1.y - dV2.y
    VSubtract.z = dV1.z - dV2.z
End Function


Public Function ColorValue(r, g, b, a) As D3DCOLORVALUE
 '##BD Returns a D3D color value (color structure) from red, green, blue and alpha values.
 '##PD r Red value (0-1)
 '##PD g Green value (0-1)
 '##PD b Blue value (0-1)
 '##PD a Alpha value (0-1)
 
 With ColorValue
  .a = a
  .b = b
  .g = g
  .r = r
 End With
End Function

Public Function VCrossProduct(V1 As D3DVECTOR, V2 As D3DVECTOR) As D3DVECTOR
  '##BD Returns the cross product vector from two vectors. This function can be called to compute the face normals.
  '##PD V1 First vector
  '##PD V2 Second vector
  D3DXVec3Cross VCrossProduct, V1, V2
End Function

Public Function VDotProduct(V1 As D3DVECTOR, V2 As D3DVECTOR) As Single
  '##BD Returns the dot product of two vectors.
  '##PD V1 First vector
  '##PD V2 Second vector
  VDotProduct = D3DXVec3Dot(V1, V2)
End Function
Function RGBA(r, g, b, a) As Long
   RGBA = DXCToL(DXColor(r, g, b, a))
End Function


Function REC(x, y, x1, y1) As RECT
   REC.Left = x
   REC.Right = x1
   REC.Top = y
   REC.Bottom = y1
End Function

Function LVertex(x, y, z, C, tu, tv) As D3DLVERTEX
     With LVertex
       .x = x
       .y = y
       .z = z
       .color = C
       .Specular = C
       .tu = tu
       .tv = tv
     End With

End Function


Function TLVertex(x As Single, y As Single, z As Single, color As Long, tu As Single, tv As Single) As D3DTLVERTEX
   With TLVertex
      .sx = x
      .sy = y
      .sz = z
      .color = color
      .tu = tu
      .tv = tv
      .rhw = 0.5
      .Specular = color
   End With
End Function


Function Vertex2(x, y, z, nx, ny, nz, tu, tv, tu1, tv1) As D3DVERTEX2
      With Vertex2
          .x = x
          .y = y
          .z = z
          .nx = nx
          .ny = ny
          .nz = nz
          .tu1 = tu
          .tv1 = tv
          .tu2 = tu1
          .tv2 = tu2
      End With
End Function
Function GetMat(MaterialName As String) As Integer
  'Macro for Getting materials
  For i = 1 To NBMaterial
     If UCase$(MaterialName) = UCase$(Materials(i).MaterialName) Then
       GetMat = i
       Exit Function
     End If
  Next i
  GetMat = 0
End Function


Function GetMesh(MeshName As String) As Mesh8
  For i = 1 To NBMesh
     If UCase$(MeshName) = UCase$(Mesh(i).MeshName) Then
       Set GetMesh = Mesh(i).Object
       Exit Function
     End If
  Next i
  Set GetMesh = Nothing
End Function

Function GetSound(SoundName As String) As Integer
  For i = 1 To NBSounds
     If UCase$(SoundName) = UCase$(Sounds(i).SoundName) Then
       GetSound = i
       Exit Function
     End If
  Next i
  GetSound = 0
End Function

Function GetTerrain(Name As String) As Integer
   
End Function

Function GetTex(Name As String) As Texture8
  'Macro for getting textures
  For i = 1 To NBTexture
     If UCase$(Name) = UCase$(Textures(i).TextureName) Then
       Set GetTex = Textures(i).TextureOb
       Exit Function
     End If
  Next i
  Set GetTex = Nothing
End Function
Function GetTexIndex(Name As String) As Integer
  'Macro for getting textures
  For i = 1 To NBTexture
     If UCase$(Name) = UCase$(Textures(i).TextureName) Then
       GetTexIndex = i
       Exit Function
     End If
  Next i
  GetTexIndex = 0
End Function

Function Vector(x As Single, y As Single, z As Single) As D3DVECTOR
    Vector.x = x
    Vector.y = y
    Vector.z = z
End Function

Private Sub Class_Initialize()
  AddLog "MATH HELPER : Create the Cos/Sin Table"
    For i = 0 To 1440
       CosTable(i) = Cos(i / 4 * 3.1415 / 180)
       SinTable(i) = Sin(i / 4 * 3.1415 / 180)
    Next i
End Sub


