VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Landscape8"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'-----------------------------------'
'      TrueVision8 Landscape        '
'-----------------------------------'
'
' started 15/11/00
'
Option Explicit


Private Land As LandscapeType, HeightMapLoaded As Integer
Private ViewP As D3DVIEWPORT8

Public Enum CONST_TV_LANDSCAPE_PRECISION
  TV_PRECISION_LOW = 32
  TV_PRECISION_HIGH = 8
  TV_PRECISION_AVERAGE = 16
  TV_PRECISION_BEST = 4
  TV_PRECISION_ULTRA = 2
End Enum

Public Enum CONST_TV_LAND_SUNMODE
'##EN Set up the sun.
  TV_SUN_REALTIME_MOVING = 1
  '##EM TV_SUN_REALTIME_MOVING The sun moves with the day time.
  TV_SUN_CHANGE_AMBIENT_LIGHT = 2
  '##EM TV_SUN_CHANGE_AMBIENT_LIGHT Changes the scene background and the ambient light in order of the sun position.
  TV_SUN_DEFAULT = 0
  '##EM TV_SUN_DEFAULT Set a default sun (no move, no light change)
End Enum

Public Enum CONST_TV_LAND_CLOUDMODE
'##EN Set up clouds
  TV_CLOUD_MOVE = 1
  '##EM TV_CLOUD_MOVE The clouds moves.
  TV_CLOUD_DEFAULT = 0
  '##EM TV_CLOUD_DEFAULT Default clouds layer (no move)
End Enum

Public Enum CONST_TV_LANDSCAPEMODE
  TV_LANDMODE_SIMPLELAND = 1
  TV_LANDMODE_ADVANCEDLAND = 2
End Enum


Private WhetherBS As New ParticleSystem8
Public Sub AddTextureLayer(Texture As Texture8)
 If Not Texture Is Nothing Then
   Land.NumLayerTex = Land.NumLayerTex + 1
   ReDim Preserve Land.LayerTex(Land.NumLayerTex)
   Land.LayerTex(Land.NumLayerTex).Texture = Texture.GetTexIndex
 End If
End Sub

Function AdvancedCollide(StartPos As D3DVECTOR, EndPos As D3DVECTOR) As CollisionResult8
    Set AdvancedCollide = MousePicking(StartPos, EndPos)
End Function


'Private AdvancedLand As New LandscapeAdv8
Sub AdvChangeTexture(Texture As Integer, x As Single, z As Single)
    Dim i As Long
     Dim Pointer As Long
     Dim PosX As Long, PosZ As Long, V As Long
     Dim S As Long
     For i = 1 To Land.NbTerrain
      If Land.Terrain(i).Position.x <= x And Land.Terrain(i).Position.z <= z _
        And Land.Terrain(i).Position.x + 256 >= x And Land.Terrain(i).Position.z + 256 >= z Then
    
        PosX = Int((x - Land.Terrain(i).Position.x) / Land.Terrain(i).Precision)
        PosZ = Int((z - Land.Terrain(i).Position.z) / Land.Terrain(i).Precision)
        
        With Land.Terrain(i)
           V = (PosZ * (.width - 1) + PosX) * 2
           Land.Terrain(i).AttributeTable(V) = Texture
           Land.Terrain(i).AttributeTable(V + 1) = Texture
        End With
          
          Pointer = Land.Terrain(i).Mesh.LockAttributeBuffer(0)
          DXCopyMemory ByVal Pointer, Land.Terrain(i).AttributeTable(0), UBound(Land.Terrain(i).AttributeTable) * 4#
          Land.Terrain(i).Mesh.UnlockAttributeBuffer
          
       End If
     Next i
End Sub
Sub AdvEnableChunk(OnOff As Boolean, x As Single, z As Single)
      Dim i As Long
     Dim Pointer As Long
     Dim PosX As Long, PosZ As Long, V As Long
     Dim S As Long
     For i = 1 To Land.NbTerrain
      If Land.Terrain(i).Position.x <= x And Land.Terrain(i).Position.z <= z _
        And Land.Terrain(i).Position.x + 256 >= x And Land.Terrain(i).Position.z + 256 >= z Then
    
        PosX = Int((x - Land.Terrain(i).Position.x) / Land.Terrain(i).Precision)
        PosZ = Int((z - Land.Terrain(i).Position.z) / Land.Terrain(i).Precision)
        
        With Land.Terrain(i)
           V = (PosZ * (.width - 1) + PosX) * 2
           If OnOff = True Then S = 1 Else S = -1
           Land.Terrain(i).AttributeTable(V) = S * Abs(Land.Terrain(i).AttributeTable(V))
           Land.Terrain(i).AttributeTable(V + 1) = S * Abs(Land.Terrain(i).AttributeTable(V + 1))
        End With
          
          Pointer = Land.Terrain(i).Mesh.LockAttributeBuffer(0)
          DXCopyMemory ByVal Pointer, Land.Terrain(i).AttributeTable(0), UBound(Land.Terrain(i).AttributeTable) * 4#
          Land.Terrain(i).Mesh.UnlockAttributeBuffer
          
       End If
     Next i

End Sub
Sub AdvSetTextureTable(NBTexture As Integer, ArrayOfTexturesZeroBased() As Texture8)
   Dim i As Long
    ReDim Land.TexUsed(NBTexture)
    Land.TexUsedNumber = NBTexture
   For i = 1 To NBTexture
     If Not ArrayOfTexturesZeroBased(i - 1) Is Nothing Then
      Land.TexUsed(i) = ArrayOfTexturesZeroBased(i - 1).GetTexIndex
     Else
      Land.TexUsed(i) = 0
     End If
     
   Next i
End Sub

Public Sub ChangePointAltitude(x As Single, z As Single, height As Single)
     Dim i As Long
     On Error Resume Next
     Dim PosX As Long, PosZ As Long, V As Long
     For i = 1 To Land.NbTerrain
      If Land.Terrain(i).Position.x <= x And Land.Terrain(i).Position.z <= z _
        And Land.Terrain(i).Position.x + 256 + Land.Terrain(i).Precision >= x And Land.Terrain(i).Position.z + 256 + Land.Terrain(i).Precision >= z Then
    
        PosX = Int((x - Land.Terrain(i).Position.x) / Land.Terrain(i).Precision)
        PosZ = Int((z - Land.Terrain(i).Position.z) / Land.Terrain(i).Precision)
        
        With Land.Terrain(i)
            V = PosZ * .width + PosX
            .Vertex(V).y = height
            D3DVertexBuffer8SetData .Mesh.GetVertexBuffer, 0, .NVertex * 40#, 0, .Vertex(0)
        End With
       End If
     Next i
     
End Sub


Private Sub CreateBumpMappingWater()
  
  Dim Pointer As Long
  Dim Bump() As Byte
  Set Land.Water.WaterBump = D3DX.CreateTexture(Device, 256, 256, 1, 0, D3DFMT_V8U8, D3DPOOL_MANAGED)
  Dim fx As Single, fy As Single
  ReDim Bump(131072) As Byte
  Dim i As Long, y As Long, x As Long, r As Single
  Dim afx As Single, afy As Single
  i = 0
  For y = 0 To 255
   For x = 0 To 255
     afx = x / 255# - 0.5
     afy = y / 255# - 0.5
     r = Sqr(afx * afx + fy * fy)
     Bump(i) = (32 * Cos(300 * r) + 32)
     Bump(i) = Bump(i) + (16 + 16 * Cos(150 * (afx + afy)))
     Bump(i) = Bump(i) + (8 + 8 * Cos(140 * (afx * 0.85 - afy)))
     
     Bump(i + 1) = (32 * Cos(300 * r) + 32)
     Bump(i + 1) = Bump(i) + (16 + 16 * Cos(150 * (afx + afy)))
     Bump(i + 1) = Bump(i) + (8 + 8 * Cos(140 * (afx * 0.85 - afy)))
     i = i + 2
   Next x
  Next y
  Dim REC As D3DLOCKED_RECT
   Land.Water.WaterBump.LockRect 0, REC, ByVal 0, D3DLOCK_DISCARD
   DXCopyMemory ByVal REC.pBits, Bump(0), 131072
   Land.Water.WaterBump.UnlockRect 0
  'Land.Water.BumpMapped = True
     
 
End Sub

Public Sub CreateDynTextures(Optional TextureWidth As Long = 256, Optional TextureHeight As Long = 256, Optional KeepOldTexture As Boolean = False)
 '##BD Creates a set of dynamic textures for this landscape. You can paint on this textures in order to create beautiful effects. You can write to this texture with the DynDraw's methods. NOTE : These textures are extremely useful for terrain editors.
 '##PD TextureWidth Width of the created texture on each terrain chunk
 '##PD TextureHeight Should be the same than width.
 '##PD KeepOldTexture Decides if the engine has to create black textures or create the textures with the actual non-dynamic textures.
 Dim tex As Integer
 Dim Surf As Direct3DSurface8
 
 D3DX.CheckTextureRequirements Device, TextureWidth, TextureHeight, 0, D3DUSAGE_RENDERTARGET, FmtTexture, D3DPOOL_DEFAULT
 AddLog "LANDSCAPE MANAGING : Create dynamic textures " & TextureWidth & " " & TextureHeight & " with format " & FmtTexture
  

 'Create one texture for each chunks of terrain
 Dim i As Long
 For i = 1 To Land.NbTerrain
   tex = LocTexFactory.GetNewTextureIndex
   Set Textures(tex).TexSurf = D3DX.CreateTexture(Device, TextureWidth, TextureHeight, 1, 0, FmtTexture, D3DPOOL_DEFAULT)
   Set Textures(tex).RTS = D3DX.CreateRenderToSurface(Device, TextureWidth, TextureHeight, FmtTexture, True, D3DFMT_D16)
   'Set Surf =
   ViewP.width = TextureWidth
   ViewP.height = TextureHeight
   ViewP.maxZ = 1
   Textures(tex).TextureWidth = TextureWidth
   Textures(tex).TextureHeight = TextureHeight
   
   Textures(tex).RTS.BeginScene Textures(tex).TexSurf.GetSurfaceLevel(0), ViewP
     
     'clear the texture
     Device.Clear 0, ByVal 0, D3DCLEAR_TARGET, 0, 1, 0
     
     'if the user has chosen to keep the textures :
     If KeepOldTexture = True Then
        LocalScreen.DrawPartTexture Textures(Land.Terrain(i).TextureI).TextureOb, -1, -1, 256, 256, 0.01, 0.01, Land.TexWidth - 0.01, Land.TexHeight - 0.01
     End If
   Textures(tex).RTS.EndScene
   Land.Terrain(i).TextureI = tex
 Next i
  
End Sub
Sub CreateEmptyTerrain(Precision As CONST_TV_LANDSCAPE_PRECISION, width As Long, height As Long, PositionX As Single, PositionZ As Single)
   Dim x As Long, y As Long
   For x = 0 To width - 1
     For y = 0 To height - 1
       GenerateTerrainEx "", Precision, PositionX + x * 256, PositionZ + y * 256, x / width, y / height, 1 / width, 1 / height, "", True, False, False
     Next y
  Next x
End Sub

Sub CreateTrackFromFile(TrackDescFile As String, RoadTexture As Texture8)

End Sub




Private Sub CreateVertexFromLens(Flare As Integer, Size As Single, color1 As Long, color2 As Long)
With LensFlares(Flare)
   .Vertex(0) = LVertex(-Size, -Size, 0, color1, 0, 0)
   .Vertex(1) = LVertex(Size, -Size, 0, color1, 1, 0)
   .Vertex(2) = LVertex(-Size, Size, 0, color1, 0, 1)
   .Vertex(3) = LVertex(Size, Size, 0, color1, 1, 1)
   .Size = Size
End With

End Sub

Public Sub DynDrawTexture(Texture As Texture8, x As Single, z As Single, x1 As Single, z1 As Single, Optional color As Long = -1, Optional blended As Boolean = False)
   '##BD Paint a texture on a dynamic terrain texture. You must have called the CreateDynTexture before using this function.
   '##PD x Left-top corner on the terrain
   '##PD z Left-top corner on the terrain
   '##PD x1 Right-bottom corner on the terrain
   '##PD y1 Right-bottom corner on the terrain
   
   'Draw the texture on all the collided dyn textures
   
   Dim i As Long, newx As Single, newz As Single, neww As Single, newh As Single
   Dim ScaleS As Single, tw As Long, th As Long
   If blended = True Then
     Device.SetRenderState D3DRS_ALPHABLENDENABLE, 1
     Device.SetRenderState D3DRS_ALPHATESTENABLE, 1
   Else
     Device.SetRenderState D3DRS_ALPHABLENDENABLE, 0
   End If
    
   For i = 1 To Land.NbTerrain
      With Land.Terrain(i)
       ' If TestInTerrain(i, x, z, x1, z1) = True Then
          'Device.SetTexture 0, Textures(Texture.GetTexIndex).TexSurf
          ScaleS = Textures(.TextureI).TextureWidth / 256
          tw = Textures(.TextureI).TextureWidth
          th = Textures(.TextureI).TextureHeight
          newx = (x - .Position.x) * ScaleS
          newz = (z - .Position.z) * ScaleS
          neww = (x1 - .Position.x) * ScaleS
          newh = (z1 - .Position.z) * ScaleS
          
          'Sort of 2d frustum culling :)
          If newx > tw And neww > tw Then GoTo 5
          If newx < 0 And neww < 0 Then GoTo 5
          If newz > th And newh > th Then GoTo 5
          If newz < 0 And newh < 0 Then GoTo 5
      
          Textures(.TextureI).RTS.BeginScene Textures(.TextureI).TexSurf.GetSurfaceLevel(0), ViewP
          LocalScreen.DrawPartTexture Texture, newx, newz, neww, newh, 0.002, 0.002, 0.998, 0.998, color, blended
          Textures(.TextureI).RTS.EndScene
          
      '  End If
      End With
5:
   Next i
   Device.SetRenderState D3DRS_ZENABLE, 1
   Device.SetRenderState D3DRS_ZWRITEENABLE, 1
   Device.SetViewport Viewport
End Sub

Sub EnableLOD(OnOff As Boolean)
   Land.Mode = OnOff
End Sub

Sub ExpandTexture(Texture As Texture8, TerrainMinX As Integer, TerrainMinZ As Integer, TerrainMaxX As Integer, TerrainMaxZ As Integer)
   Dim scalex As Single
   Dim scaley As Single
   Dim DecalX As Single, DecalY As Single
   Dim cx As Long, cy As Long, x As Long, y As Long, i As Long
   Dim V As Long
   scalex = 1 / (TerrainMaxX - TerrainMinX)
   scaley = 1 / (TerrainMaxZ - TerrainMinZ)
   
   For x = TerrainMinX To TerrainMaxX
    For y = TerrainMinZ To TerrainMaxZ
       DecalX = (x - TerrainMinX) * scalex
       DecalY = (y - TerrainMinZ) * scaley
        For i = 1 To Land.NbTerrain
         With Land.Terrain(i)
          If (.Position.x \ 256) = x And (.Position.z \ 256) = y Then
           .TextureI = Texture.GetTexIndex
           AddLog CStr(x) + " " + CStr(y)
          For cx = 0 To .width - 1
            For cy = 0 To .height - 1
              V = .width * cy + cx
              .Vertex(V).tu1 = cx / (.width - 1) * scalex * 0.995 + 0.0025 + DecalX
              .Vertex(V).tv1 = cy / (.height - 1) * scaley * 0.995 + 0.0025 + DecalY
            Next cy
          Next cx
          D3DVertexBuffer8SetData .Mesh.GetVertexBuffer, 0, .NVertex * 40#, 0, .Vertex(0)
          End If
        End With
      Next i
    Next y
   Next x
   
End Sub

Public Sub GenerateTexture(width As Long, height As Long)
  
  '##BD Generate a texture from the defined texture layers (can be very slow)
  '##PD Width Width of the new texture on each terrain
  '##PD Height Height of the new texture on each terrain

 D3DX.CheckTextureRequirements Device, width, height, 1, 0, D3DFMT_R5G6B5, D3DPOOL_MANAGED
  
  Dim Land16() As Byte
  Dim Land24() As Byte
  
  'NbByteTerrain = 1# * width * height * 2
  'NbByteTerrain2 = 1# * width * height * 3
  
  
 ' For i = 1 To Land.NbTerrain

' Next i
End Sub
Sub ClearTextureLayers()
  Land.NumLayerTex = 0
  ReDim Land.LayerTex(0)
End Sub
Friend Function GetDesc() As LandscapeType
   GetDesc = Land
End Function

Function GetNormal(x As Single, z As Single) As D3DVECTOR
   Dim y As Single
   y = GetHeight(x, z)
   GetNormal = CollisionNormal
   
End Function

Function GetSlope(x As Single, z As Single, x1 As Single, z1 As Single) As Single
    Dim V As Single, V1 As Single, V2 As Single
    V = Sqr((x1 - x) ^ 2 + (z1 - z) ^ 2)
    
    V1 = GetHeight(x, z)
    V2 = GetHeight(x1, z1)
    
    GetSlope = (V2 - V1) / V
End Function
Function GetSlopeAngle(x As Single, z As Single, x1 As Single, z1 As Single) As Single
   '##BD Returns the angle of the slope between two points. This slope angles is in degrees.
   '##PD x Point
   Dim Slope As Single
   Slope = GetSlope(x, z, x1, z1)
   GetSlopeAngle = Atn(Slope) * 180 / 3.1415
End Function


Sub InitClouds(CloudTexture As Texture8, Optional CloudFlags As CONST_TV_LAND_CLOUDMODE = TV_CLOUD_MOVE, Optional CloudHeight = 500, Optional Layer As Integer = 1, Optional LayerCount As Integer = 1, Optional TilingX As Single = 1, Optional TilingY As Single = 1, Optional CloudExpand As Single = 0)
'##BD Create a clouds layer with specified altitude.

'##PD CloudTexture The clouds texture.
'##PD CloudFlags Clouds parameters.
'##PD CloudHeight Cloud layer altitude.
'##PD Layer Layer index.
'##PD LayerCount Layers count (usually 1).

 Land.DayFX.LandscapeCloud = True
 ReDim Preserve Land.DayFX.Layers(LayerCount)
 Dim i As Long, x1 As Single, y1 As Single, X2 As Single, y2 As Single
 x1 = 9999
 X2 = -9999
 y1 = 9999
 y2 = -9999
 
 For i = 1 To Land.NbTerrain
    With Land.Terrain(i)
       If .Position.x < x1 Then x1 = .Position.x
       If .Position.z < y1 Then y1 = .Position.z
       If .Position.x > X2 Then X2 = .Position.x
       If .Position.z > y2 Then y2 = .Position.z
    End With
 Next i
 
 If CloudExpand = 0 Then
  x1 = x1 - 1024
  X2 = X2 + 1024
  y1 = y1 - 1024
  y2 = y2 + 1024
 Else
  x1 = x1 - CloudExpand
  X2 = X2 + CloudExpand
  y1 = y1 - CloudExpand
  y2 = y2 + CloudExpand
 End If
 With Land.DayFX.Layers(Layer)
   .Texture = CloudTexture.GetTexIndex
   .CVertex(1) = Vertex2(x1, CloudHeight, y1, 0, -1, 0, 0, 0, 0, 0)
   .CVertex(2) = Vertex2(X2, CloudHeight, y1, 0, -1, 0, TilingX, 0, TilingX, 0)
   .CVertex(3) = Vertex2(x1, CloudHeight, y2, 0, -1, 0, 0, TilingY, 0, TilingY)
   .CVertex(4) = Vertex2(X2, CloudHeight, y2, 0, -1, 0, TilingX, TilingY, TilingX, TilingY)
   .TilingX = TilingX
   .TilingZ = TilingY
   .VelocityX = 1
   .VelocityZ = 1
 End With
Land.DayFX.CloudFlags = CloudFlags

  'init a new material :
   Land.DayFX.Layers(Layer).Material = 0
End Sub
Sub InitLensFlare(Count As Integer)
  '##BD This method creates the lens flare for this lanscape. But you need to set the texture and the lens flare position with the SetLensFlare method. Note that you have to init the sun if you want to use this effect.
  '##PD count Number of lens surfaces that will be drawn
   Dim i As Integer
   ReDim LensFlares(Count)
   NumLensFlare = Count
   
   If Count <> 0 Then
     For i = 1 To NumLensFlare
       With LensFlares(i)
         .Position = i * 20
         .Size = 10
         .Texture = 0
         CreateVertexFromLens i, .Size, RGBA(0.8, 0.8, 0.8, 1), RGBA(1, 1, 1, 1)
       End With
     Next i
   End If
   
End Sub
Sub InitRain(density As Single, RainTexture As Texture8)
'##BD Init a rain billboard system with the specified texture.

'##PD Density Rain particles count.
'##PD RainTexture Rain (or snow) texture.
    Dim NbParticles As Long, i As Long
    NbParticles = density * 10
    WhetherBS.CreateBillboardSystem CInt(NbParticles), 0, 0.3, StartPos, 0, RainTexture
    WhetherBS.SetGravity 0, 0
    WhetherBS.SetParticleSpeed 0.008
    WhetherBS.SetGeneratorSpeed 20
    WhetherBS.SetPraticleAutoGenerateMode True, 1, 1, 1, 1, 4, 0, -1, 0, 0.1, 0.1, 0.1
    WhetherBS.SetAlphaBlendingMode TV_CHANGE_NO, D3DBLEND_ONE, D3DBLEND_ONE
    Land.DayFX.LandscapeRain = True
End Sub

Sub InitSun(SunTexture As Texture8, Position As D3DVECTOR, Optional SunSize As Single = 1)
'##BD Create a sun with the specified parameters. The sun is a billboard that is always at the same position.

'##PD SunTexture Texture applied on the sun billboard.
'##PD Position Sun position in the sky.
'##PD SunSize Billboard face size x100

  Land.DayFX.LandscapeSun = True
  Land.DayFX.SunVertex(1) = Vertex2(0, -200 * SunSize, -200 * SunSize, 0, 0, -1, 0, 0, 0, 0)
  Land.DayFX.SunVertex(2) = Vertex2(0, -200 * SunSize, 200 * SunSize, 0, 0, -1, 1, 0, 1, 0)
  Land.DayFX.SunVertex(3) = Vertex2(0, 200 * SunSize, -200 * SunSize, 0, 0, -1, 0, 1, 0, 1)
  Land.DayFX.SunVertex(4) = Vertex2(0, 200 * SunSize, 200 * SunSize, 0, 0, -1, 1, 1, 1, 1)
  'init a new material :
  Dim MF As New MaterialFactory8
  Land.DayFX.SunMaterial = MF.CreateMaterialQuick(2, 1.5, 0, 1, "Init Sun")
  Land.DayFX.sunposition = Position
  Land.DayFX.SunTexture = SunTexture.GetTexIndex

End Sub



Public Sub LoadDynTexture(Filename As String)
   '##BD Load the dynamic textures in the landscape
   '##PD Filename Should be ####### (not .Bmp)
   Dim i As Long
   For i = 0 To Land.NbTerrain - 1
      LocTexFactory.LoadTexture Filename + CStr(i + 1) + ".bmp", "DynTex"
   Next i
   
End Sub

Friend Function MousePicking(vi As D3DVECTOR, vf As D3DVECTOR) As CollisionResult8
    Dim dest As D3DVECTOR, Start As D3DVECTOR
    Dim Dest2 As D3DVECTOR
    Dim o As Long, V As Long, i As Long
    Start = vi

    dest = VNormalize(VSubtract(vf, vi))
    Dim x As Single, z As Single, PosX As Single, PosZ As Single
    Dim xl As Long, yl As Long, V1 As Long, V2 As Long, v3 As Long, v4 As Long, v5 As Long, v6 As Long
    Dim t As Single, T1 As Single, g As Integer, g1 As Integer
       Set MousePicking = New CollisionResult8
   For o = 0 To PrecisionMousePicking \ 10
       Start = VAdd(Start, VScale(dest, 10))
       Dest2 = VAdd(Start, VScale(dest, 10))
       x = Dest2.x
       z = Dest2.z
     '  Debug.Print x, z
    For i = 1 To Land.NbTerrain
      If Land.Terrain(i).Position.x < x And Land.Terrain(i).Position.z < z _
        And Land.Terrain(i).Position.x + 256 > x And Land.Terrain(i).Position.z + 256 > z Then
    
        PosX = Int((x - Land.Terrain(i).Position.x) / Land.Terrain(i).Precision)
        PosZ = Int((z - Land.Terrain(i).Position.z) / Land.Terrain(i).Precision)
        
        With Land.Terrain(i)
           xl = PosX
           yl = PosZ
               If xl >= 0 And xl < .width - 1 And yl >= 0 And yl < .height - 1 Then
                 V = .width * yl + xl
                 V1 = V
                 V2 = V + 1
                 v3 = V + .width
                 v4 = V + 1
                 v5 = V + .width
                 v6 = V + .width + 1
                 
                 'g = RayTri(Ver(.Vertex(v1)), Ver(.Vertex(v2)), Ver(.Vertex(v3)), dest, VSubtract(Start, Land.Terrain(i).Position), T, 0, 0, True)
                 'g1 = RayTri(Ver(.Vertex(v6)), Ver(.Vertex(v5)), Ver(.Vertex(v4)), dest, VSubtract(Start, Land.Terrain(i).Position), t1, 0, 0, True)
                 
                 g = Ray_Tri(VSubtract(Start, Land.Terrain(i).Position), dest, Ver(.Vertex(V1)), Ver(.Vertex(V2)), Ver(.Vertex(v3)), t, 0, 0, True)
                 g1 = Ray_Tri(VSubtract(Start, Land.Terrain(i).Position), dest, Ver(.Vertex(v6)), Ver(.Vertex(v5)), Ver(.Vertex(v4)), T1, 0, 0, True)
                 
                 
                 If g <> 0 Then
'                  AddLog "tete"
                   CollisionImpact = VAdd(CollisionImpact, Land.Terrain(i).Position)
                   MousePicking.SetCollisionProperties True, t, 0, 0, CollisionNormal, 0, VAdd(CollisionImpact, Land.Terrain(i).Position), Land.Terrain(i).TextureI, CInt(i)
                   Exit Function
                 End If
                 If g1 <> 0 Then
 '                  AddLog "Petet"
                   CollisionImpact = VAdd(CollisionImpact, Land.Terrain(i).Position)
                   MousePicking.SetCollisionProperties True, t, 0, 0, CollisionNormal, 0, VAdd(CollisionImpact, Land.Terrain(i).Position), Land.Terrain(i).TextureI, CInt(i)
                   Exit Function
                 End If
               End If
        End With
        
      End If
    Next i
   Next o
  
End Function

Public Sub RenderLensFlare()
  '##BD Call this method when you have finished to render your scene.
  
  ' Thanks for Gary Simmons
  '
  
  If Land.DayFX.LandscapeSun = True Then
   'compute the angle between the sun and the look at
   Dim vDir As D3DVECTOR, vSun As D3DVECTOR
   Dim Ang As Single, InvMat As D3DMATRIX
   Dim det As Single, i As Long
   Dim Lookat As D3DVECTOR
   Dim nowpos As D3DMATRIX
   vSun = VNormalize(Land.DayFX.sunposition)
   vDir = VNormalize(VSubtract(EndPos, StartPos))
   Ang = D3DXVec3Dot(vSun, vDir)

   If Ang > 0.4 Then
     Device.SetRenderState D3DRS_ZWRITEENABLE, 0
     Device.SetRenderState D3DRS_ZFUNC, D3DCMP_ALWAYS
     
     Device.SetRenderState D3DRS_LIGHTING, 0
     Device.SetRenderState D3DRS_ALPHABLENDENABLE, 1
     Device.SetRenderState D3DRS_SRCBLEND, D3DBLEND_SRCCOLOR
     Device.SetRenderState D3DRS_DESTBLEND, D3DBLEND_ONE
     Device.SetTextureStageState 0, D3DTSS_ALPHAOP, D3DTOP_SELECTARG1
     Device.SetTextureStageState 0, D3DTSS_ALPHAARG1, D3DTA_TEXTURE
     D3DXMatrixInverse InvMat, det, ViewMatrix
     Device.SetVertexShader TV_LVERTEX
     For i = 1 To NumLensFlare
      With LensFlares(i)
         D3DXMatrixIdentity nowpos
         D3DXMatrixTranslation nowpos, 0, 0, 15
         D3DXMatrixMultiply nowpos, nowpos, InvMat
         Lookat = VSubtract(VAdd(Land.DayFX.sunposition, StartPos), Vector3(nowpos.m41, nowpos.m42, nowpos.m43))
        D3DXVec3Normalize Lookat, Lookat
         nowpos.m41 = nowpos.m41 + (Lookat.x * .Position)
         nowpos.m42 = nowpos.m42 + (Lookat.y * .Position)
         nowpos.m43 = nowpos.m43 + (Lookat.z * .Position)
         
         If .Texture > 0 Then
           Device.SetTexture 0, Textures(.Texture).TexSurf
         Else
           Device.SetTexture 0, Nothing
         End If
         Device.SetTransform D3DTS_WORLD, nowpos
         Device.DrawPrimitiveUP D3DPT_TRIANGLESTRIP, 2, .Vertex(0), Len(.Vertex(0))
      End With
     
     Next i
   End If
  End If
  Device.SetRenderState D3DRS_ZFUNC, D3DCMP_LESSEQUAL
  Device.SetRenderState D3DRS_ZWRITEENABLE, 1

End Sub
Public Sub SaveDynTexture(Filename As String)
 '##BD Save the dynamic textures. The textures will be saved as BMP.
 '##PD filename Filename WITHOUT Extension (no BMP).
 Dim i As Long
 For i = 1 To Land.NbTerrain
   TexSave Filename + CStr(i) + ".bmp", Textures(Land.Terrain(i).TextureI).TexSurf
 Next i
End Sub

Sub SaveLandscapeToTVO()

End Sub

Sub SetCloudTexture(Texture As Texture8, Optional Layer As Integer = -1)
  '##BD Changes the texture of a cloud layer (or several cloud layers)
  '##PD Texture Texture class to apply
  '##PD Layer Layer on which the texture must be applied
  Dim i As Long
  For i = 1 To UBound(Land.DayFX.Layers)
    If Layer = i Or Layer = -1 Then
     Land.DayFX.Layers(i).Texture = Texture.GetTexIndex
    End If
  Next i
End Sub
Sub SetCloudMaterial(MaterialIndex As Integer, Optional Layer As Integer = -1)
  '##BD Changes the material of a cloud layer (or several cloud layers)
  '##PD MaterialIndex Material to apply
  '##PD Layer Layer on which the material must be applied
  Dim i As Long
  For i = 1 To UBound(Land.DayFX.Layers)
    If Layer = i Or Layer = -1 Then
     Land.DayFX.Layers(i).Material = MaterialIndex
    End If
  Next i
End Sub

Sub SetCloudVelocity(Layer As Integer, VelocX As Single, VelocZ As Single)
   With Land.DayFX
     .Layers(Layer).VelocityX = VelocX
     .Layers(Layer).VelocityZ = VelocZ
   End With
End Sub

Public Sub SetCustomLightMap(lightmap As Texture8)
  If lightmap Is Nothing Then Land.ShadowMap = 0 Else Land.ShadowMap = lightmap.GetTexIndex
End Sub

Public Sub SetDetailTexture(Texture As Texture8)
  '##BD Set the current detail texture for the landscape. This detail texture is a second texture that is applied on the terrain. Useful if you use the GenerateTexture method for a very big terrain. HOWEVER, this feature works only on MultiTexturing-featured cards.
   If Texture Is Nothing Then Land.DetailTexture = 0 Else Land.DetailTexture = Texture.GetTexIndex
End Sub

Sub SetLandscapeMode(Mode As CONST_TV_LANDSCAPEMODE)
  Land.LandscapeMode = Mode
  Dim a As Long, i As Long, Pointer As Long
  If Mode = TV_LANDMODE_ADVANCEDLAND Then
       For i = 1 To Land.NbTerrain
          Pointer = Land.Terrain(i).Mesh.LockAttributeBuffer(0)
          DXCopyMemory ByVal Pointer, Land.Terrain(i).AttributeTable(0), UBound(Land.Terrain(i).AttributeTable) * 4#
          Land.Terrain(i).Mesh.UnlockAttributeBuffer
     Next i
  Else
     For i = 1 To Land.NbTerrain
        For a = 0 To UBound(Land.Terrain(i).AttributeTable)
         Land.Terrain(i).AttributeTable(a) = 0
        Next a
        Pointer = Land.Terrain(i).Mesh.LockAttributeBuffer(0)
        DXCopyMemory ByVal Pointer, Land.Terrain(i).AttributeTable(0), UBound(Land.Terrain(i).AttributeTable) * 4#
        Land.Terrain(i).Mesh.UnlockAttributeBuffer
      Next i
  End If
End Sub

Public Sub SetLensFlare(Index As Integer, Size As Single, Texture As Texture8, Position As Single, NormalColor As Long, HighLightColor As Long)
   With LensFlares(Index)
       .Position = Position
       .Size = Size
       .Texture = Texture.GetTexIndex
       CreateVertexFromLens Index, .Size, NormalColor, HighLightColor
   End With
End Sub
Sub SetWaterAltitude(Altitude As Single)
'##BD Defines the water plane altitude.

'##PD Altitude Water altitude on the y-axis.

 Land.Water.Altitude = Altitude
 Dim i As Long
 For i = 1 To 4
  Land.Water.Vertex(i).y = Altitude
 Next i
  Land.Water.Plane.a = 0
  Land.Water.Plane.b = 1
  Land.Water.Plane.C = 0
  Land.Water.Plane.d = -Altitude
  
 For i = 1 To Land.NbTerrain

  
  With Land.Terrain(i)
   D3DXMatrixReflect .RefMatrix, Land.Water.Plane
   .RefMatrix.m41 = .Position.x
   '.RefMatrix.m42 = Altitude
   .RefMatrix.m43 = .Position.z
   End With
  Next i
  
  
End Sub


Sub SetWaterEffect(alpha As Boolean, Optional AlphaFactor As Single = 0.4, Optional Animated As Boolean = False, Optional SrcBlend As CONST_D3DBLEND = D3DBLEND_SRCALPHA, Optional DestBlend As CONST_D3DBLEND = D3DBLEND_ONE, Optional Reflected As Boolean)
'##BD Decide if the water is animated, transparent.

'##PD Alpha Enable/Disable alphablending (transparent water)
'##PD AlphaFactor Transparency factor 0-1
'##PD Animated Enable/Disable water moves.
'##PD SrcBlend Alpha blending parameters (advanced users only).
'##PD DestBlend Alpha blending parameters (advanced users only).

 With Land.Water
    .AlphaBlended = alpha
    .Animated = Animated
    .AlphaFactor = AlphaFactor
    .SrcBlend = SrcBlend
    .DestBlend = DestBlend
    .Reflected = Reflected
    Dim i As Long
    For i = 1 To 4
        .Vertex(i).color = RGBA(1, 1, 1, AlphaFactor)
    Next i
    If .Altitude = 0 Then
     SetWaterAltitude 0
    End If
     
End With
End Sub

Sub SetWaterEnable(OnOff As Boolean)
'##BD Enable/Disable the water.

 'big fixed
 Land.Water.Enabled = OnOff
End Sub

Sub SetWaterTexture(Texture As Texture8)
'##BD Set the water texture. You can change the texture coordinates with the SetWaterTextureScale method.

'##PD Texture A texture class will be applied on the water plane.

    Land.Water.Texture = Texture.GetTexIndex
End Sub


Sub SetWaterTextureScale(ScaleTexture As Single)
'##BD Defines how many time the texture will be drawn on the water plane. _
(1 : the water textures covers the entire water plane 2 : the water texture is drawn 4 times on the water planes...) _
<b><i>Note:</b>  You can 't call this method after having set the animated water flag.</i>

'##PD ScaleTexture Scale factor for texture coordinates.

  If Land.Water.Animated = False Then
  Dim i As Long
  For i = 1 To 4
   Land.Water.Vertex(i).tu1 = Sgn(Land.Water.Vertex(i).tu1) * ScaleTexture
   Land.Water.Vertex(i).tv1 = Sgn(Land.Water.Vertex(i).tv1) * ScaleTexture
  Next i
 
  End If
  Land.Water.TextureScale = ScaleTexture
End Sub
Public Sub DeleteAll()
  Dim i As Long
 AddLog "LANDSCAPE UNLOAD : Delete All landscape meshes"
  For i = 1 To Land.NbTerrain
     If Not Land.Terrain(i).Adj Is Nothing Then Set Land.Terrain(i).Adj = Nothing
     If Not Land.Terrain(i).Prog Is Nothing Then Set Land.Terrain(i).Prog = Nothing
     If Not Land.Terrain(i).Mesh Is Nothing Then Set Land.Terrain(i).Mesh = Nothing
  Next i
  AddLog "LANDSCAPE UNLOAD : End of Landscape unloading "
 ' ReDim Land.Terrain(0)
  Land.NbTerrain = 0
End Sub

Public Sub GenerateHugeTerrain(heightmap As String, Precision As CONST_TV_LANDSCAPE_PRECISION, width As Long, height As Long, PosX As Single, PosZ As Single, Optional AffineTerrain As Boolean = False)
  On Error GoTo a
  Dim x As Long, y As Long, TStart As Long
  IntForm.Terrain.Picture = LoadPicture("")
  TStart = Land.NbTerrain + 1
  AddLog "LANDSCAPE CREATOR : Generate huge terrain"
  ErrStr = "GenerateHugeTerrain"
  If DisplayConsole = True Then
   ClearScreen
   LocalScreen.DrawFilledBox 5, 5, 300, 200, RGBA(0, 0.2, 0, 1), False
   LocalScreen.DrawBox 5, 5, 300, 200, RGBA(0, 1, 0, 1)
   LocalScreen.DrawText "TrueVision 8 Huge Terrain generator", 10, 10, RGBA(0, 1, 0, 1)
   FlipToScreen
  End If
  
  For x = 0 To width - 1
   For y = 0 To height - 1
     If DisplayConsole = True Then
     LocalScreen.DrawFilledBox 10, 60, 200, 80, RGBA(0, 0.2, 0, 1)
     LocalScreen.DrawText "Create (" + CStr(x) + "," + CStr(y) + ") terrain. (" + CStr(Int((x * width + y) / (width * height) * 100)) + "%)", 15, 70, RGBA(1, 1, 0, 1)
     FlipToScreen
     End If
     ErrStr = "Create : Terrain " + CStr(x) + " " + CStr(y)
     GenerateTerrainEx heightmap, Precision, PosX + x * 256, PosZ + y * 256, x / width, y / height, 1 / width, 1 / height, "", False, AffineTerrain
   Next y
  Next x
  
  'Release heightmaps
  IntForm.Terrain.Picture = LoadPicture("")
  
  
  If AffineTerrain = True Then
  'Affine the sides of the terrains if requestred

  
  Dim ave As Single, t As Long, y1 As Long, y2 As Long
  Dim t3 As Single, t4 As Single
  With Land
  Dim V As D3DVERTEX2
  On Error Resume Next
  For x = 0 To width - 1
     For y = 0 To height - 1
       t = y * width + x + TStart
       
       'right side
       If y < height - 1 Then
        For y1 = 0 To .Terrain(t).height
           t3 = .Terrain(t).Vertex(y1 * .Terrain(t).width + .Terrain(t).width - 1).y
           t4 = .Terrain(t + width).Vertex(y1 * .Terrain(t).width).y
           If t3 <> -1 And t4 <> -1 Then
              ave = (t3 + t4) / 2
             .Terrain(t).Vertex(y1 * .Terrain(t).width + .Terrain(t).width - 1).y = ave
             .Terrain(t + width).Vertex(y1 * .Terrain(t).width).y = ave
           End If
        Next y1
       End If
       'bottom side
       If x < width - 1 Then
        For y1 = 0 To .Terrain(t).width - 2
           t3 = .Terrain(t).Vertex(y1 + .Terrain(t).width * (.Terrain(t).height - 1)).y
           t4 = .Terrain(t + 1).Vertex(y1).y
           If t3 <> -1 And t4 <> -1 Then
             ave = (t3 + t4) / 2
             .Terrain(t).Vertex(y1 + .Terrain(t).width * (.Terrain(t).height - 1)).y = ave
             .Terrain(t + 1).Vertex(y1).y = ave
           End If
        Next y1
       End If
     
       'and the corners !
       If x < height - 1 And x < width - 1 Then
          ave = .Terrain(t).Vertex(.Terrain(t).width * .Terrain(t).height - 1).y
          ave = ave + .Terrain(t + 1 + width).Vertex(0).y
          ave = ave + .Terrain(t + width).Vertex(.Terrain(t).width * (.Terrain(t).height - 1)).y
          ave = ave + .Terrain(t + 1).Vertex(.Terrain(t).width - 1).y
          ave = ave / 4
          .Terrain(t).Vertex(.Terrain(t).width * .Terrain(t).height - 1).y = ave
           .Terrain(t + 1 + width).Vertex(0).y = ave
           .Terrain(t + width).Vertex(.Terrain(t).width * (.Terrain(t).height - 1)).y = ave
           .Terrain(t + 1).Vertex(.Terrain(t).width - 1).y = ave
       End If
     Next y
  Next x
  
 On Error GoTo a
  ErrStr = "Affine : Remplace vertexes"
  For x = 0 To width - 1
    For y = 0 To height - 1
       D3DVertexBuffer8SetData .Terrain(y * width + x + TStart).Mesh.GetVertexBuffer, 0, 1# * .Terrain(y * width + x + TStart).NVertex * 40#, 0, .Terrain(y * width + x + TStart).Vertex(0)
    Next y
  Next x
  
  End With
 End If
 Exit Sub
a:
 AddLog "LANDSCAPE HUGE TERRAIN GENERATOR : Error in " + CStr(ErrStr) + ":" + CStr(Err.Number) + " /" + CStr(D3DX.GetErrorString(Err.Number)) + " " + Err.Description
 Resume Next
End Sub

Public Sub GenerateTerrain(heightmap As String, Precision As CONST_TV_LANDSCAPE_PRECISION, PositionX As Single, PositionZ As Single, Optional Name As String = "")
  GenerateTerrainEx heightmap, Precision, PositionX, PositionZ, 0, 0, 1, 1, Name
End Sub

Private Sub GenerateTerrainEx(heightmap As String, Precision As CONST_TV_LANDSCAPE_PRECISION, PositionX As Single, PositionZ As Single, SrcPosX As Single, SrcPosY As Single, SingWidth As Single, SingHeight As Single, Optional Name As String, Optional LoadH As Boolean = True, Optional AffineTerrain As Boolean = False, Optional NoHeight As Boolean)
  'Create a terrain from a heightmap
  Dim w As Long, h As Long, MinY As Single
  
  On Error GoTo ErrHandler
  AddLog "LANDSCAPE : Generate Terrain from " + CStr(heightmap)
  Dim Ret As D3DXIMAGE_INFO, NbVertex As Long
  Dim Surf As Direct3DSurface8, V As Long
  Dim Vert() As D3DVERTEX2  'have to use Vertex2 for lightmapping
  Dim vy() As Single
  'Dim Indices() As Integer
  

  
  
  If HeightMapLoaded = 0 Or LoadH = True Then
      AddLog "LANDSCAPE : Load Heightmap"
      HeightMapLoaded = 1
    TestPAKFile heightmap
    IntForm.Terrain.Picture = LoadPicture(heightmap)
    DeletePAKTemp heightmap
  End If
  w = IntForm.Terrain.width
  h = IntForm.Terrain.height
  
  AddLog "LANDSCAPE : Create vertexes"
  
  'Create the terrain from the image
  'Read only the red channel.
  'So if the heightmap is in black & white, it works.
  
  Land.NbTerrain = Land.NbTerrain + 1
  NbVertex = (256# / Precision + 1) ^ 2
  ReDim Vert(NbVertex) As D3DVERTEX2
  Dim x As Long, y As Long, xl As Long, yl As Long
  ReDim Preserve Land.Terrain(Land.NbTerrain)
  ReDim Preserve vy(NbVertex) As Single
   
  Land.Terrain(Land.NbTerrain).Precision = Precision
  
  
  AddLog "LANDSCAPE : Vertex parsing"
  
  MinY = -5
  
  Dim hdc As Long
  Dim GP As Long
  hdc = IntForm.Terrain.hdc
  
  With Land.Terrain(Land.NbTerrain)
      Set .Mesh = D3DX.CreateMeshFVF(NbVertex * 2, NbVertex, D3DXMESH_MANAGED Or D3DXMESH_WRITEONLY, TV_VERTEX2, Device)
      ReDim Preserve TerrainName(Land.NbTerrain)
      ReDim Preserve .Vertex(NbVertex)
      .Name = IIf(Name = "", "Terrain" + CStr(Land.NbTerrain), Name)
      TerrainName(Land.NbTerrain) = .Name

      .width = 256# / Precision + 1
      .height = 256# / Precision + 1
      .Position = Vector(PositionX, 0, PositionZ)
      
      For y = 0 To .height - 1
       For x = 0 To .width - 1
          V = y * .width + x
          xl = x / (.width - 1) * w * SingWidth + SrcPosX * w
          yl = y / (.height - 1) * h * SingHeight + SrcPosY * h
          Vert(V).x = x * Precision
          Vert(V).z = y * Precision
          If NoHeight = False Then
          GP = GetPixel(hdc, xl, yl)
          If GP = 64512 Then
            vy(V) = -1
          Else
            vy(V) = (GP And &HFF) * Land.YFactor
          End If
          End If
          'If Vert(V).y > MinY Then MinY = Vert(V).y
          Vert(V).ny = 1
          Vert(V).tu1 = (x / (.width - 1))
          Vert(V).tv1 = (y / (.height - 1))
          Vert(V).tu2 = Vert(V).tu2
          Vert(V).tv2 = Vert(V).tv2
          .Vertex(V) = Vert(V)
         Next x
    Next y


  'TV Pass 6 times and normalize everything
    Dim ave As Single, a As Long, b As Long

  If AffineTerrain = True Then
    For y = 0 To .height - 1
     For x = 0 To .width - 1
        If vy((y * .height + x)) <> -1 Then
         ave = 0
         b = 0
         For xl = -1 To 1
          For yl = -1 To 1
           If xl + x >= 0 And yl + y >= 0 And xl + x <= .width - 2 And yl + y <= .height - 2 Then
             If vy((y + yl) * .height + x + xl) <> -1 Then
              ave = ave + vy((y + yl) * .height + x + xl)
             Else
             End If
             b = b + 1
           End If
          Next yl
         Next xl
         Vert(y * .height + x).y = ave / b
        Else

         Vert(y * .height + x).y = -1
        End If
        
     Next x
    Next y
   Else
    For y = 0 To .height - 1
     For x = 0 To .width - 1
         Vert(y * .height + x).y = vy(y * .height + x)
     Next x
    Next y
   End If
   'Release the picture box
   If LoadH = True Then
   AddLog "LANDSCAPE  : HeightMap releasing..."
   IntForm.Terrain.Picture = LoadPicture("")
   HeightMapLoaded = 0
   End If
   
    Dim i As Long
    i = 0
    
    Dim Nind As Long
    Nind = NbVertex * 6#
    ReDim Indices(Nind) As Integer
    For y = 0 To .height - 2
     For x = 0 To .width - 2
      
        V = y * .width + x
       If Vert(V).y <> -1 And Vert(V + 1).y <> -1 And Vert(V + .width).y <> -1 And Vert(V + .width + 1).y <> -1 Then
        Indices(i) = V
        Indices(i + 1) = V + 1
        Indices(i + 2) = V + .width
        Indices(i + 5) = V + 1
        Indices(i + 4) = V + .width
        Indices(i + 3) = V + .width + 1
        i = i + 6
       End If
     Next x
    Next y
  
    .NIndices = i
    .NVertex = NbVertex

    .BoxMax = Vector(256, MinY, 256)
    .BoxMin = Vector(0, 0, 0)
    
    D3DVertexBuffer8SetData .Mesh.GetVertexBuffer, 0, NbVertex * 40#, 0, Vert(0)
    D3DIndexBuffer8SetData .Mesh.GetIndexBuffer, 0, .NIndices * 2#, 0, Indices(0)
    
    

    D3DXMatrixIdentity .Matrix
    D3DXMatrixTranslation .Matrix, .Position.x, .Position.y, .Position.z
    
    D3DX.ComputeBoundingSphereFromMesh .Mesh, .Sphere, .Radius
     
    ReDim .Vertex(UBound(Vert))
    ReDim .AttributeTable((.width - 1) * (.height - 1) * 2)
    For i = 0 To UBound(.AttributeTable)
      .AttributeTable(i) = 1
    Next i
    
    
    'for lightning
    D3DX.ComputeNormals .Mesh
    
    'LOD Precomputing
  If Land.Mode <> 0 Then
    Set .Adj = D3DX.CreateBuffer(12# * .Mesh.GetNumFaces)
    .Mesh.GenerateAdjacency 0, ByVal .Adj.GetBufferPointer
    If D3DX.ValidMesh(.Mesh, ByVal .Adj.GetBufferPointer) <> 2 Then
      Set .Prog = D3DX.GeneratePMesh(.Mesh, ByVal .Adj.GetBufferPointer, ByVal 0, ByVal 0, 1, D3DXMESHSIMP_FACE)
    End If
End If
    'AddLog "Sphere computed : Center (" + CStr(.Sphere.X) + "," + CStr(.Sphere.y) + "," + CStr(.Sphere.z) + ") Radius :" + CStr(.Radius)
    
    
    .Vertex = Vert
  End With
  AddLog "LANDSCAPE : End of Landscape creation"
  ComputeWater
  Exit Sub

  
ErrHandler:
  AddLog "GENERATE TERRAIN : " + CStr(Err.Number) + " " + Err.Description
  Resume Next
End Sub
Friend Sub SetDesc(Desc As LandscapeType)
   Land = Desc
End Sub

Public Function GetHeight(x As Single, z As Single) As Single

    Dim PosX As Long, PosZ As Long, t As Single, T1 As Single, V As Long
    Dim xl As Long, yl As Long, V1 As Long, V2 As Long, v3 As Long, v4 As Long, v5 As Long
    Dim v6 As Long, i As Long, g As Integer, g1 As Integer
    
    On Error Resume Next
    For i = 1 To Land.NbTerrain
      If Land.Terrain(i).Position.x <= x And Land.Terrain(i).Position.z <= z _
        And Land.Terrain(i).Position.x + 256 >= x And Land.Terrain(i).Position.z + 256 >= z Then
    
        PosX = Int((x - Land.Terrain(i).Position.x) / Land.Terrain(i).Precision)
        PosZ = Int((z - Land.Terrain(i).Position.z) / Land.Terrain(i).Precision)
        
        With Land.Terrain(i)
           For xl = PosX - 1 To PosX + 1
            For yl = PosZ - 1 To PosZ + 1
               If xl >= 0 And xl < .width And yl >= 0 And yl < .height Then
                 V = .width * yl + xl
                 V1 = V
                 V2 = V + 1
                 v3 = V + .width
                 v4 = V + 1
                 v5 = V + .width
                 v6 = V + .width + 1
                 
                 g = RayTri(Ver(.Vertex(V1)), Ver(.Vertex(V2)), Ver(.Vertex(v3)), Vector(0, 1, 0), Vector(x - .Position.x, 0, z - .Position.z), t, 0, 0, True)
                 g1 = RayTri(Ver(.Vertex(v6)), Ver(.Vertex(v5)), Ver(.Vertex(v4)), Vector(0, 1, 0), Vector(x - .Position.x, 0, z - .Position.z), T1, 0, 0, True)
                 If g <> 0 Then
                   GetHeight = t
                   Exit Function
                 End If
                 If g1 <> 0 Then
                   GetHeight = T1
                   Exit Function
                 End If
               End If
            Next yl
           Next xl
        End With
        
      End If
    Next i
    
    Exit Function
End Function
Public Sub Render(Optional WaterFog As Boolean = True)
 On Error GoTo TreatError:

   Dim V As D3DVERTEX2, i As Long, a As D3DMATRIX, g As Long
   Dim V2 As D3DLVERTEX2
 With Device
   .SetVertexShader TV_VERTEX2
    
    .SetRenderState D3DRS_CULLMODE, D3DCULL_CW
    .SetTextureStageState 0, D3DTSS_TEXCOORDINDEX, 0
    .SetRenderState D3DRS_ALPHABLENDENABLE, 0
    .SetRenderState D3DRS_LIGHTING, 1
    .SetRenderState D3DRS_ALPHATESTENABLE, 0
    .SetRenderState D3DRS_ZENABLE, 1
    .SetRenderState D3DRS_ZWRITEENABLE, 1
   End With
   Dim j As Integer
 If Land.DetailTexture > 0 Then ApplyDetailTexture
 If Land.ShadowMap > 0 Then ApplyShadowTexture
 
 If Land.Water.Reflected = True And Land.Water.Enabled = True Then
      GLO.SetUserClipPlane True, 0, Land.Water.Plane.a, Land.Water.Plane.b, Land.Water.Plane.C, Land.Water.Plane.d
 End If
 
 For i = 1 To Land.NbTerrain
  
  With Land.Terrain(i)
       Device.SetTransform D3DTS_WORLD, .Matrix
       
   If CheckSphere(.Sphere, .Radius) = 1 Then
     If Land.LandscapeMode = 1 Then
   
      If .TextureI > 0 Then
        Device.SetTexture 0, Textures(.TextureI).TexSurf
      Else
        Device.SetTexture 0, Nothing
      End If
      
      If .MaterialI > 0 Then
        Device.SetMaterial Materials(.MaterialI).Mat
      Else
        Device.SetMaterial Materials(0).Mat
     End If
     
      .Mesh.DrawSubset 0
     

    Else
      If .MaterialI > 0 Then
        Device.SetMaterial Materials(.MaterialI).Mat
      Else
        Device.SetMaterial Materials(0).Mat
     End If
      For g = 1 To Land.TexUsedNumber
       If Land.TexUsed(g) > 0 Then
          Device.SetTexture 0, Textures(Land.TexUsed(g)).TexSurf
       Else
          Device.SetTexture 0, Nothing
       End If
       .Mesh.DrawSubset g
    Next g
    End If

   End If
  
  End With
 Next i
 
 If Land.Water.Reflected = True And Land.Water.Enabled = True Then
    GLO.SetUserClipPlane True, 0, Land.Water.Plane.a, -Land.Water.Plane.b, Land.Water.Plane.C, -Land.Water.Plane.d
 
 'Draw reflective
 For i = 1 To Land.NbTerrain
  
  With Land.Terrain(i)
      Device.SetRenderState D3DRS_CULLMODE, D3DCULL_CCW
       Device.SetTransform D3DTS_WORLD, .RefMatrix
  
   If CheckSphere(.Sphere, .Radius) = 1 Then
   
      If .TextureI > 0 Then
        Device.SetTexture 0, Textures(.TextureI).TexSurf
      Else
        Device.SetTexture 0, Nothing
      End If
      
      If .MaterialI > 0 Then
        Device.SetMaterial Materials(.MaterialI).Mat
      Else
        Device.SetMaterial Materials(0).Mat
     End If
      .Mesh.DrawSubset 0
  End If
  
  End With
 Next i
 
 
 
   GLO.SetUserClipPlane False, 0, Land.Water.Plane.a, Land.Water.Plane.b, Land.Water.Plane.C, Land.Water.Plane.d
End If

If Land.DetailTexture > 0 Then StopDetailTexture
'If Land.ShadowTexture > 0 Then StopShadowTexture
With Device

      .SetRenderState D3DRS_CULLMODE, D3DCULL_NONE
  If Land.DayFX.LandscapeSun = True Then
   .SetRenderState D3DRS_FOGENABLE, 0
   .SetRenderState D3DRS_ZWRITEENABLE, False
   .SetRenderState D3DRS_LIGHTING, True
   .SetRenderState D3DRS_ALPHABLENDENABLE, True
   .SetRenderState D3DRS_SRCBLEND, D3DBLEND_ONE
   .SetRenderState D3DRS_DESTBLEND, D3DBLEND_ONE
   .SetTexture 0, Textures(Land.DayFX.SunTexture).TexSurf
   .SetMaterial Materials(Land.DayFX.SunMaterial).Mat
   Dim b As D3DMATRIX
   D3DXMatrixIdentity b
   b = MRotate(b, 0, (GetCameraAngle - 90), 0)
   b = MTranslate(b, Land.DayFX.sunposition.x + StartPos.x, Land.DayFX.sunposition.y + StartPos.y, Land.DayFX.sunposition.z + StartPos.z)
   .SetTransform D3DTS_WORLD, b
   
   .SetVertexShader TV_VERTEX2
   .DrawPrimitiveUP D3DPT_TRIANGLESTRIP, 2, Land.DayFX.SunVertex(1), Len(V)
   .SetTransform D3DTS_WORLD, a
   .SetRenderState D3DRS_FOGENABLE, SEFogEnabled
 
 End If

  If Land.DayFX.LandscapeRain = True Then
     
   'compute the new position:
   Dim ve As D3DVECTOR
   ve = VScale(VNormalize(VSubtract(EndPos, StartPos)), 20)
   'Ve = VAdd(VScale(Ve, 5), StartPos)
   WhetherBS.MoveEmettor Vector(StartPos.x + ve.x + Rnd * 40 - 20, StartPos.y + 20, StartPos.z + ve.z + Rnd * 40 - 20)
   WhetherBS.RenderParticles
   WhetherBS.UpdateParticles TV_UPDATE_GENERATOR Or TV_UPDATE_BOTH
 End If
  'render the water
  If Land.Water.Enabled = True Then
    'Render for on water yes/no
    If WaterFog = False Then
      Dim RestoreFogWater As Boolean
      RestoreFogWater = SEFogEnabled
      SEFogEnabled = False
    End If
    'Device.SetRenderState D3DRS_ZWRITEENABLE, False
   
   D3DXMatrixIdentity a
   .SetTransform D3DTS_WORLD, a
   
   .SetRenderState D3DRS_LIGHTING, False
   
   'If Land.Water.BumpMapped = True Then
    'RenderBumpMapped
   'Else
   If Land.Water.Texture > 0 Then
    .SetTexture 0, Textures(Land.Water.Texture).TexSurf
   Else
    .SetTexture 0, Nothing
   End If
   If Land.Water.Animated = True Then
   Dim aa As Single, St As Single
   With Land.Water
   .AnimKey = .AnimKey + SystemFrame * 0.001
   aa = .AnimKey: St = .TextureScale
   'calculate Water "animation"
   .Vertex(1).tu1 = St + Cos(aa) * St / 100
   .Vertex(1).tv1 = St
   .Vertex(2).tu1 = 0 + Cos(aa) * St / 100
   .Vertex(2).tv1 = St
   .Vertex(3).tu1 = St + Cos(aa) * St / 100
   .Vertex(3).tv1 = 0
   .Vertex(4).tu1 = 0 + Cos(aa) * St / 100
   .Vertex(4).tv1 = 0
    If aa > 360 Then .AnimKey = -360
  End With
  End If
  'alpha setting
  .SetRenderState D3DRS_ALPHABLENDENABLE, IIf(Land.Water.AlphaBlended = True, 1, 0)
  .SetRenderState D3DRS_SRCBLEND, Land.Water.SrcBlend
  .SetRenderState D3DRS_DESTBLEND, Land.Water.DestBlend
  
  'water rendering
  .SetVertexShader TV_LVERTEX2

  .DrawPrimitiveUP D3DPT_TRIANGLESTRIP, 2, Land.Water.Vertex(1), Len(V2)
  'End If

  'Put the fog back to default
  SEFogEnabled = RestoreFogWater
 End If
 Dim V1 As D3DVERTEX2

  .SetRenderState D3DRS_ZWRITEENABLE, True
 'Render cloud layers :
 If Land.DayFX.LandscapeCloud = True Then
   .SetRenderState D3DRS_ZWRITEENABLE, False
   D3DXMatrixIdentity a
   .SetTransform D3DTS_WORLD, a
   .SetRenderState D3DRS_LIGHTING, True
   .SetRenderState D3DRS_ALPHABLENDENABLE, True
   .SetRenderState D3DRS_SRCBLEND, D3DBLEND_SRCALPHA
   .SetRenderState D3DRS_DESTBLEND, D3DBLEND_INVSRCALPHA
   For i = 1 To UBound(Land.DayFX.Layers)
      .SetTexture 0, Textures(Land.DayFX.Layers(i).Texture).TexSurf
      .SetMaterial Materials(Land.DayFX.Layers(i).Material).Mat
      .SetVertexShader TV_VERTEX2
     With Land.DayFX.Layers(i)
       .PosX = .PosX + .VelocityX * SystemFrame * 0.001
       .PosZ = .PosZ + .VelocityZ * SystemFrame * 0.001
       If .PosX > .TilingX - 0.01 Then .PosX = .PosX - .TilingX
       If .PosZ > .TilingZ - 0.01 Then .PosZ = .PosZ - .TilingZ
       .CVertex(1).tu1 = .PosX
       .CVertex(1).tv1 = .PosZ
       .CVertex(2).tu1 = .PosX + .TilingX
       .CVertex(2).tv1 = .PosZ
       .CVertex(3).tu1 = .PosX
       .CVertex(3).tv1 = .PosZ + .TilingZ
       .CVertex(4).tu1 = .PosX + .TilingX
       .CVertex(4).tv1 = .PosZ + .TilingZ
 
     End With
      
      .DrawPrimitiveUP D3DPT_TRIANGLESTRIP, 2, Land.DayFX.Layers(i).CVertex(1), Len(V)
   Next i
 End If
 
 .SetRenderState D3DRS_ZWRITEENABLE, True
 
 End With
 Exit Sub
TreatError:
 AddLog "LANDSCAPE ERROR :" + CStr(Err.Number) + " " + CStr(Err.Description)
 Resume Next
End Sub

Sub RenderBumpMapped()
Dim r As Single
Static g As Single
g = g + SystemFrame * 0.05
 r = 0.04
   With Land.Water.BumpMatrix
     .m11 = r * Cos(g * 9#)
     .m12 = -r * Sin(g * 9#)
     .m21 = r * Sin(g * 9#)
     .m22 = r * Cos(g * 9#)
     Dim Mat As D3DMATRIX
    Mat.m11 = 0.8: Mat.m12 = 0#: Mat.m13 = 0#
    Mat.m21 = 0#: Mat.m22 = 0.8: Mat.m23 = 0#
    Mat.m31 = 0.5: Mat.m32 = -0.5: Mat.m33 = 1#
    Mat.m41 = 0#: Mat.m42 = 0#: Mat.m43 = 0#
    Device.SetTransform D3DTS_TEXTURE1, Mat
    Device.SetTextureStageState 1, D3DTSS_TEXTURETRANSFORMFLAGS, D3DTTFF_COUNT3 Or D3DTTFF_PROJECTED
    Device.SetTextureStageState 1, D3DTSS_TEXCOORDINDEX, D3DTSS_TCI_CAMERASPACEPOSITION Or 1
    
    Call Device.SetTexture(0, Land.Water.WaterBump)
    Call Device.SetTextureStageState(0, D3DTSS_TEXCOORDINDEX, 0)
    Call Device.SetTextureStageState(0, D3DTSS_ADDRESSU, D3DTADDRESS_CLAMP)
    Call Device.SetTextureStageState(0, D3DTSS_ADDRESSV, D3DTADDRESS_CLAMP)
    Call Device.SetTextureStageState(0, D3DTSS_BUMPENVMAT00, FtoDW(.m11))
    Call Device.SetTextureStageState(0, D3DTSS_BUMPENVMAT01, FtoDW(.m12))
    Call Device.SetTextureStageState(0, D3DTSS_BUMPENVMAT10, FtoDW(.m21))
    Call Device.SetTextureStageState(0, D3DTSS_BUMPENVMAT11, FtoDW(.m22))
    Call Device.SetTextureStageState(0, D3DTSS_COLOROP, D3DTOP_BUMPENVMAP)
    Call Device.SetTextureStageState(0, D3DTSS_COLORARG1, D3DTA_TEXTURE)
    Call Device.SetTextureStageState(0, D3DTSS_COLORARG2, D3DTA_CURRENT)
    Call Device.SetTextureStageState(1, D3DTSS_COLOROP, D3DTOP_MODULATE)
    Call Device.SetTextureStageState(1, D3DTSS_COLORARG1, D3DTA_TEXTURE)
    Call Device.SetTextureStageState(1, D3DTSS_COLORARG2, D3DTA_CURRENT)
    
    Call Device.SetTexture(1, Textures(2).TexSurf)
   Device.SetRenderState D3DRS_ALPHABLENDENABLE, False
  Device.SetRenderState D3DRS_SRCBLEND, Land.Water.SrcBlend
  Device.SetRenderState D3DRS_DESTBLEND, Land.Water.DestBlend
  
  'water rendering
Dim V2 As D3DLVERTEX2
  Device.SetVertexShader TV_LVERTEX2
Device.DrawPrimitiveUP D3DPT_TRIANGLESTRIP, 2, Land.Water.Vertex(1), Len(V2)
   Call Device.SetTextureStageState(0, D3DTSS_ADDRESSU, D3DTADDRESS_WRAP)
    Call Device.SetTextureStageState(0, D3DTSS_ADDRESSV, D3DTADDRESS_WRAP)
   Call Device.SetTextureStageState(0, D3DTSS_COLOROP, D3DTOP_MODULATE)
    Call Device.SetTextureStageState(0, D3DTSS_COLORARG1, D3DTA_TEXTURE)
    Call Device.SetTextureStageState(0, D3DTSS_COLORARG2, D3DTA_DIFFUSE)
   Call Device.SetTextureStageState(1, D3DTSS_COLOROP, D3DTOP_DISABLE)
  
      End With
End Sub

Sub SetFactorY(factor As Single)
    Land.YFactor = factor
End Sub


Sub SetTexture(tex As Texture8, Optional NumTerrain As Integer = -1)
    Dim i As Long
    
    If NumTerrain = -1 Then
      For i = 1 To Land.NbTerrain
        Land.Terrain(i).TextureI = tex.GetTexIndex
      Next i
    Else
      Land.Terrain(NumTerrain).TextureI = tex.GetTexIndex
    End If
    
End Sub
Sub SetMaterial(MatIndex As Integer, Optional NumTerrain As Integer = -1)
    Dim i As Long
    
    If NumTerrain = -1 Then
      For i = 1 To Land.NbTerrain
        Land.Terrain(i).MaterialI = MatIndex
      Next i
    Else
      Land.Terrain(NumTerrain).MaterialI = MatIndex
    End If
    
End Sub

Sub SetTextureScale(tuScale As Single, tvScale As Single, Optional Terrainindex As Integer = -1)
   Dim i As Long, a As Long, V As Long, x As Long, y As Long
   For i = 1 To Land.NbTerrain
     With Land.Terrain(i)
       
       If Terrainindex = -1 Or Terrainindex = i Then
          For x = 0 To .width - 1
            For y = 0 To .height - 1
              V = .width * y + x
              .Vertex(V).tu1 = x / (.width - 1) * tuScale * 0.995 + 0.0025
              .Vertex(V).tv1 = y / (.height - 1) * tvScale * 0.995 + 0.0025
            Next y
          Next x
          D3DVertexBuffer8SetData .Mesh.GetVertexBuffer, 0, .NVertex * 40#, 0, .Vertex(0)
       End If
       
     End With
   Next i
   Land.TexWidth = tuScale
   Land.TexHeight = tvScale
End Sub
Sub SetDetailTextureScale(tuScale As Single, tvScale As Single, Optional Terrainindex As Integer = -1)
   Dim i As Long, a As Long, V As Long, x As Long, y As Long
   For i = 1 To Land.NbTerrain
     With Land.Terrain(i)
       
       If Terrainindex = -1 Or Terrainindex = i Then
          For x = 0 To .width - 1
            For y = 0 To .height - 1
              V = .width * y + x
              .Vertex(V).tu2 = x / (.width - 1) * tuScale * 0.995 + 0.0025
              .Vertex(V).tv2 = y / (.height - 1) * tvScale * 0.995 + 0.0025
            Next y
          Next x
          D3DVertexBuffer8SetData .Mesh.GetVertexBuffer, 0, .NVertex * 40#, 0, .Vertex(0)
       End If
       
     End With
   Next i
   'Land.TexWidth = tuScale
   'Land.TexHeight = tvScale
End Sub

Private Sub ApplyDetailTexture()
   'This feature works only on MultiTexturing device
   If MultiTexturing = True And Land.DetailTexture > 0 Then
     Device.SetTexture 1, Textures(Land.DetailTexture).TexSurf
     Device.SetTextureStageState 1, D3DTSS_COLOROP, D3DTOP_ADDSIGNED
     Device.SetTextureStageState 1, D3DTSS_COLORARG1, D3DTA_TEXTURE
     Device.SetTextureStageState 1, D3DTSS_COLORARG2, D3DTA_CURRENT
     Device.SetTextureStageState 1, D3DTSS_TEXCOORDINDEX, 1
   End If
End Sub
Private Sub ApplyShadowTexture()
   'This feature works only on MultiTexturing device
   Dim Stage As Long
   If MultiTexturing = True Then
    If Land.DetailTexture > 0 Then
      Stage = 2
    Else
      Stage = 1
    End If
    Device.SetTexture Stage, Textures(Land.ShadowMap).TexSurf
    Device.SetTextureStageState Stage, D3DTSS_COLOROP, D3DTOP_MODULATE
    Device.SetTextureStageState Stage, D3DTSS_COLORARG1, D3DTA_TEXTURE
    Device.SetTextureStageState Stage, D3DTSS_COLORARG2, D3DTA_CURRENT
    Device.SetTextureStageState Stage, D3DTSS_TEXCOORDINDEX, 0
   End If
End Sub

Private Sub StopDetailTexture()
  If MultiTexturing = True Then
    With Device
     .SetTexture 1, Nothing
     .SetTexture 2, Nothing
     .SetTextureStageState 2, D3DTSS_COLOROP, D3DTOP_DISABLE
     .SetTextureStageState 1, D3DTSS_COLOROP, D3DTOP_DISABLE
    End With
  End If
End Sub


Private Function Ver(V As D3DVERTEX2) As D3DVECTOR
    With Ver
      Ver.x = V.x
      Ver.y = V.y
      Ver.z = V.z
    End With
End Function

Private Sub Class_Initialize()
  Land.YFactor = 1
  ReDim Land.Terrain(0)
  Land.NbTerrain = 0
  AddLog "LANDSCAPE : Initialized"
  Set LocalLand = Me
  

    Land.Water.Altitude = 0
    Land.Water.AnimKey = 0
    Land.Water.TextureScale = 32
    Land.Water.SrcBlend = D3DBLEND_SRCALPHA
    Land.Water.DestBlend = D3DBLEND_ONE
    Land.LandscapeMode = 1
    Land.TexWidth = 1
    Land.TexHeight = 1
    ReDim Land.TexUsed(0)
    Land.TexUsedNumber = 0
End Sub


Private Sub Class_Terminate()
  DeleteAll
  AddLog "LANDSCAPE : Desallocate Landscape memory"
  Set LocalLand = Nothing
End Sub

Private Sub ComputeWater()
 Dim i As Long, x1 As Single, y1 As Single, X2 As Single, y2 As Single

 x1 = 9999
 X2 = -9999
 y1 = 9999
 y2 = -9999
 
 For i = 1 To Land.NbTerrain
    With Land.Terrain(i)
       If .Position.x < x1 Then x1 = .Position.x
       If .Position.z < y1 Then y1 = .Position.z
       If .Position.x > X2 Then X2 = .Position.x
       If .Position.z > y2 Then y2 = .Position.z
    End With
 Next i
 
 x1 = x1
 X2 = X2 + 256
 y1 = y1
 y2 = y2 + 256
 
  With Land.Water
   .Vertex(2) = LVertex2(x1, .Altitude, y1, RGBA(1, 1, 1, .AlphaFactor), 0, .TextureScale, 0, 0)
   .Vertex(1) = LVertex2(X2, .Altitude, y1, RGBA(1, 1, 1, .AlphaFactor), .TextureScale, .TextureScale, 0, 0)
   .Vertex(4) = LVertex2(x1, .Altitude, y2, RGBA(1, 1, 1, .AlphaFactor), 0, 0, 0, 0)
   .Vertex(3) = LVertex2(X2, .Altitude, y2, RGBA(1, 1, 1, .AlphaFactor), .TextureScale, 0, 0, 0)
  End With
End Sub
