VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Actor8"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True

'##CD This class allows you to load and render a MDL Half-Life Model or a MD2 Quake2 Model . It uses skeletal animation and realtime multimodels rendering (for MDL) or frames animation (MD2).
'##CD For MDL, you can also set the programmatic controller and characters can move their mouth !

'----------
'MDL Class
'---------
'
' by Sylvain
'
' 18-08-00 : It works now !!
'
' 10-08-00 : First release : Load, SetAnimation, Play, Stop
'                            SetModel

Option Explicit
Private MDLA As MDLFile
Private MD2 As MD2Type
Private MD3 As MD3Type


Private ModelType As Integer

Private ModelMesh As Integer, MeshO As Mesh8

Public Enum CONST_TV_MODEL_TYPE
 '##EN Model type
 TV_MODEL_QUAKE_MD2 = 2
 TV_MODEL_HALFLIFE_MDL = 1
 TV_MODEL_QUAKE_MD3 = 3
End Enum

Public Type MDLSequenceDesc
 '##UT Model Sequence description.
 NumFrames As Integer
 '##UM NumFrames Number of animation frames (0-based)
 FPS As Single
 '##UM FPS Frame-rate of the animation.
 Name As String
 '##UM Name Animation name
End Type

Public Type MDLSubModel
  '##UT SubModel description
  ModelName As String
  '##UM ModelName Name of the model
  NumMeshes As Integer
  '##UM NumMeshes Number of meshes in this submodels.
End Type
Public Type MDLBodyPart
  '##UT Info on bodyparts.
  NumSubModels As Integer
  '##UM NumSubModels Number of submodels
  SubModels() As MDLSubModel
  '##UM SubModels SubModels array.
  BodyPartName As String
  '##UM BodyPartName BodyPart name
End Type

Public Type MDLModelInfo
 '##UT Model sequences animation infos.
 ModelType As CONST_TV_MODEL_TYPE
 '##UM ModelType Model type
 NumSequences As Integer
 '##UM NumSequences Number of sequences in all the model files
 Sequences() As MDLSequenceDesc
 '##UM Sequences Sequences description for each animation (FPS, NumFrame, Name)
 NumBodyPart As Integer
 '##UM NumBodyPart Number of bodyparts in this MDL file
 BodyParts() As MDLBodyPart
 '##UM BodyParts Array of bodyparts info.
 NumBoneControllers As Integer
 '##UM NumBoneControllers Number of bone controllers
 MouthController As Boolean
 '##UM MouthController Is there a mouth controller ?
End Type

Private Data() As Byte
Private ActIndex As Integer

Private Sub AdvanceFrame(dt As Single)
 Dim AdFrame As Single
On Error Resume Next
  AdFrame = dt * MDLA.Seq(MDLA.Sequence).FPS / 1000 * MDLA.Speed
  MDLA.KeyFrame = MDLA.KeyFrame + AdFrame
  If MDLA.KeyFrame > MDLA.Seq(MDLA.Sequence).NumFrames - 1 Then
   MDLA.KeyFrame = MDLA.KeyFrame - (MDLA.Seq(MDLA.Sequence).NumFrames - 1)
  End If
  
End Sub


Private Sub CalcBonePosition(frame As Integer, SF As Single, Pos As D3DVECTOR, Bone As Integer, MI As Integer)
 Dim i As Integer, counter As Long, k As Long, Valid As Long
 Dim a As StudioAnim
 Dim s As SAF, ScaleVector As D3DVECTOR
 Dim VA As D3DVECTOR, VB As D3DVECTOR, VC As D3DVECTOR
 Dim P As StudioAnimUnion
 a = MDLA.SequenceA.Anim(Bone)
On Error Resume Next

   Pos = Vector(0, 0, 0)
   For i = 0 To 2
    SetVector i, Pos, MDLA.Bones(Bone).value(i)
    SetVector i, ScaleVector, MDLA.Bones(Bone).ScaleV(i)
    If a.offset(i) <> 0 Then
      counter = MDLA.SequenceA.Index + a.offset(i) + 12 * Bone
      CopyMemory P, MDLA.f(MDLA.SequenceA.Group).b(counter), 2
      k = frame
      
      Do While P.Total <= k
       k = k - P.Total
       counter = counter + (P.Valid + 1) * 2
       CopyMemory P, MDLA.f(MDLA.SequenceA.Group).b(counter), 2
      Loop
     
     If P.Valid > k Then
       If P.Valid > k + 1 Then
         counter = counter + (k + 1) * 2
         CopyMemory s, MDLA.f(MDLA.SequenceA.Group).b(counter), 2
         SetVector i, VA, s.value * (1 - SF)
         CopyMemory s, MDLA.f(MDLA.SequenceA.Group).b(counter + 2), 2
         SetVector i, VB, s.value * SF
         Select Case i
          Case 0: VC.x = VA.x + VB.x
          Case 1: VC.y = VA.y + VB.y
          Case 2: VC.z = VA.z + VB.z
         End Select
       Else
         counter = counter + (k + 1) * 2
         CopyMemory s, MDLA.f(MDLA.SequenceA.Group).b(counter), 2
         SetVector i, VC, s.value * 1#
       End If
      Else
        If P.Total < k + 1 Then
           Valid = P.Valid
           counter = counter + (Valid) * 2
           CopyMemory s, MDLA.f(MDLA.SequenceA.Group).b(counter), 2
           SetVector i, VA, s.value * (1 - SF)
           CopyMemory s, MDLA.f(MDLA.SequenceA.Group).b(counter + 4), 2
           
           SetVector i, VB, s.value * SF
           Select Case i
             Case 0: VC.x = VA.x + VB.x
             Case 1: VC.y = VA.y + VB.y
             Case 2: VC.z = VA.z + VB.z
           End Select
        Else
       
         counter = counter + (P.Valid) * 2
         CopyMemory s, MDLA.f(MDLA.SequenceA.Group).b(counter), 2
         SetVector i, VC, s.value * 1#
        End If
      End If
    End If
      
   Next i
   Pos.x = Pos.x + VC.x * ScaleVector.x
   Pos.y = Pos.y + VC.y * ScaleVector.y
   Pos.z = Pos.z + VC.z * ScaleVector.z
   
   
  
  If MDLA.Bones(Bone).BoneController(0) <> -1 Then Pos.x = Pos.x + MDLA.MAdj(MDLA.Bones(Bone).BoneController(0))
  If MDLA.Bones(Bone).BoneController(1) <> -1 Then Pos.y = Pos.y + MDLA.MAdj(MDLA.Bones(Bone).BoneController(1))
  If MDLA.Bones(Bone).BoneController(2) <> -1 Then Pos.z = Pos.z + MDLA.MAdj(MDLA.Bones(Bone).BoneController(2))
  On Error GoTo 0
  
  Exit Sub
CalcBoneError:
Err.Clear

End Sub
Private Sub CalcBonePosition2(frame As Integer, SF As Single, Pos As D3DVECTOR, Bone As Integer, MI As Integer)
 Dim i As Integer, counter As Long, k As Long, Valid As Long
 Dim a As StudioAnim
 
 
 Dim s As SAF, ScaleVector As D3DVECTOR
 Dim VA As D3DVECTOR, VB As D3DVECTOR, VC As D3DVECTOR
 Dim P As StudioAnimUnion
 a = MDLA.SequenceA.Anim(Bone)

On Error Resume Next

   Pos.x = 0: Pos.y = 0: Pos.z = 0
   For i = 0 To 2
    SetVector i, Pos, MDLA.Bones(Bone).value(i)
    SetVector i, ScaleVector, MDLA.Bones(Bone).ScaleV(i)
    If a.offset(i) <> 0 Then
      counter = MDLA.SequenceA.Index + a.offset(i) + 12 * Bone
      k = frame
      
      Do While Data(counter + 1) <= k
       k = k - Data(counter + 1)
       counter = counter + (Data(counter) + 1) * 2
      Loop
     
     If Data(counter) > k Then
       If Data(counter) > k + 1 Then
         counter = counter + (k + 1) * 2
         SetVector i, VA, ByteToInt(Data(counter), Data(counter + 1)) * (1 - SF)
         SetVector i, VB, ByteToInt(Data(counter + 2), Data(counter + 3)) * SF
         
         Select Case i
          Case 0: VC.x = VA.x + VB.x
          Case 1: VC.y = VA.y + VB.y
          Case 2: VC.z = VA.z + VB.z
         End Select
       Else
         counter = counter + (k + 1) * 2
         CopyMemory s, MDLA.f(MDLA.SequenceA.Group).b(counter), 2
         
         SetVector i, VC, ByteToInt(Data(counter), Data(counter + 1))
       End If
      Else
        If Data(counter + 1) < k + 1 Then
           Valid = Data(counter)
           counter = counter + (Valid) * 2
           SetVector i, VA, ByteToInt(Data(counter), Data(counter + 1)) * (1 - SF)
           SetVector i, VB, ByteToInt(Data(counter + 4), Data(counter + 5)) * SF
           Select Case i
             Case 0: VC.x = VA.x + VB.x
             Case 1: VC.y = VA.y + VB.y
             Case 2: VC.z = VA.z + VB.z
           End Select
        Else
         counter = counter + Data(counter) * 2
         SetVector i, VC, ByteToInt(Data(counter), Data(counter + 1)) * 1#
        End If
      End If
    End If
      
   Next i
   Pos.x = Pos.x + VC.x * ScaleVector.x
   Pos.y = Pos.y + VC.y * ScaleVector.y
   Pos.z = Pos.z + VC.z * ScaleVector.z
   
   
  
  If MDLA.Bones(Bone).BoneController(0) <> -1 Then Pos.x = Pos.x + MDLA.MAdj(MDLA.Bones(Bone).BoneController(0))
  If MDLA.Bones(Bone).BoneController(1) <> -1 Then Pos.y = Pos.y + MDLA.MAdj(MDLA.Bones(Bone).BoneController(1))
  If MDLA.Bones(Bone).BoneController(2) <> -1 Then Pos.z = Pos.z + MDLA.MAdj(MDLA.Bones(Bone).BoneController(2))
  On Error GoTo 0
  
  Exit Sub
CalcBoneError:
Err.Clear

End Sub
Function Collide(StartPos As D3DVECTOR, EndPos As D3DVECTOR, Optional TestType As CONST_TV_TESTTYPE = TV_TESTTYPE_MDL_HITBOXES, Optional BoneTouched As Integer) As Boolean
  '##BD Test if a ray intersects the actor.
  '##BD StartPos Start of the ray
  '##BD EndPos End of the ray
  '##BD TestType Type of collision. Only Bounding Box and HitBoxes are allowed.
  Dim TOrigin As D3DVECTOR, TDest As D3DVECTOR
  Dim TOr As D3DVECTOR, TD As D3DVECTOR
  TOrigin = MITransform(MDLA.Matrix, StartPos)
  TDest = MITransform(MDLA.Matrix, EndPos)
  Collide = False
 
  Dim i As Long
  If TestType = TV_TESTTYPE_MDL_HITBOXES Then
    BoneTouched = 0
    For i = 0 To UBound(MDLA.HitBoxes)
      TOr = MITransform(MDLA.AnimationStatus.Bones(MDLA.HitBoxes(i).Bone).Matrix, TOrigin)
      TD = MITransform(MDLA.AnimationStatus.Bones(MDLA.HitBoxes(i).Bone).Matrix, TDest)
      D3DXVec3Subtract TD, TD, TOr
      D3DXVec3Normalize TD, TD

      Collide = D3DX.BoxBoundProbe(MDLA.HitBoxes(i).bbmin, MDLA.HitBoxes(i).bbmax, TOr, TD)
      If Collide = True Then
        BoneTouched = MDLA.HitBoxes(i).Bone
        Exit Function
      End If
    Next i
  End If
  If TestType = TV_TESTTYPE_BOUNDINGBOX Then
      D3DXVec3Subtract TDest, TDest, TOrigin
      D3DXVec3Normalize TDest, TDest
       Collide = D3DX.BoxBoundProbe(MDLA.BoxMin, MDLA.BoxMax, TOrigin, TDest)
  End If
 
End Function

Public Function DuplicateActor() As Actor8
  Set DuplicateActor = New Actor8
  DuplicateActor.SetData MDLA, MD2, MD3
End Function


Friend Function GetActorIndex() As Integer
   GetActorIndex = ActIndex
End Function
Friend Function GetAttachPoint(Att As Integer) As D3DMATRIX
  If ModelType = 3 Then
   D3DXMatrixMultiply GetAttachPoint, MD3.AttachPoint(Att).Matrix, MDLA.Matrix
  End If
  If ModelType = 1 Then
   D3DXMatrixMultiply GetAttachPoint, MDLA.Attachment(Att).Matrix, MDLA.AnimationStatus.Bones(MDLA.Attachment(Att).Bone).Matrix
   D3DXMatrixMultiply GetAttachPoint, GetAttachPoint, MDLA.Matrix
  End If
'   GetAttachPoint =
End Function

Function GetBoneNameFromID(BoneID As Integer) As String
    GetBoneNameFromID = MDLA.Bones(BoneID).Name
End Function

Private Sub GetSequence(NumSeq As Integer)
  On Error Resume Next
   Dim s As Long, SG As Long
   Dim ve As Integer
   MDLA.Sequence = NumSeq
   s = NumSeq
   SG = MDLA.Seq(s).SeqGroup
  With MDLA.SequenceA
   .Group = SG
   .Index = MDLA.Seq(s).AnimIndex + MDLA.SeqGrp(SG).Data
   ReDim .Anim(MDLA.AnimationStatus.NbBones)
   CopyMemory .Anim(0), MDLA.f(SG).b(MDLA.Seq(s).AnimIndex + MDLA.SeqGrp(SG).Data), Len(.Anim(0)) * (UBound(MDLA.Bones) + 1)
   
  End With
   ReDim Data(UBound(MDLA.f(MDLA.SequenceA.Group).b)) As Byte
 CopyMemory Data(0), MDLA.f(MDLA.SequenceA.Group).b(0), UBound(Data)
  MDLA.MeshF.Settings.Changed = True
End Sub

Private Sub MD2UpdateAnimation()
  Dim LV() As D3DLVERTEX, i As Long
  Dim Blank As Long, f1 As Long, f2 As Long, pol As Single, V As Long
  Blank = D3DColorMake(1, 1, 1, 1)
  Device.SetRenderState D3DRS_LIGHTING, False
  With MDLA
     D3DXMatrixIdentity .Matrix
     If .MeshF.Settings.Scaling.x <> 0 And .MeshF.Settings.Scaling.y <> 0 And .MeshF.Settings.Scaling.z <> 0 Then
       .Matrix = MScale2(.Matrix, .MeshF.Settings.Scaling.x, .MeshF.Settings.Scaling.y, .MeshF.Settings.Scaling.z)
     End If
     .Matrix = MRotate(.Matrix, .MeshF.Settings.Rotation.x, .MeshF.Settings.Rotation.y, .MeshF.Settings.Rotation.z)
     .Matrix = MTranslate(.Matrix, .MeshF.Settings.Position.x, .MeshF.Settings.Position.y, .MeshF.Settings.Position.z)
  End With
   
  With MD2
  Device.SetTransform D3DTS_WORLD, MDLA.Matrix
   
   .CurrentFrame = .CurrentFrame + SystemFrame * MDLA.Speed / 1000
   If .CurrentFrame > .EndFrame Then .CurrentFrame = .StartFrame
   f1 = Int(.CurrentFrame)
   If f1 > .EndFrame - 2 Then
     f2 = .StartFrame
   Else
     f2 = f1 + 1
   End If
   pol = .CurrentFrame - f1
   ReDim LV(UBound(.VIndexes))
   For i = 0 To UBound(LV) - 1
      LV(i).color = Blank
      V = .VIndexes(i)
      LV(i).x = .Frames(f1).vertices(V).V.x * (1 - pol) + .Frames(f2).vertices(V).V.x * (pol)
      LV(i).y = .Frames(f1).vertices(V).V.y * (1 - pol) + .Frames(f2).vertices(V).V.y * (pol)
      LV(i).z = .Frames(f1).vertices(V).V.z * (1 - pol) + .Frames(f2).vertices(V).V.z * (pol)
      LV(i).tu = .TexCoord2(.TIndexes(i)).s
      LV(i).tv = .TexCoord2(.TIndexes(i)).t
   Next i
  End With
  With Device
   If MD2.SkinTexture <> 0 Then
    .SetTexture 0, Textures(MD2.SkinTexture).TexSurf
   Else
    .SetTexture 0, Nothing
   End If
   .SetVertexShader TV_LVERTEX
   .DrawPrimitiveUP D3DPT_TRIANGLELIST, UBound(LV) / 3, LV(0), Len(LV(0))
   
 End With
End Sub
Private Sub MD3UpdateAnimation()
  Dim LV() As D3DLVERTEX, i As Long, a As Long
  Dim Blank As Long, f1 As Long, f2 As Long, pol As Single, V As Long
  Blank = D3DColorMake(1, 1, 1, 1)
  Device.SetRenderState D3DRS_LIGHTING, False
  With MDLA
     D3DXMatrixIdentity .Matrix
    If MD3.Attach = -1 Then
     
     If .MeshF.Settings.Scaling.x <> 0 And .MeshF.Settings.Scaling.y <> 0 And .MeshF.Settings.Scaling.z <> 0 Then
       .Matrix = MScale2(.Matrix, .MeshF.Settings.Scaling.x, .MeshF.Settings.Scaling.y, .MeshF.Settings.Scaling.z)
     End If
     .Matrix = MRotate(.Matrix, .MeshF.Settings.Rotation.x, .MeshF.Settings.Rotation.y, .MeshF.Settings.Rotation.z)
     .Matrix = MTranslate(.Matrix, .MeshF.Settings.Position.x, .MeshF.Settings.Position.y, .MeshF.Settings.Position.z)
    Else
      D3DXMatrixMultiply .Matrix, .Matrix, LocalActors(MD3.Attach).GetAttachPoint(MD3.AttachBone)
      'Same current frame
      'MD3.CurrentFrame = LocalActors(MD3.Attach).GetFrame
    End If
    
   End With
   
  With MD3
 If .Surfaces(0).NumFrames <> 1 Then
   .EndFrame = .Surfaces(0).NumFrames
   
   
   .CurrentFrame = .CurrentFrame + SystemFrame * MDLA.Speed / 100
   If .CurrentFrame > .EndFrame Then .CurrentFrame = .StartFrame
   f1 = Int(.CurrentFrame)
   If f1 > .EndFrame - 2 Then
     f2 = .StartFrame
   Else
     f2 = f1 + 1
   End If
   pol = .CurrentFrame - f1
   Else
    pol = 0
    f2 = 0
    f1 = f2
   End If
  
  Device.SetTransform D3DTS_WORLD, MDLA.Matrix
  If CheckSphere(.Frames(.CurrentFrame).LocalOrigin, .Frames(f1).Radius) = 0 Then
    Exit Sub
  End If
 
  Dim V1 As D3DVECTOR, V2 As D3DVECTOR, v3 As D3DVECTOR
  Dim v4 As D3DVECTOR
 ' On Error Resume Next
  On Error Resume Next
  Dim s As Single
  s = 1 / 0
  On Error GoTo 0
  
  For a = 0 To .NbAttachPoint - 1
     V1.x = 0: V1.y = 0: V1.z = 0
     D3DXVec3Lerp V1, .AttachPoint(a).Tags(f1).Axis(0), .AttachPoint(a).Tags(f2).Axis(0), pol
     D3DXVec3Lerp V2, .AttachPoint(a).Tags(f1).Axis(1), .AttachPoint(a).Tags(f2).Axis(1), pol
     D3DXVec3Lerp v3, .AttachPoint(a).Tags(f1).Axis(2), .AttachPoint(a).Tags(f2).Axis(2), pol
     D3DXVec3Lerp v4, .AttachPoint(a).Tags(f1).Origin, .AttachPoint(a).Tags(f2).Origin, pol
     With .AttachPoint(a).Matrix
       .m11 = V1.x: .m12 = V1.y: .m13 = V1.z: .m14 = 0
       .m21 = V2.x: .m22 = V2.y: .m23 = V2.z: .m24 = 0
       .m31 = v3.x: .m32 = v3.y: .m33 = v3.z: .m34 = 0
       .m41 = v4.x: .m42 = v4.y: .m43 = v4.z: .m44 = 1
     End With
  Next
 
  For a = 0 To .NbSurface - 1
   ReDim LV(UBound(.Surfaces(a).Indexes))
   Dim temp As D3DVECTOR
   With .Surfaces(a)
  If pol <> 0 Then
   For i = 0 To UBound(LV) - 1
      LV(i).color = Blank
      V = .Indexes(i)
      D3DXVec3Lerp temp, .Frames(f1).Vector(V), .Frames(f2).Vector(V), pol
      DXCopyMemory LV(i), temp, 12
      DXCopyMemory LV(i).tu, .St(V), 8
   Next i
  Else
   For i = 0 To UBound(LV) - 1
      LV(i).color = Blank
      V = .Indexes(i)
      DXCopyMemory LV(i), .Frames(f1).Vector(V), 12
      DXCopyMemory LV(i).tu, .St(V), 8
   Next i
  End If
   If .ShaderIndex <> 0 Then
    Device.SetTexture 0, Textures(.ShaderIndex).TexSurf
   Else
    Device.SetTexture 0, Nothing
   End If
   Device.SetVertexShader TV_LVERTEX
   Device.DrawPrimitiveUP D3DPT_TRIANGLELIST, UBound(LV) / 3, LV(0), Len(LV(0))
   End With
  Next a
 End With
End Sub

Private Sub OpenMD3File(Filename As String)
 Dim Header As MD3Header
 Dim Surface() As MD3Surface
 Dim a As Long
 Dim Shader() As MD3Shader, nbshader As Long, CurrentShader As Long
 Dim i As Long, Triangle() As MD3Triangle
 Dim XYZ() As MD3XYZNormal
 Dim SurfaceOf() As Long
 Close #1
 ModelType = 3
 On Error Resume Next
 Open Filename For Binary As #1
    Get #1, , Header
 Open Filename For Binary As #1
  If Header.Ident <> "IDP3" Then
   Exit Sub
  End If
 On Error Resume Next
   Debug.Print "\\\\\\\\\\\\\\\\\\\\\\\\\\"
   Debug.Print Header.NumFrames, Filename
  ReDim MD3.Frames(Header.NumFrames)
  Seek #1, Header.ofsFrames + 1
  For i = 0 To Header.NumFrames - 1
     Get #1, , MD3.Frames(i)
   'Debug.Print MD3.Frames(i).Name, MD3.Frames(i).LocalOrigin.x, MD3.Frames(i).LocalOrigin.y, MD3.Frames(i).LocalOrigin.z, MD3.Frames(i).Radius
  Next i
  
  Dim Tags() As MD3Tag
  ReDim Tags(Header.numTags * Header.NumFrames)
  Seek #1, Header.ofsTags + 1
  MD3.NbAttachPoint = Header.numTags
  ReDim MD3.AttachPoint(Header.numTags)
 For a = 0 To Header.NumFrames - 1
   ReDim MD3.AttachPoint(a).Tags(Header.NumFrames)
   For i = 0 To Header.numTags - 1
     Get #1, , MD3.AttachPoint(i).Tags(a)
     'Debug.Print MD3.AttachPoint(i).Tags(a).Name
     'Debug.Print MD3.AttachPoint(a).Tags(i).Origin.x, MD3.AttachPoint(a).Tags(i).Origin.y, MD3.AttachPoint(a).Tags(i).Origin.z
     
   Next i
 Next a
   
  ReDim Surface(Header.numSurfaces)
  ReDim SurfaceOf(Header.numSurfaces)
  Seek 1, Header.ofsSurfaces + 1
  
  For i = 0 To Header.numSurfaces - 1
     SurfaceOf(i) = Seek(1) - 1
     Get #1, , Surface(i)
    Seek #1, Surface(i).ofsEnd + 1 + SurfaceOf(i)
  Next i
 
 'Get surfaces
 
 MD3.NbSurface = Header.numSurfaces
 ReDim Preserve MD3.Surfaces(MD3.NbSurface)
 Dim ShaderName As String
 Dim SurfOffset As Long, g As Long, f As Long, VO As Long
 For i = 0 To Header.numSurfaces - 1
   SurfOffset = SurfaceOf(i)
   ReDim Shader(Surface(i).numShaders)
   Get #1, SurfOffset + Surface(i).ofsShaders + 1, Shader()
   For g = 0 To Surface(i).numShaders - 1
     Debug.Print Shader(g).Name
     ShaderName = SearchExistPath(Left(Shader(g).Name, InStr(Shader(g).Name, Chr(0)) - 1), "c:\")
     Shader(g).ShaderIndex = LocTexFactory.LoadTexture(ShaderName, Shader(g).Name).GetTexIndex
   Next g
   
   With MD3.Surfaces(i)
     .ShaderIndex = Shader(g - 1).ShaderIndex
     .NumFrames = Surface(i).NumFrames
     ReDim .St(Surface(i).numVerts)
     Get #1, SurfOffset + Surface(i).ofsSt + 1, .St
     
     'Get Vertexes per Frames
     ReDim .Frames(.NumFrames)
     ReDim XYZ(.NumFrames * Surface(i).numVerts)
     Get #1, SurfOffset + Surface(i).ofsXyzNormals + 1, XYZ
     VO = 0
     For f = 0 To .NumFrames - 1
        .Frames(f).NumVector = Surface(i).numVerts
        ReDim Preserve .Frames(f).Vector(.Frames(f).NumVector)
        For g = 0 To .Frames(f).NumVector - 1
          .Frames(f).Vector(g) = VScale(Vector(XYZ(g + VO).XYZ(0), XYZ(g + VO).XYZ(1), XYZ(g + VO).XYZ(2)), MD3_XYZ_SCALE)
        Next g
        VO = VO + .Frames(f).NumVector
     Next f
   
   
   'Get the triangles and create index buffer from it
   ReDim .Indexes(Surface(i).numTriangles * 3)
   ReDim Triangle(Surface(i).numTriangles)
   Get #1, SurfOffset + Surface(i).ofsTriangles + 1, Triangle()
   VO = 0
   For f = 0 To Surface(i).numTriangles - 1
      .Indexes(VO + 0) = Triangle(f).Index(0)
      .Indexes(VO + 1) = Triangle(f).Index(1)
      .Indexes(VO + 2) = Triangle(f).Index(2)
      VO = VO + 3
   Next f
   
   
   End With
   
   
   
 Next i
 
 
 Close #1
  
  
End Sub
Private Sub MDLUpdateAnimation(MI As Integer, M As MDLFile)

   Dim i As Long, temp As D3DVECTOR, MeshE As Integer, V As Long, ms As Integer
   Dim LV() As D3DLVERTEX, VC() As D3DVECTOR
   Dim delta As Single, Mini As D3DVECTOR, Maxi As D3DVECTOR

 
   delta = GetTickCount - M.OldTime
   If delta > 100 Then delta = 100
   M.OldTime = GetTickCount
   AdvanceFrame delta
   
     With M
     
     If .MeshF.Settings.Changed = True And M.AttachMesh = -1 Then
      
      D3DXMatrixIdentity .Matrix
            If .MeshF.Settings.Scaling.x <> 0 And .MeshF.Settings.Scaling.y <> 0 And .MeshF.Settings.Scaling.z <> 0 Then
        .Matrix = MScale2(.Matrix, .MeshF.Settings.Scaling.x, .MeshF.Settings.Scaling.y, .MeshF.Settings.Scaling.z)
       End If
       .Matrix = MRotate(.Matrix, .MeshF.Settings.Rotation.x, .MeshF.Settings.Rotation.y, .MeshF.Settings.Rotation.z)
       .Matrix = MTranslate(.Matrix, .MeshF.Settings.Position.x, .MeshF.Settings.Position.y, .MeshF.Settings.Position.z)
      .MeshF.Settings.Changed = False
       
     End If
     If M.AttachMesh > -1 Then
        D3DXMatrixIdentity .Matrix
     
      D3DXMatrixMultiply .Matrix, .Matrix, LocalActors(MDLA.AttachMesh).GetAttachPoint(MDLA.AttachPoint)
      'Same current frame
      'MD3.CurrentFrame = LocalActors(MD3.Attach).GetFrame
     End If
      
     End With
     
   '  Device.SetTransform D3DTRANSFORMSTATE_WORLD, M.MeshF.Matrix
   Device.SetTransform D3DTS_WORLD, M.Matrix
  
  If M.SphereComputed = False Then
    Maxi = Vector(-9999, -9999, -9999)
    Mini = Vector(9999, 9999, 9999)

  Else
    
  '  If Device.ComputeSphereVisibility(M.MeshF.Center, M.MeshF.radius) And &HFFF000 Then
  '     Exit Sub
  '  End If
    If CheckSphere(M.MeshF.Settings.SphereClip, M.MeshF.Settings.SphereRadius) = 0 Then
      Exit Sub
    End If
  End If

     SetUpBones MI, M.KeyFrame
   
Render:
      With Device
       .SetRenderState D3DRS_CULLMODE, D3DCULL_NONE
       .SetRenderState D3DRS_LIGHTING, 0
       .SetRenderState D3DRS_ALPHABLENDENABLE, 0
       .SetRenderState D3DRS_ZWRITEENABLE, 1
       .SetRenderState D3DRS_ZENABLE, 1
       
     
     Dim VCA As D3DLVERTEX
     Dim White As Long
     Dim numv As Long
     
      White = D3DColorMake(1, 1, 1, 1)
      .SetVertexShader TV_LVERTEX
      End With
     On Error GoTo suite
     For i = 0 To M.Header.NumBodyparts - 1
        ms = M.BP(i).ModelSelect
        numv = M.BP(i).Model(ms).NumVertex
        ReDim VC(numv)
        For V = 0 To numv
           D3DXVec3TransformCoord VC(V), M.BP(i).Mods(ms).Vertex(V), M.AnimationStatus.Bones(M.BP(i).Mods(ms).VertexBones(V)).Matrix
        Next V
        For MeshE = 0 To M.BP(i).Model(ms).NumMesh - 1
          With M.BP(i).Mods(ms)
            ReDim LV(UBound(.Mesh(MeshE).Vertex))
            
          'create vertexes on the fly
            For V = 0 To UBound(LV) - 1
              With .Mesh(MeshE)
                 DXCopyMemory LV(V).x, VC(.Vertex(V)), 12
                 'LV(v).x = VC(.Vertex(v)).x
                 'LV(v).y = VC(.Vertex(v)).y
                 'LV(v).z = VC(.Vertex(v)).z
 
                 LV(V).color = White
                 DXCopyMemory LV(V).tu, .TC(V).U, 8
                 'LV(v).tu = .TC(v).U
                 'LV(v).tv = .TC(v).v
                  If M.SphereComputed = False Then
                   If LV(V).x < Mini.x Then Mini.x = LV(V).x
                   If LV(V).y < Mini.y Then Mini.y = LV(V).y
                   If LV(V).z < Mini.z Then Mini.z = LV(V).z
                   If LV(V).x > Maxi.x Then Maxi.x = LV(V).x
                   If LV(V).y > Maxi.y Then Maxi.y = LV(V).y
                   If LV(V).z > Maxi.z Then Maxi.z = LV(V).z
                 End If
             End With
              
            Next V
            
            'render vertexes
              Device.SetTexture 0, Textures(M.TextureOffset(.Mesh(MeshE).Texture)).TexSurf
              Device.DrawPrimitiveUP D3DPT_TRIANGLELIST, UBound(LV) / 3, LV(0), Len(VCA)
              
            'End If
          End With
          
        Next MeshE
     Next i
If M.SphereComputed = False Then
   M.SphereComputed = True
   M.BoxMin = Mini
   M.BoxMax = Maxi
   M.Center = VScale(VAdd(Mini, Maxi), 0.5)
   M.Radius = VModulus(VSubtract(Maxi, Mini)) / 2 * 1.414
End If

 If M.MeshF.Settings.Changed = True Then
   CopyMemory Mesh(ModelMesh).Features, M.MeshF, Len(M.MeshF)
 End If
 Exit Sub
suite:
Resume Next
Err.Clear
a:
On Error GoTo 0
End Sub


Private Sub SearchAnimFrames(a As Integer)
  If a = -1 Then
   MD2.StartFrame = 0
   MD2.EndFrame = MD2.Header.Num_frames - 1
   MD2.CurrentFrame = 0
  Else
   MD2.StartFrame = MD2.Anim(a).Start
   MD2.EndFrame = MD2.Anim(a).End
   MD2.CurrentFrame = MD2.StartFrame
  End If
  
End Sub

Friend Function SetActorIndex(Ind) As Integer
    ActIndex = Ind
End Function

Friend Sub SetAttachPoint(ActInd As Integer, Point As Integer)
  If ModelType = 3 Then
   'works only with MD3 for now
    MD3.AttachPoint(Point).AttachMesh = ActInd
    D3DXMatrixIdentity MD3.AttachPoint(Point).Matrix
   ' MD3.Attach = 0
  End If
  If ModelType = 1 Then
    MDLA.Attachment(Point).AttachMesh = ActInd
  End If
End Sub

Friend Sub SetData(M1 As MDLFile, M2 As MD2Type, m3 As MD3Type)
  MDLA = M1
  MD2 = M2
  MD3 = m3
End Sub

Sub SetHitboxesEnable(Enable As Boolean)
   MDLA.UseHitboxes = Enable
End Sub

Sub SetMD3Texture(Texture As Texture8, Optional Surface As Integer = -1)
  '##BD Apply a loaded texture to a MD3 surface. A MD3 can contain several surfaces. Basically you just need to set the texture and get rid of the surface argument.
  '##PD Texture Texture class to be applied
  '##PD Surface Don't use it ;)
  Dim i As Long
  For i = 0 To MD3.NbSurface - 1
   If Surface = -1 Or Surface = i Then
     MD3.Surfaces(i).ShaderIndex = Texture.GetTexIndex
   End If
  Next i
End Sub

Sub SetSkinMD2(Skin As Texture8)
   '##BD <b> ONLY FOR MD2 FILES </b> Set the skin texture for the MD2 model. The texture must be loaded as usual with the Scene.LoadTexture method.
   '##PD Skin Texture class that will be applied on the MD2 model.
  '
  If ModelType = 2 Then
     MD2.SkinTexture = Skin.GetTexIndex
  End If
End Sub

Private Sub SetUpBones(MI As Integer, frame As Single)
 On Error Resume Next
  Dim Q() As D3DQUATERNION, Pos() As D3DVECTOR, a As Long
  Dim i As Integer, s As Single, f As Integer
  
 ReDim Q(MDLA.AnimationStatus.NbBones)
  ReDim Pos(MDLA.AnimationStatus.NbBones)
  
  f = Int(frame)
  s = frame - f


 
  If MDLA.Header.NumBoneControllers > 0 Then
     CalcControllers
  End If



  For i = 0 To UBound(MDLA.Bones)
   
    CalcBonePosition f, s, Pos(i), i, MI
    CalcBoneQuaternion f, s, Q(i), i, MI
  Next i
  
 ' If MDLA.Seq(MDLA.Sequence).MotionType And studio_x Then
 '   Pos(MDLA.Seq(MDLA.Sequence).MotionBone).X = 0
 ' End If
 ' If MDLA.Seq(MDLA.Sequence).MotionType And studio_y Then
 '   Pos(MDLA.Seq(MDLA.Sequence).MotionBone).y = 0
 ' End If
 ' If MDLA.Seq(MDLA.Sequence).MotionType And studio_z Then
 '   Pos(MDLA.Seq(MDLA.Sequence).MotionBone).z = 0
  'End If
  
  'Concat transform matrix

  For i = 0 To MDLA.AnimationStatus.NbBones - 1
    With MDLA.AnimationStatus.Bones(i)
     D3DXMatrixRotationQuaternion .Matrix, Q(i)
     'QuaternionMatrix Q(i), .Matrix
     .Matrix.m41 = Pos(i).x
     .Matrix.m42 = Pos(i).y
     .Matrix.m43 = Pos(i).z
     .Matrix.m44 = 1
     If .Parent <> -1 Then
        D3DXMatrixMultiply .Matrix, .Matrix, MDLA.AnimationStatus.Bones(.Parent).Matrix
     End If
    End With
  Next i
  
End Sub

Private Sub CalcBoneQuaternion(frame As Integer, SF As Single, Q As D3DQUATERNION, Bone As Integer, MI As Integer)
 On Error Resume Next
    Dim i As Integer, k As Long, counter As Long, AncCounter As Long
    Dim angle1 As D3DVECTOR
    Dim angle2 As D3DVECTOR
    Dim q1 As D3DQUATERNION, q2 As D3DQUATERNION
    Dim s As SAF, a As StudioAnim, S1 As SAF, ScaleVector As D3DVECTOR
    Dim Rot As D3DVECTOR
    Dim P As StudioAnimUnion
     a = MDLA.SequenceA.Anim(Bone)
      Rot.x = 0: Rot.y = 0: Rot.z = 0
      ScaleVector.x = 0: ScaleVector.y = 0: ScaleVector.z = 0
      For i = 3 To 5
        SetVector i, ScaleVector, MDLA.Bones(Bone).ScaleV(i)
        SetVector i, Rot, MDLA.Bones(Bone).value(i)
       If a.offset(i) = 0 Then
          If i = 3 Then angle1.x = Rot.x: angle2.x = angle1.x
          If i = 4 Then angle1.y = Rot.y: angle2.y = angle1.y
          If i = 5 Then angle1.z = Rot.z: angle2.z = angle1.z
       Else
        counter = MDLA.SequenceA.Index + a.offset(i) + 12 * Bone
        CopyMemory P, MDLA.f(MDLA.SequenceA.Group).b(counter), 2
        k = frame
        Do While P.Total <= k
          k = k - P.Total
          counter = counter + (P.Valid + 1) * 2
          CopyMemory P, MDLA.f(MDLA.SequenceA.Group).b(counter), 2
        Loop
        If P.Valid > k Then
          AncCounter = counter
          counter = counter + (k + 1) * 2
          CopyMemory S1, MDLA.f(MDLA.SequenceA.Group).b(counter), 2
          SetVector i, angle1, S1.value * 1#
          If P.Valid > k + 1 Then
           counter = counter + 2
           CopyMemory S1, MDLA.f(MDLA.SequenceA.Group).b(counter), 2
           SetVector i, angle2, S1.value * 1#
          Else
           If P.Total > k + 1 Then
            If i = 3 Then angle2.x = angle1.x
            If i = 4 Then angle2.y = angle1.y
            If i = 5 Then angle2.z = angle1.z
           Else
            counter = AncCounter + (P.Valid + 1) * 2
            CopyMemory S1, MDLA.f(MDLA.SequenceA.Group).b(counter), 2
            SetVector i, angle2, S1.value * 1#
           End If
          End If
          
         Else
          AncCounter = counter
          counter = counter + (P.Valid) * 2
          CopyMemory S1, MDLA.f(MDLA.SequenceA.Group).b(counter), 2
          SetVector i, angle1, S1.value * 1#
          If P.Total > k + 1 Then
            If i = 3 Then angle2.x = angle1.x
            If i = 4 Then angle2.y = angle1.y
            If i = 5 Then angle2.z = angle1.z
          Else
            counter = AncCounter + (P.Valid + 2) * 2
            CopyMemory S1, MDLA.f(MDLA.SequenceA.Group).b(counter), 2
            SetVector i, angle2, S1.value * 1#
          End If
         End If
          Select Case i
           Case 3
             angle1.x = angle1.x * ScaleVector.x + Rot.x
             angle2.x = angle2.x * ScaleVector.x + Rot.x
           Case 4
             angle1.y = angle1.y * ScaleVector.y + Rot.y
             angle2.y = angle2.y * ScaleVector.y + Rot.y
           Case 5
             angle1.z = angle1.z * ScaleVector.z + Rot.z
             angle2.z = angle2.z * ScaleVector.z + Rot.z
          End Select
       End If
    Next i
    
  
   
   If MDLA.Bones(Bone).BoneController(3) <> -1 Then angle1.x = angle1.x + MDLA.MAdj(MDLA.Bones(Bone).BoneController(3)): angle2.x = angle2.x + MDLA.MAdj(MDLA.Bones(Bone).BoneController(3))
   If MDLA.Bones(Bone).BoneController(4) <> -1 Then angle1.y = angle1.y + MDLA.MAdj(MDLA.Bones(Bone).BoneController(4)): angle2.y = angle2.y + MDLA.MAdj(MDLA.Bones(Bone).BoneController(4))
   If MDLA.Bones(Bone).BoneController(5) <> -1 Then angle1.z = angle1.z + MDLA.MAdj(MDLA.Bones(Bone).BoneController(5)): angle2.z = angle2.z + MDLA.MAdj(MDLA.Bones(Bone).BoneController(5))
   
   If VCompare(angle1, angle2) = 1 Then
      'D3DXQuaternionRotationYawPitchRoll Q, angle1.X, angle1.y, angle1.z
      AngleQuaternion angle1, Q
    Else
      AngleQuaternion angle1, q1
      AngleQuaternion angle2, q2
      'D3DXQuaternionRotationYawPitchRoll q1, angle1.x, angle1.y, angle1.z
      'D3DXQuaternionRotationYawPitchRoll q2, angle2.x, angle2.y, angle2.z
      D3DXQuaternionSlerp Q, q1, q2, SF
      'QuaternionSlerp q1, q2, SF, Q
      
    End If
    On Error GoTo 0
Exit Sub

End Sub

Private Function LoadMainMDL(Filename As String)
On Error GoTo ErrorTreat
Dim i As Long, N As Long, a As Long, tex As Integer, vi As Long, Prim As Long
Dim V As Long, VC As Long, nf As Long, nac As Long

 'MDL are sometimes divided in several files : [Name]0[n].mdl : Sequence group
 '                                             [Name]T.MDL: Textures
 '                                             [Name].MDL : main file with vertexes & general info

 'Here we'll load the main MDL

 'Load MDL header info
 
MDLA.Filename = Filename
AddLog "MDL/MD2 ACTOR : Loading " + CStr(MDLA.Filename)
Open Filename For Binary As 1
 Get #1, , Hdr
  
 If Hdr.id = "IDP3" Then
   Close #1
   'it's a MD3 file
   AddLog "MD3 model file type..."
   OpenMD3File Filename
   Exit Function
 End If
 If Hdr.id = "IDP2" Then
  'it's a MD2 file
  Close #1
  AddLog "MD2 model file type..."
  OpenMD2File Filename
  Exit Function
 End If
 
 If Hdr.id <> "IDST" Then

  AddLog Filename + "he file isn't a Half-Life model file. STATE : ERROR (Level 3/5)"
  Exit Function
 End If
 
 ModelType = 1
 
 AddLog "Load the entire file..."
 'Get the entire file
 ReDim MDLA.f(0)
 ReDim MDLA.f(0).b(LOF(1))
 Get #1, 1, MDLA.f(0).b()
   MDLA.Header = Hdr
  'Load Bones
  AddLog "Load bones..."
  ReDim MDLA.Bones(Hdr.NumBones)
  Seek #1, Hdr.BoneIndex + 1
  For i = 0 To Hdr.NumBones
     Get #1, , MDLA.Bones(i)
  Next i
 
 'Load Controllers bones
 AddLog "Load bone controllers..."
 If Hdr.NumBoneControllers <> 0 Then
 ReDim MDLA.ControllerBone(Hdr.NumBoneControllers - 1)
 ReDim MDLA.MAdj(Hdr.NumBoneControllers - 1)
 ReDim MDLA.ControllerValue(Hdr.NumBoneControllers - 1)
 Seek #1, Hdr.BoneControllerIndex + 1
 For i = 0 To Hdr.NumBoneControllers - 1
  Get #1, , MDLA.ControllerBone(i)
  If MDLA.ControllerBone(i).Index < 3 Then
    MDLA.ControllerValue(i) = 128
  End If
 Next i
 End If
 
 If Hdr.NumHitBoxes > 0 Then
   ReDim MDLA.HitBoxes(Hdr.NumHitBoxes - 1)
   ReDim MDLA.HitboxesT(Hdr.NumHitBoxes - 1)
   Seek #1, Hdr.HitBoxIndex + 1
   For i = 0 To Hdr.NumHitBoxes - 1
      Get #1, , MDLA.HitBoxes(i)
      With MDLA.HitboxesT(i)
        .min = MDLA.HitBoxes(i).bbmin
        .max = MDLA.HitBoxes(i).bbmax
           
     End With
   Next i
 End If
 
 AddLog "Load bodypart..."
 'Load Bodyparts & models
  ReDim MDLA.BP(Hdr.NumBodyparts - 1)
  Seek #1, Hdr.Bodypartindex + 1
  For i = 0 To Hdr.NumBodyparts - 1
   Get #1, , MDLA.BP(i).BodyP
  Next i
  
 'GoTo Group
    'Check if we have internal textures to load
  AddLog "Load textures..."
   If Hdr.NumTextures > 0 Then
     AddLog "Internal textures..."
     'we have textures to load here
     LoadMDLTextures 1, Hdr
   Else
     LoadMDLTextureFile
   End If
    
    
  'get Attachments
  If Hdr.NumAttachments > 0 Then
   MDLA.NumAttachment = Hdr.NumAttachments
   ReDim MDLA.Attachment(Hdr.NumAttachments)
   Dim Att() As StudioAttachment
   Dim V1 As D3DVECTOR, V2 As D3DVECTOR, v3 As D3DVECTOR
   Dim v4 As D3DVECTOR
   ReDim Att(MDLA.NumAttachment - 1)
   Seek #1, Hdr.Attachmentindex + 1
   Get #1, , Att()
   
   For i = 0 To MDLA.NumAttachment - 1
      With MDLA.Attachment(i)
        .Bone = Att(i).Bone
        V1 = Att(i).Vec(0)
        V2 = Att(i).Vec(1)
        v3 = Att(i).Vec(2)
        v4 = Att(i).Org
        With .Matrix
          .m11 = V1.x: .m12 = V1.y: .m13 = V1.z: .m14 = 0
          .m21 = V2.x: .m22 = V2.y: .m23 = V2.z: .m24 = 0
          .m31 = v3.x: .m32 = v3.y: .m33 = v3.z: .m34 = 0
          .m41 = v4.x: .m42 = v4.y: .m43 = v4.z: .m44 = 1
         If .m11 = 0 Then .m11 = 1
         If .m22 = 0 Then .m22 = 1
         If .m33 = 0 Then .m33 = 1
        End With
        
      End With
   Next i
  End If
    
  'Get models & vertexes
  For i = 0 To Hdr.NumBodyparts - 1
     Seek #1, MDLA.BP(i).BodyP.ModelIndex + 1
     ReDim MDLA.BP(i).Model(MDLA.BP(i).BodyP.NumModels - 1)
     ReDim MDLA.BP(i).Mods(MDLA.BP(i).BodyP.NumModels - 1)
     For N = 0 To MDLA.BP(i).BodyP.NumModels - 1
       Get #1, , MDLA.BP(i).Model(N)
     Next N
     With MDLA.BP(i)
     For N = 0 To .BodyP.NumModels - 1
       Seek #1, .Model(N).VertexIndex + 1
       If .Model(N).NumVertex > 0 Then
        ReDim .Mods(N).Vertex(.Model(N).NumVertex)
        
        'Get all the vertexes & vertexes bones
        Get #1, , .Mods(N).Vertex()
        
        ReDim .Mods(N).VertexBones(.Model(N).NumVertex + 1)
        Seek #1, .Model(N).VertexInfoindex + 1
        Get #1, , .Mods(N).VertexBones()
        
        'Get meshes
        ReDim .Mods(N).SMesh(.Model(N).NumMesh - 1)
        Seek #1, .Model(N).MeshIndex + 1
        Get #1, , .Mods(N).SMesh()
        
        'Get triangles datas
        ReDim .Mods(N).Mesh(.Model(N).NumMesh - 1)
        .Mods(N).NumMesh = .Model(N).NumMesh
        For a = 0 To .Mods(N).NumMesh - 1
           
           Seek #1, .Mods(N).SMesh(a).TriIndex + 1  ' CHECK IT
           .Mods(N).Mesh(a).Texture = .Mods(N).SMesh(a).SkinRef
        '   Debug.Print "mesh "; a; " numtri  :"; .Mods(N).SMesh(a).NumTris
           
           ' get triangle commands :
           Dim TriCmds(3) As Integer, NV As Integer
           ReDim .Mods(N).Mesh(a).Vertex(.Mods(N).SMesh(a).NumTris * 3)
           ReDim .Mods(N).Mesh(a).TC(.Mods(N).SMesh(a).NumTris * 3)
           tex = .Mods(N).Mesh(a).Texture
           
          vi = 0
          Do
           Get #1, , NV
           'if NV is negative, then the primitive type is a TRIANGLE_FAN
           'else a TRIANGLE_STRIP, and we will have a TRIANGLE_LIST. It's really crazy!
           'Debug.Print
           'Debug.Print NV
           If NV = 0 Then Exit Do
           If NV < 0 Then
            Prim = 1
            NV = -NV
           Else
            Prim = 0
           End If
           Dim vx() As Integer
           Dim s() As Integer
           Dim t() As Integer
           ReDim vx(NV), s(NV), t(NV)
           
           For V = 1 To NV
            Get #1, , TriCmds()
            vx(V) = TriCmds(0)
            s(V) = TriCmds(2)
            t(V) = TriCmds(3)
            
            ' let's try with a texture coordinate for a vertex
            '
            '.Mods(N).TC(TriCmds(0)).x = TriCmds(2)
            '.Mods(N).TC(TriCmds(0)).y = TriCmds(3)
            'Debug.Print TriCmds(0), TriCmds(1), TriCmds(2), TriCmds(3)
           Next V
            
           'compose TriangleList
           
           If Prim = 1 Then  'TRIANGLE_FAN
            'Debug.Print "FAN"
            With .Mods(N).Mesh(a)
              For VC = 1 To NV - 2
                .Vertex(vi) = vx(1)
                .Vertex(vi + 1) = vx(VC + 1)
                .Vertex(vi + 2) = vx(VC + 2)
                .TC(vi).U = s(1) / MDLA.TexSize(tex).x
                .TC(vi + 1).U = s(VC + 1) / MDLA.TexSize(tex).x
                .TC(vi + 2).U = s(VC + 2) / MDLA.TexSize(tex).x
                .TC(vi).V = t(1) / MDLA.TexSize(tex).y
                .TC(vi + 1).V = t(VC + 1) / MDLA.TexSize(tex).y
                .TC(vi + 2).V = t(VC + 2) / MDLA.TexSize(tex).y
               'Debug.Print .Vertex(vi), .Vertex(vi + 1), .Vertex(vi + 2)
                vi = vi + 3
              Next VC
            End With
           Else
            ' Debug.Print "STRIP"
             With .Mods(N).Mesh(a)
              For VC = 1 To NV - 2
                .Vertex(vi) = vx(VC)
                .Vertex(vi + 1) = vx(VC + 1)
                .Vertex(vi + 2) = vx(VC + 2)
                .TC(vi).U = s(VC) / MDLA.TexSize(tex).x
                .TC(vi + 1).U = s(VC + 1) / MDLA.TexSize(tex).x
                .TC(vi + 2).U = s(VC + 2) / MDLA.TexSize(tex).x
                .TC(vi).V = t(VC) / MDLA.TexSize(tex).y
                .TC(vi + 1).V = t(VC + 1) / MDLA.TexSize(tex).y
                .TC(vi + 2).V = t(VC + 2) / MDLA.TexSize(tex).y
                'Debug.Print .Vertex(vi), .Vertex(vi + 1), .Vertex(vi + 2)
                vi = vi + 3
              Next VC
            End With
           
           End If
            
          Loop Until NV = 0
        Next a
   
       End If
     Next N
     End With
  Next i
  
Group:
  'Get Sequence Groups (to see if we have external anim to load)
   ReDim MDLA.SeqGrp(Hdr.NumSeqGroups - 1)
   ReDim Preserve MDLA.f(Hdr.NumSeqGroups - 1)
   Seek #1, Hdr.SeqGroupIndex + 1
   
   For i = 0 To Hdr.NumSeqGroups - 1
     Get #1, , MDLA.SeqGrp(i)
     If i > 0 Then
      Dim FilMod As String
      FilMod = Left(MDLA.Filename, Len(MDLA.Filename) - 4) + Format(i, "00") + ".mdl"
      TestPAKFile FilMod
      Open FilMod For Binary As 2
       'get the entire file
       ReDim Preserve MDLA.f(i).b(LOF(2))
       Get #2, 1, MDLA.f(i).b()
      Close 2
      DeletePAKTemp FilMod
     End If
   Next i
   If Hdr.NumSeqGroups > 1 Then
   End If
    
      'Get sequences
    ReDim MDLA.Seq(Hdr.NumSeq - 1)
    ReDim MDLA.Anim(0)
    Seek #1, Hdr.seqindex + 1
    nf = 0: nac = 0
    For i = 0 To Hdr.NumSeq - 1
      ReDim MDLA.Anim(0).Bones(Hdr.NumBones)
      Get #1, , MDLA.Seq(i)
 
    Next i
  
 Close #1
  MDLA.KeyFrame = 1
  MDLA.Sequence = 1
  MDLA.OldTime = GetTickCount

  
  Exit Function
  
ErrorTreat:
 'AddLog "Error in LoadMainMDL " + CStr(Err.Description) + " " + CStr(Err.Number)

 Resume Next
 End Function

Private Sub OpenMD2File(Filename As String)
  Dim i As Long, j As Long, numv As Long, nump As Long, numf As Long, numa As Long
  Dim last As String, Start As Long, Canim As String
  Dim Skins() As String * 64
  Dim BufferV() As Byte
  Dim Light As Integer, Light2 As Integer, Light3 As Integer
  Dim Tri As MD2Triangle
  Dim frame As MD2AliasFrame
  Dim Zero As Long
  AddLog "MD2 Loader"
  Open Filename For Binary As 1
  Get #1, , MD2.Header
  
  numf = MD2.Header.Num_frames
  numv = MD2.Header.Num_Vertex
  nump = MD2.Header.Num_tris
  MDLA.Speed = 1
  'Load skins filename
  ReDim Skins(MD2.Header.Num_Skins)
  If MD2.Header.Num_Skins > 0 Then
   Get #1, MD2.Header.Ofs_Skins + 1, Skins
  End If
  With MD2
    ReDim .TexCoord(.Header.Num_TexCoords)
    ReDim .TexCoord2(.Header.Num_TexCoords)
    Get #1, MD2.Header.Ofs_TextCoords + 1, .TexCoord()
    'Fix the integer prob
    For i = 0 To .Header.Num_TexCoords - 1
      .TexCoord2(i).s = .TexCoord(i).s / .Header.SkinWidth
      .TexCoord2(i).t = .TexCoord(i).t / .Header.SkinHeight
    Next i
    
    ReDim .Triangle(.Header.Num_tris)
    Get #1, MD2.Header.Ofs_Tris + 1, .Triangle()
    ReDim .Frames(.Header.Num_frames)
    Seek #1, MD2.Header.Ofs_frame + 1
    For i = 0 To .Header.Num_frames - 1
      ReDim .Frames(i).vertices(.Header.Num_Vertex)
      ReDim BufferV(.Header.FrameSize - 1)
      Get #1, , BufferV
      CopyMemory frame, BufferV(0), .Header.FrameSize
      Zero = InStr(frame.Name, Chr(0))
      .Frames(i).Name = Left(frame.Name, Zero - 1)
      For j = 0 To .Header.Num_Vertex - 1
        .Frames(i).vertices(j).V.x = frame.Verts(j).V(0) * frame.ScaleM(0) + frame.TranslateM(0)
        .Frames(i).vertices(j).V.y = frame.Verts(j).V(1) * frame.ScaleM(1) + frame.TranslateM(1)
        .Frames(i).vertices(j).V.z = frame.Verts(j).V(2) * frame.ScaleM(2) + frame.TranslateM(2)
      Next j
    Next i
    Debug.Print
  
 
   Close #1

  'Transform triangles to triangle list usable by Direct3D.Device
  j = 0
  
  ReDim .VIndexes(nump * 3)
  ReDim .TIndexes(nump * 3)
  
  For i = 0 To nump - 1
      .VIndexes(j) = .Triangle(i).Vertex(0)
      .VIndexes(j + 1) = .Triangle(i).Vertex(1)
      .VIndexes(j + 2) = .Triangle(i).Vertex(2)
      
      .TIndexes(j) = .Triangle(i).St(0)
      .TIndexes(j + 1) = .Triangle(i).St(1)
      .TIndexes(j + 2) = .Triangle(i).St(2)
      
      j = j + 3
  Next i
  
ModelType = 2

  ReDim .Anim(0)
  numa = 0
  'Get animations :
  last = Left(.Frames(0).Name, Len(.Frames(0).Name) - 2)
  Start = 0
  For i = 1 To .Header.Num_frames - 1
     Canim = Left(.Frames(i).Name, Len(.Frames(i).Name) - 2)
     If Canim <> last Or i = .Header.Num_frames - 1 Then
       .Anim(numa).Name = last
       .Anim(numa).Start = Start
       .Anim(numa).End = i
       Start = i + 1
       last = Canim
       numa = numa + 1
       ReDim Preserve .Anim(numa)
     End If
  Next i

  'set the "all" animations
  .StartFrame = 0
  .EndFrame = .Header.Num_frames - 1
End With


End Sub


Private Sub LoadMDLTextureFile()
 Dim TextureFile As String
 On Error GoTo textureerror
 '
    ' Here we'll load the [Name]T.MDL texture model
    ' This file has also a header so we use it
    '
    TextureFile = Left(MDLA.Filename, Len(MDLA.Filename) - 4) + "t.mdl"
    AddLog "Load External texture file in MDL " + TextureFile
    Debug.Print "Load external texture file"
    Dim TextureHeader As StudioHeader
    TestPAKFile TextureFile
    Open TextureFile For Binary Lock Read As 2
       Get #2, , TextureHeader
    
       'and we start loading textures with this header
        LoadMDLTextures 2, TextureHeader
    Close #2
    DeletePAKTemp TextureFile
    'and it's all !
    Exit Sub
textureerror:
    AddLog "MDL Texture loading error..." + Err.Description + " " + CStr(Err.Number)
    
    Resume Next
End Sub

Private Sub LoadMDLTextures(nf, Hdr2 As StudioHeader)
  'Load all textures headers
  Dim i As Long, hdc As Long, x As Long, y As Long, d As Long, a As Long, newt As Long, offset As Long, offset1 As Long
  ReDim MDLA.TexHeader(Hdr2.NumTextures - 1)
  
  Seek #nf, Hdr2.TextureIndex + 1
  For i = 0 To Hdr2.NumTextures - 1
    Get #nf, , MDLA.TexHeader(i)
  Next i
  
  'This is a little cheat but it's very fast !
  'We'll use SetPixel and GetLockedPixel to get DirectDraw colors !
  'and we'll stretch to the next power of 2
  
  'Create a temporary surface
'  Dim TempSurface As DirectDrawSurface7

  
  'convert texture to 16 bits textures in order to load it in memory
  
  Dim Palette(256 * 3) As Byte
  Dim by(512) As Byte
  Dim Data() As Byte, TData() As Byte
  Dim CWidth As Long, CHeight As Long
  
  ReDim MDLA.TextureOffset(Hdr2.NumTextures)
  ReDim MDLA.TexSize(Hdr2.NumTextures)
  
  For i = 0 To Hdr2.NumTextures - 1
    AddLog "Load texture : " + MDLA.TexHeader(i).Name
    MDLA.TexSize(i).x = MDLA.TexHeader(i).width
    MDLA.TexSize(i).y = MDLA.TexHeader(i).height
     
   'load texture data
   ReDim Data(MDLA.TexHeader(i).width * MDLA.TexHeader(i).height)
   ReDim TData(MDLA.TexHeader(i).width * MDLA.TexHeader(i).height * 2)
   Get #nf, MDLA.TexHeader(i).Index + 1, Data()
   
   'load the palette
   Get #nf, MDLA.TexHeader(i).Index + MDLA.TexHeader(i).width * MDLA.TexHeader(i).height + 1, Palette()
   
   'convert the palette to 16bits integer values.
   offset1 = 0
   offset = 0
   For x = 0 To 255
      by(offset1 + 1) = (Palette(offset) And &HF8) Or (Palette(offset + 1) And &HE0) \ 32
      by(offset1) = (Palette(offset + 1) And &H1C) * 8 Or (Palette(offset + 2) And &HF8) \ 8
      offset1 = offset1 + 2
      offset = offset + 3
    Next x
    
   'Create a surface in memory
   offset = 0
   For y = 0 To MDLA.TexHeader(i).height - 1
     For x = 0 To MDLA.TexHeader(i).width - 1
      d = Data(offset)
      TData(offset * 2) = by(d * 2)
      TData(offset * 2 + 1) = by(d * 2 + 1)
      offset = offset + 1
    Next x
   Next y
 '
   
    CWidth = MDLA.TexHeader(i).width
    CHeight = MDLA.TexHeader(i).height
    
    If CWidth < 8 Then CWidth = 8
    If CHeight < 8 Then CHeight = 8
    
    Dim Format As Long
    Format = 23
    
    D3DX.CheckTextureRequirements Device, CWidth, CHeight, 1, 0, Format, D3DPOOL_DEFAULT
    
    'Create the texture from the surface memory
    Dim TempTexture As Direct3DTexture8
    Set TempTexture = Device.CreateTexture(CWidth, CHeight, 1, 0, Format, D3DPOOL_DEFAULT)
    Dim C As Direct3DSurface8
    Set C = Device.CreateImageSurface(CWidth, CHeight, D3DFMT_R5G6B5)
    D3DX.LoadSurfaceFromMemory C, ByVal 0, ByVal 0, TData(0), D3DFMT_R5G6B5, MDLA.TexHeader(i).width * 2, ByVal 0, REC(0, 0, MDLA.TexHeader(i).width, MDLA.TexHeader(i).height), D3DX_DEFAULT, 0
    Device.CopyRects C, ByVal 0, 0, TempTexture.GetSurfaceLevel(0), ByVal 0
   
    Dim NewInd As Long
    NewInd = LocTexFactory.GetNewTextureIndex
    Set Textures(NewInd).TexSurf = TempTexture
    Set TempTexture = Nothing
   
   MDLA.TextureOffset(i) = NewInd
   
  Next i

End Sub

Private Sub RefreshMesh(MeshI As Integer)
    Dim i As Long
     With MDLA.AnimationStatus
      .NbBones = UBound(MDLA.Bones)
      ReDim .Bones(.NbBones)
      For i = 0 To .NbBones - 1
        .Bones(i).Name = MDLA.Bones(i).Name
        .Bones(i).Parent = MDLA.Bones(i).Parent
        .Bones(i).Pos = Vector(MDLA.Bones(i).value(0), MDLA.Bones(i).value(1), MDLA.Bones(i).value(2))
        .Bones(i).Rot = Vector(MDLA.Bones(i).value(3), MDLA.Bones(i).value(4), MDLA.Bones(i).value(5))
      Next i
    End With
      GetSequence 1
 End Sub


Sub EnableShadowing(OnOff As Boolean)
   '##BD Enables the MDL shadowing for this model
   '##PD Enable/Disable
  ' MDLA.MeshF.Shadowing = OnOff
End Sub


Private Sub CalcControllers()
 On Error Resume Next
  Dim i As Long, C As Long, value As Single
   
  For i = 0 To UBound(MDLA.ControllerBone)
      With MDLA.ControllerBone(i)
       C = .Index
       If C <= 3 Then
         'If .Type And 32768 Then
          value = MDLA.ControllerValue(i) * (360 / 256) + .Start

         'Else
          value = MDLA.ControllerValue(i) / 255
          If value < 0 Then value = 0
          If value > 1# Then value = 1
          value = (1# - value) * .Start + value * .End
         'End If
       Else
        'mouth
        value = MDLA.ControllerValue(i) / 64
        If value > 1 Then value = 1
        value = (1 - value) * .Start + value * .End
       End If
       
       
        If (.Type And STUDIO_XR) Or (.Type And STUDIO_YR) Or (.Type And STUDIO_ZR) Then
          MDLA.MAdj(i) = value * PI
        End If
        If (.Type And studio_x) Or (.Type And STUDIO_Y) Or (.Type And STUDIO_Z) Then
         MDLA.MAdj(i) = value
        End If
   
       
      End With
  Next i
  
End Sub
Public Function GetBodyPartFromName(BodyPartName As String) As Integer
  '##BD Get the bodypart index from its name
  '##PD BodyPartName Bodypart name (no case-sensitive)
  Dim i As Long
  For i = 0 To UBound(MDLA.BP)
     If UCase(BodyPartName) = UCase(MDLA.BP(i).BodyP.Name) Then
      GetBodyPartFromName = i
      Exit Function
     End If
  Next i
  GetBodyPartFromName = -1 'No found
End Function
Public Function GetFrame() As Single
   '##BD Get the current animation keyframe
   If ModelType = 1 Then
   GetFrame = MDLA.KeyFrame
   Else
   If ModelType = 2 Then
     GetFrame = MD2.CurrentFrame
   Else
     GetFrame = MD3.CurrentFrame
   End If
   End If
End Function

Public Function GetModelFromName(BodyPart As Integer, ModelName As String) As Integer
   '##BD Get the model index from its name in the specified bodypart.
   '##PD BodyPart Bodypart index
   '##PD ModelName Model name
   Dim i As Long
   For i = 0 To UBound(MDLA.BP(BodyPart).Model)
     If UCase(ModelName) = UCase(MDLA.BP(BodyPart).Model(i).Name) Then
      GetModelFromName = i
      Exit Function
     End If
  Next i
  GetModelFromName = -1 'No found
End Function


Function GetModelInfo() As MDLModelInfo
  '##BD Returns information about the model file (sequences name, FPS, numframe)
  Dim i As Long, a As Long
  On Error Resume Next
  'for MDL
  If ModelType = 1 Then
  With GetModelInfo
    .ModelType = 1
    .NumSequences = UBound(MDLA.Seq) + 1
    ReDim .Sequences(.NumSequences)
    For i = 0 To .NumSequences - 1
      .Sequences(i).FPS = MDLA.Seq(i).FPS
      .Sequences(i).NumFrames = MDLA.Seq(i).NumFrames
      .Sequences(i).Name = Trim(MDLA.Seq(i).Name)
    Next i
    .NumBoneControllers = UBound(MDLA.ControllerBone) + 1
    .NumBodyPart = UBound(MDLA.BP) + 1
     For i = 0 To UBound(MDLA.ControllerValue)
      If MDLA.ControllerBone(i).Index > 3 Then
        .MouthController = True
      End If
     Next i
     ReDim .BodyParts(.NumBodyPart)
     For i = 0 To .NumBodyPart - 1
       .BodyParts(i).BodyPartName = Trim(MDLA.BP(i).BodyP.Name)
       .BodyParts(i).NumSubModels = MDLA.BP(i).BodyP.NumModels
       ReDim .BodyParts(i).SubModels(.BodyParts(i).NumSubModels)
       For a = 0 To .BodyParts(i).NumSubModels - 1
         .BodyParts(i).SubModels(a).ModelName = Trim(MDLA.BP(i).Model(a).Name)
         .BodyParts(i).SubModels(a).NumMeshes = MDLA.BP(i).Model(a).NumMesh
       Next a
     Next i

  End With
  Else
   If ModelType = 2 Then
   With GetModelInfo
     .ModelType = 0
     .NumSequences = UBound(MD2.Anim)
     .MouthController = False
     .NumBodyPart = 1
     .NumBoneControllers = 0
     ReDim .Sequences(.NumSequences)
     For i = 0 To .NumSequences - 1
        .Sequences(i).Name = MD2.Anim(i).Name
        .Sequences(i).NumFrames = MD2.Anim(i).End - MD2.Anim(i).Start
     Next i
    End With
    Else
    With GetModelInfo
       .NumSequences = 1
       .NumBodyPart = 0
       .NumBoneControllers = 0
       ReDim .Sequences(1)
       .Sequences(0).NumFrames = MD3.Surfaces(0).NumFrames
    End With
    End If
  End If
End Function

Public Function GetModelMesh() As Mesh8
  '##BD Use this returned mesh in Camera functions where the argument is a mesh object.
  CopyMemory Mesh(ModelMesh).Features, MDLA.MeshF, Len(MDLA.MeshF)
  Mesh(ModelMesh).Matrix = MDLA.Matrix
  Set GetModelMesh = Mesh(ModelMesh).Object
End Function


Public Sub Load(Filename As String, Optional LoadTextures As Boolean = True)
    '##BD This method loads a MDL, a MD2 file or a MD3 file in the current class.
    '##PD filename MDL/MD2/MD3 filename
    '##PD LoadTextures Enable/Disable textures loading.
    
    'Load the model file (use MDLFileModule)
    TestPAKFile Filename
    LoadMainMDL Filename
    DeletePAKTemp Filename
    
    'only for MDL (HalfLife)
    If ModelType = 1 Then
      RefreshMDL
    End If
End Sub


Friend Sub RefreshMDL()
  If MDLA.Filename = "" Then Exit Sub
  
  RefreshMesh ModelMesh
End Sub

Public Sub Render()
  '##BD Render the MDL actor at the current position. <b><i>Note :</i>You have to load a MDL file before calling this function.</b>
  If ModelType = 1 Then  'Half Life MDL
    
    MDLUpdateAnimation ModelMesh, MDLA
  ElseIf ModelType = 2 Then 'Quake 2 MD2
    MD2UpdateAnimation
  Else
    MD3UpdateAnimation
  End If
End Sub
Sub AttachTo(Actor As Actor8, AttachmentPoint As Integer)
    '##BD Attachs a model to another one. This methods works only on MDL and MD3. You need to set
    '##PD Actor The Parent Actor
    '##PD AttachmentPoint The Tags index for a MD3 or a attachpoint point for a MDL
    If ModelType = 1 Then
     Actor.SetAttachPoint ActIndex, AttachmentPoint
     MDLA.AttachPoint = AttachmentPoint
     MDLA.AttachMesh = Actor.GetActorIndex
    Else
     Actor.SetAttachPoint ActIndex, AttachmentPoint
     MD3.AttachBone = AttachmentPoint
     MD3.Attach = Actor.GetActorIndex
    End If
End Sub


Public Sub SetModelInBodyPart(BodyPart As Integer, Model As Integer)
  '##BD <b> ONLY FOR MDL FILES </b> MDL bodypart can contain several model. This method allows you to change a model in a specified bodypart.
  '##PD BodyPart BodyPart index
  '##PD Model Model index
  If ModelType = 1 Then
   If BodyPart > UBound(MDLA.BP) Then Exit Sub
   MDLA.BP(BodyPart).ModelSelect = Model
   RefreshMDL
  End If
End Sub
Sub SetMouthController(value As Single)
  '##BD <b> ONLY FOR MDL FILES </b> Set the mouth opening. Useful for simulating speaking.
  '##PD value Mouth opening value (0: closed mouth, 64:very open mouth)
  Dim i As Integer
  If ModelType = 1 Then
  For i = 0 To UBound(MDLA.ControllerValue)
   If MDLA.ControllerBone(i).Index > 3 Then
      SetProgrammicController i, value
   End If
  Next i
  End If
End Sub

Public Sub SetPosition(x, y, z)
  '##BD Set the actor postion in the 3D world
  '##PD x X coordinate
  '##PD y Y coordinate
  '##PD z Z coordinate
  
  MDLA.MeshF.Settings.Position = Vector(x, y, z)
  MDLA.MeshF.Settings.Changed = True
End Sub

Sub SetProgrammicController(Index As Integer, value As Single)
  '##BD <b> ONLY FOR MDL FILES </b> A MDL Actor can have programmic controllers. They allow you to move the actor head, to turn it in a direction etc... This method set the controller value for the specified bone controller.
  '##PD Index Bone controller index.
  '##PD value New bone controller value (0-256)
  If ModelType = 1 Then
   If UBound(MDLA.ControllerBone) >= Index Then
  MDLA.ControllerValue(Index) = value
  End If
  End If
End Sub
Sub SetRotation(x, y, z)
 '##BD Set the actor rotation around the three axis.
 '##PD x Rotation in degrees around the x-axis
 '##PD y Rotation in degrees around the y-axis
 '##PD z Rotation in degrees around the z-axis
 MDLA.MeshF.Settings.Rotation = Vector(x, y, z)
 MDLA.MeshF.Settings.Changed = True
End Sub
Sub SetScale(x, y, z)
 '##BD This function allows to scale your actor on the 3 axis.
 '##PD x Scale factor on the x-axis
 '##PD y Scale factor on the y-axis
 '##PD z Scale factor on the z-axis
 
 MDLA.MeshF.Settings.Scaling = Vector(-x, y, -z)
  MDLA.MeshF.Settings.Changed = True
End Sub


Public Sub SetSpeed(Speed As Single)
   '##BD Set the current animation speed (0=stop, 1=normal speed, 5=very fast)
   '##PD Speed Animation speed (0-5)
   MDLA.Speed = Speed
   
End Sub


Public Sub SetAnimation(AnimationIndex As Integer)
   '##BD Set the sequence index that will be rendered.
   '##PD AnimationIndex Sequence index.
   'LoadMDLSequence AnimationIndex, MDLA
   If ModelType = 1 Then
    MDLA.Sequence = AnimationIndex
    MDLA.KeyFrame = 1
    GetSequence AnimationIndex
   Else
    SearchAnimFrames AnimationIndex
   End If
End Sub
Public Sub SetAnimationName(AnimationName As String)
   '##BD Set the animation name that will be rendered. <b><i>Note :</i> If the corresponding animation isn't found, the default animation will be selected.</b>
   '##PD AnimationName Animation name to select.
   Dim i As Integer
   If ModelType = 1 Then
    For i = 0 To UBound(MDLA.Seq) - 1
      If InStr(UCase(MDLA.Seq(i).Name), UCase(AnimationName)) > 0 Then
         SetAnimation i
        Exit Sub
       End If
     Next i
   Else
      For i = 0 To UBound(MD2.Anim) - 1
      If InStr(UCase(MD2.Anim(i).Name), UCase(AnimationName)) > 0 Then
         SetAnimation i
        Exit Sub
       End If
     Next i
  
   End If
   
End Sub


Private Sub Class_Initialize()
  Dim i As Long
  Dim MDLMs As Mesh8
  Set MDLMs = LocalScene.CreateMeshBuilder("MDL")
  ModelMesh = MDLMs.GetMeshIndex
  MDLMs.ScaleMesh 1, 1, 1
  MDLA.MeshF.Settings.Changed = True
  MDLA.MeshF.Settings.Scaling.x = -1
  MDLA.MeshF.Settings.Scaling.z = -1
  NbActors = NbActors + 1
  MD3.Attach = -1
  MDLA.AttachMesh = -1
  ReDim Preserve LocalActors(NbActors)
  Set LocalActors(NbActors) = Me
  ActIndex = NbActors
End Sub


Private Sub Class_Terminate()
  Set MeshO = Nothing
  Mesh(ModelMesh).Active = False
  Set LocalActors(ActIndex) = Nothing
End Sub


