VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "MaterialFactory8"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'----------------------
' Material Factory
'----------------------


Private LocalClass As Boolean
' Started 17/11/00

Public Function CreateMaterial(Optional Name As String = "") As Integer
  For i = 1 To NBMaterial
     If Materials(i).Enabled = False Then
       Exit For
     End If
  Next i
  
  If i = NBMaterial + 1 Then
    ReDim Preserve Materials(i)
    NBMaterial = NBMaterial + 1
  End If
  
  Materials(i).Enabled = True
  Materials(i).MaterialName = IIf(Name = "", "Material" + CStr(i), Name)
  Materials(i).Mat.Ambient = DXColor(1, 1, 1, 1)
  Materials(i).Mat.Diffuse = DXColor(1, 1, 1, 1)
  Materials(i).Mat.emissive = DXColor(1, 1, 1, 1)
  Materials(i).Mat.Specular = DXColor(1, 1, 1, 1)
  Materials(i).Mat.power = 1
  CreateMaterial = i
  
End Function

Function CreateMaterialQuick(r As Single, g As Single, B As Single, a As Single, MaterialName As String) As Integer
  CreateMaterialQuick = CreateMaterial(MaterialName)
  SetAmbient CreateMaterialQuick, r, g, B, a
  SetDiffuse CreateMaterialQuick, r, g, B, a
  SetEmissive CreateMaterialQuick, r, g, B, a
End Function

Public Sub DeleteMaterial(MaterialIndex As Integer)
   Materials(MaterialIndex).Enabled = False
End Sub

Public Sub SetAmbient(MaterialIndex As Integer, r As Single, g As Single, B As Single, a As Single)
   With Materials(MaterialIndex)
      .Mat.Ambient = DXColor(r, g, B, a)
   End With
End Sub
Public Sub SetDiffuse(MaterialIndex As Integer, r As Single, g As Single, B As Single, a As Single)
   With Materials(MaterialIndex)
      .Mat.Diffuse = DXColor(r, g, B, a)
   End With
End Sub

Sub SetLocal()
   LocalClass = True
End Sub

Friend Sub SetMat8(MatIndex As Integer, Mat As D3DMATERIAL8)
   Materials(MatIndex).Mat = Mat
End Sub

Public Sub SetSpecular(MaterialIndex As Integer, r As Single, g As Single, B As Single, a As Single)
   With Materials(MaterialIndex)
      .Mat.Specular = DXColor(r, g, B, a)
   End With
End Sub

Public Sub SetEmissive(MaterialIndex As Integer, r As Single, g As Single, B As Single, a As Single)
   With Materials(MaterialIndex)
      .Mat.emissive = DXColor(r, g, B, a)
   End With
End Sub
Public Sub SetPower(MaterialIndex As Integer, power As Single)
   With Materials(MaterialIndex)
      .Mat.power = power
   End With
End Sub

Private Sub Class_Initialize()
  'Class already initialized in TrueVision Initialize
End Sub


Private Sub Class_Terminate()
 If LocalClass = False Then
  
 End If
End Sub


