Attribute VB_Name = "mai"
Dim tv As New TrueVision8
Dim Inp As New InputEngine8


Public Scene As New Scene8
Public TexFactory As New TextureFactory8
Public MatFactory As New MaterialFactory8
Public Effects As New GraphicEffect8
Public Particle As New ParticleSystem8
Public Land As New Landscape8
'Public Light As New LightEngine8

Public Camera As New Camera8

Public Car As Mesh8

Dim Room As Mesh8

Public V1 As D3DVECTOR
Public V2 As D3DVECTOR
Public v3 As D3DVECTOR
Public MeshE As Mesh8
Public blended As Mesh8


Public Sub Main60()

  'Initialize a Windowed mode TrueVision

    Set tv = New TrueVision8
    Set Scene = New Scene8
    Set scr = New Screen8
    Set Land = New Landscape8
  
    tv.EnableHardwareTL True
    'TV.ShowDriverDialog
    tv.Initialize IntForm.hwnd
    tv.SetSearchDirectory App.Path + " \lensflare"
    
  
    'Init Input engine
    Set Inp = New InputEngine8
  
    'Set the background color
    Scene.SetSceneBackGround 0.4, 0.7, 0.8
    Scene.SetViewFrustum 90, 6000
    
    '-----------------------------
    ' LOAD THE LANDSCAPE
    '-----------------------------
    Land.SetFactorY 0.4
    Land.GenerateHugeTerrain "land_map.jpg", TV_PRECISION_AVERAGE, 4, 4, 0, 0, True
    
    
    'Load the terrain texture
    
    TexFactory.LoadTexture "map_preview.jpg", "TerrainTex"
    TexFactory.LoadTexture "detail.jpg", "Details"
    TexFactory.LoadTexture "light_map.jpg", "Shadow"
    TexFactory.LoadTexture "top.jpg", "Sky1"
    TexFactory.LoadTexture "left.jpg", "Sky2"
    TexFactory.LoadTexture "right.jpg", "Sky3"
    TexFactory.LoadTexture "front.jpg", "Sky4"
    TexFactory.LoadTexture "back.jpg", "Sky5"
    TexFactory.LoadTexture "water.bmp", "Water"
  
    'and Apply it to the terrain
    Scene.EnableMipMapping True
    Land.SetTexture GetTex("TerrainTex")
    Land.SetDetailTexture GetTex("Details")
    'Land.SetCustomLightMap GetTex("Shadow")
    Land.SetDetailTextureScale 6, 6
    Land.SetWaterEnable True
    Land.SetWaterEffect True, 0.5, True, , , True
    Land.SetWaterAltitude 40
    Land.SetWaterTexture GetTex("Water")
    Land.SetWaterTextureScale 16
     Scene.SetSkyTexture GetTex("Sky5"), GetTex("sky3"), GetTex("sky2"), GetTex("sky4"), GetTex("sky1"), GetTex("sky1"), 3000
Dim io As New InternalObjects8
    io.GetDevice3D.SetTextureStageState 1, D3DTSS_MAGFILTER, D3DTEXF_POINT
    io.GetDevice3D.SetTextureStageState 1, D3DTSS_MINFILTER, D3DTEXF_POINT
     
    Land.ExpandTexture GetTex("TerrainTex"), 0, 0, 7, 7
    '-------------------------------------
    ' LENS FLARES INITIALIZATION
    '-------------------------------------
    'Load Textures
    TexFactory.LoadTexture "sun.bmp", "Sun", , , TV_COLORKEY_BLACK
    For i = 0 To 4
        TexFactory.LoadTexture "flare" + CStr(i) + ".bmp", "Flare" + CStr(i), , , TV_COLORKEY_BLACK
    Next i
  
    ' You have to initialize a Sun to use Lens Flares
    Land.InitSun GetTex("sun"), Vector(500, 200, 0)
  
    'Init the lens flares
    'Create 8 flares
    'Land.InitLensFlare 8
  
    'And set the properties
    'Land.SetLensFlare FlareIndex, Size, Texture, Position, HighLightColor, NormalColor
    'The position is the flare position on the line between the sun and the camera
    'Land.SetLensFlare 1, 2 * 5, GetTex("Flare4"), 40, RGBA(1, 1, 1, 0.5), RGBA(1, 1, 1, 0.5)
    'Land.SetLensFlare 2, 2 * 1, GetTex("Flare3"), 18, RGBA(1, 1, 1, 0.5), RGBA(1, 1, 1, 0.5)
    'Land.SetLensFlare 3, 2 * 1.8, GetTex("Flare2"), 15, RGBA(1, 1, 1, 0.5), RGBA(0.7, 1, 1, 0.5)
    'Land.SetLensFlare 4, 2 * 1, GetTex("Flare4"), 6, RGBA(1, 0.1, 0, 0.5), RGBA(0.5, 1, 1, 0.5)
    'Land.SetLensFlare 5, 2 * 0.5, GetTex("Flare2"), 2, RGBA(1, 1, 1, 0.5), RGBA(0.5, 1, 1, 0.5)
    'Land.SetLensFlare 6, 2 * 1, GetTex("Flare4"), -4, RGBA(1, 1, 1, 0.5), RGBA(1, 1, 1, 0.5)
    'Land.SetLensFlare 7, 2 * 0.3, GetTex("Flare0"), 0.3, RGBA(1, 1, 1, 0.51), RGBA(0.5, 1, 1, 0.5)
    'Land.SetLensFlare 8, 2 * 0.2, GetTex("Flare1"), -7, RGBA(1, 1, 1, 0.5), RGBA(0.5, 1, 1, 0.5)
  
    'Start position :
    PosX = 256
    PosZ = 256
  
    'Game loop
    Do
        tv.Clear
    
        'Render the landscape
        Scene.RenderSky
        Land.Render
    
        'Render the lens flare at the end of the rendering
'        Land.RenderLensFlare
    
        If Inp.IsKeyPressed(TV_KEY_S) = True Then tv.ScreenShot "c:\key.bmp" ':( Expand Structure
        tv.RenderToScreen
    
        'Input management
        Pos
    Loop Until Inp.IsKeyPressed(TV_KEY_ESCAPE) = True ':( Remove Pleonasm
  
    Set tv = Nothing
    Unload Form1
  
End Sub


 Sub Main17()
 '1. Show the form in that the scene will be rendered.
    'Form1.Show
    Dim LightId As Integer
    tv.DisplayFPS = True
    Dim Light As New LightEngine8
    '2. Initialize the engine in windowed mode.
    '   Note that you have to use the Hwnd of the desired form or picturebox
    tv.Initialize IntForm.hwnd
    
    '2b. Defines the data directory. Usually it's the application path
    tv.SetSearchDirectory App.Path
    
    '3. Create the room
    '3a : Create the mesh from the scene object
    Set MeshE = Scene.CreateMeshBuilder("Room")
    
    '3b : Add the walls to the room using the Mesh8.AddWall method
    '     We will set the texture later...
    '     Note that you should subdivide your too big faces so that
    '     Direct3D Lighting works better
    '     Here we have divided the room box in 10
    For i = 0 To 19
     MeshE.AddWall Nothing, -10, i * 5, -10, i * 5 + 5, 20
     MeshE.AddWall Nothing, 10, i * 5 + 5, 10, i * 5, 20
     MeshE.AddFloor Nothing, -10, i * 5, 10, i * 5 + 5, 0
     MeshE.AddFloor Nothing, -10, i * 5, 10, i * 5 + 5, 20
    Next i
     
     MeshE.AddWall Nothing, -10, 100, 10, 100, 20
     MeshE.AddWall Nothing, -10, 0, 10, 0, 20
            
    '3d : Load a brick texture. Note that TrueVision can load
    '     BMP, JPG, DDS, PNG, GIF picture files.
    Scene.LoadTexture "brick1.bmp", , , "BrickTexture"
    
    '3e : Apply the texture to the room
    MeshE.SetTexture GetTex("BrickTexture")
    
    '4 : Set the camera startpos
    Camera.SetCameraPosition 0, 10, 0
    Camera.SetCameraLookAt 0, 10, 1
    
    '5 ------------------------
    '  Lighting setup
    '--------------------------
    ' 1 : Use normal vertex for lightning.
    '     You MUST use this kind of vertexs.
    MeshE.SetVertexType TV_NORMAL_VERTEX
    
    ' 2 : Create a material for the corridor
    ' When you create a material with Quick function
    ' the given color is attribued to Ambient lighting
    ' (color without light) and (color with light)
    MatFactory.CreateMaterialQuick 0.2, 0.2, 0.2, 1, "Mat"
    
    'Then you have to set the diffuse color
    'Usually 1,1,1,1
    MatFactory.SetDiffuse GetMat("Mat"), 1, 1, 1, 1
    
    'Apply it to the corridor
    MeshE.SetMaterial GetMat("Mat")
    
    '3 Then let's compute the face normals
    '  so that the light engine computes the reflection vector.
    MeshE.ComputeNormals
    
    '4 Create the point light and get the Light ID
    '  NOTE You must give very high color values
    '  The Radius is the distance where the light doesn't lit anything more
    LightId = Light.CreatePointLight(Vector(0, 10, 10), 30, 0, 300, 0, 1)
    Light.SetLightAttenuation LightId, 1, 0, 0
    'Light.SetLightFalloff LightID, 0.5
    
    '------------------------------
    ' Alpha Blended Stuff
    '------------------------------
    ' For Alpha blended face, we needn't use lighting
    ' so let's use COLOR_VERTEX
    
    '1. Create the mesh
    Set blended = Scene.CreateMeshBuilder("Blended")
    
    '2. Set the vertex format
    blended.SetVertexType TV_COLOR_VERTEX
    
    '3. Set the blending mode. The ALPHA blending mode is selected by default
    'but you can choose other mode with the SetAlphaBlendingMode function.
    blended.SetBlendingMode TV_BLEND_ALPHA
    
    '4. Create the wall
    blended.AddWall GetTex("BrickTexture"), -10, 50, 10, 50, 20
    
    '5. Set the alpha factor of the mesh. Here we use 0.5
    ' Note you can apply a texture too.
    blended.SetColor RGBA(1, 0, 0, 0.2)
    
    'Remarks : If you need to work with materials and alphablending,
    '          you have to set the SAME alpha blending factor in the
    '          different material color values.
    
    
    'The main game loop :
    Dim a As Single
    Do
      'Clear the screen. You must do this before rendering anything on the screen.
      tv.Clear
      
      'Call the room rendering method
      Scene.RenderAllMeshes
      
      'Render everything on the screen
      tv.RenderToScreen
      
     'Move the light
      'a = a + tv.TimeElapsed * 0.001
      If b = 0 Then
      a = a + 5
      If a > 1000 Then
       b = 1
      End If
      Else
      a = a - 5
      If a < 0 Then
       b = 0
      End If
     End If
      Light.SetLightRadius LightId, a
      Light.SetLightPosition LightId, Vector(0, 10, 10)
      
      'Move the scene according to the keyboard presses.
      
      If Inp.IsKeyPressed(TV_KEY_UP) = True Then Camera.MoveForward 20
      If Inp.IsKeyPressed(TV_KEY_DOWN) = True Then Camera.MoveForward -20
      If Inp.IsKeyPressed(TV_KEY_RIGHT) = True Then Camera.RotateCameraY -60
      If Inp.IsKeyPressed(TV_KEY_LEFT) = True Then Camera.RotateCameraY 60
      
    'Check the Escape Key that ends up the tutorial
    Loop Until Inp.IsKeyPressed(TV_KEY_ESCAPE) = True
    
    'Don't forget to shut down the engine
    Set tv = Nothing
    
End Sub


Function GetMat(MaterialName As String) As Integer
  'Macro for Getting materials
  For i = 1 To NBMaterial
     If UCase$(MaterialName) = UCase$(Materials(i).MaterialName) Then
       GetMat = i
       Exit Function
     End If
  Next i
  GetMat = 0
End Function


Public Function GetIntersection(s As D3DVECTOR, E As D3DVECTOR, P As D3DVECTOR, o As Single, i As D3DVECTOR)
 Dim Dir As D3DVECTOR
 Dim Po As Single
 Dim Dot As Single, Dist As Single
 Dim V1 As D3DVECTOR
 Dir = VSubtract(E, s)
 Dot = D3DXVec3Dot(Dir, P)
  If Abs(Dot) < 0.001 Then
    'The direction is in the same plane
    GetIntersection = False
    Exit Function
  End If
V1 = VSubtract(VScale(P, -o), s)
Dist = D3DXVec3Dot(V1, P)
Po = Dist / Dot
If Po < 0 Then GetIntersection = False: Exit Function
If Po > 1 Then GetIntersection = False: Exit Function
i.x = s.x + Dir.x * Po
i.y = s.y + Dir.y * Po
i.z = s.z + Dir.z * Po
GetIntersection = True
End Function


Function CreateMirrorEffect(MeshWall As Mesh8, width As Long, height As Long) As RenderSurface8
  Set CreateMirrorEffect = LocalScene.CreateRenderSurface(width, height, True)
  MeshWall.SetTexture CreateMirrorEffect.GetTexture
  Dim V1 As D3DVECTOR, V2 As D3DVECTOR
  Dim VC As D3DVECTOR, NV As D3DVECTOR
  Dim Ind As Integer
  Ind = MeshWall.GetMeshIndex
  
  With Mesh(Ind).Features
    For i = 1 To .NbVertex
        VC = VAdd(VC, Vert(.Vertex(i - 1)))
    Next i
    VC = VScale(VC, 1 / .NbVertex)
    V1 = VNormalize(VSubtract(Vert(.Vertex(1)), Vert(.Vertex(0))))
    V2 = VNormalize(VSubtract(Vert(.Vertex(2)), Vert(.Vertex(0))))
    D3DXVec3Cross NV, V1, V2
   ' NV = VScale(VNormalize(NV), VModulus(VSubtract(Vert(.Vertex(2)), Vert(.Vertex(0)))) * Tan(AngleFOV / 2))
    NV = VScale(VNormalize(NV), 1)
   
   ' VC = VSubtract(VC, NV)
  End With
  Debug.Print VC.x, VC.y, VC.z
  CreateMirrorEffect.SetCamera VC.x, VC.y, VC.z, VC.x + NV.x, VC.y + NV.y, VC.z + NV.z


End Function

Sub Main10()
tv.ShowDriverDialog
    tv.Initialize 'IntForm.hwnd
    IntForm.Show
    Dim PosX As Single, PosY As Single, PosZ As Single, Ang As Single
    
    Dim house As Mesh8
    Set house = Scene.CreateMeshBuilder()
    Dim HouseTexture As Texture8
    tv.SetSearchDirectory App.Path
    Set HouseTexture = LocTexFactory.LoadTexture("tunnel.bmp", "Wood")
   ' M.AddWall GetTex("Wood"), -200, -200, -200, 200, 50, 0
   ' M.AddWall GetTex("Wood"), -200, 200, 200, 200, 50, 0
   ' M.AddWall GetTex("Wood"), 200, 200, 200, -200, 50, 0
   ' M.AddWall GetTex("Wood"), 200, 200, 200, -200, 50, 0
   ' M.AddWall GetTex("Wood"), 200, -200, -200, -200, 50, 0
    'M.AddFloor GetTex("Wood"), -200, -200, 200, 200, 50
    'M.AddFloor GetTex("Wood"), -200, -200, 200, 200, 0
   '
    
    Dim li As New LightEngine8
   ' Li.CreatePointLight Vector(0, 50, 0), 100, 2, 2, 1, 1
   ' Li.CreatePointLight Vector(100, 50, 100), 200, 2, 2, 1, 1
   ' Li.CreatePointLight Vector(-100, 50, -100), 100, 2, 0, 0, 1
    
    Dim lightpos As D3DVECTOR
       lightpos = Vector(-90, 60, -85)
li.CreatePointLight lightpos, 200, 0, 1, 0, 1
        lightpos = Vector(-20, 60, -25)
li.CreatePointLight lightpos, 200, 1, 0, 0, 1


   'create the room
   house.AddWall HouseTexture, -100, 0, -70, 0, 100
   house.AddWall HouseTexture, -70, 0, -70, 70, 100
   house.AddWall HouseTexture, -70, 70, 40, 70, 100
   house.AddWall HouseTexture, 40, 70, 40, 40, 100
   house.AddWall HouseTexture, 40, 40, -40, 40, 100
   
   house.AddWall HouseTexture, -40, 40, -40, 0, 100
   house.AddWall HouseTexture, -40, 0, 0, 0, 100
      
   house.AddWall HouseTexture, 0, 0, 0, -100, 100
   house.AddWall HouseTexture, 0, -100, -100, -100, 100
   house.AddWall HouseTexture, -100, -100, -100, 0, 100
   
   house.AddWall HouseTexture, -50, -50, -50, -60, 50
   house.AddWall HouseTexture, -50, -60, -60, -60, 50
   house.AddWall HouseTexture, -60, -60, -60, -50, 50
   house.AddWall HouseTexture, -60, -50, -50, -50, 50
   
   
   house.AddFloor HouseTexture, -70, 0, -40, 40
   house.AddFloor HouseTexture, 0, -100, -100, 0
   house.AddFloor HouseTexture, -70, 70, -20, 40
   house.AddFloor HouseTexture, -20, 70, 40, 40
   house.AddFloor HouseTexture, -100, -100, 40, 70, 100
     
   house.GenerateLightMap 8, True
   house.SaveLightmaps "lightmap.lm"
    Do
   
   tv.Clear
   house.Render
   tv.RenderToScreen
   
   
   If Inp.IsKeyPressed(TV_KEY_1) = True Then
     s.SetRenderMode TV_LINE
   End If
   If Inp.IsKeyPressed(TV_KEY_2) = True Then
     s.SetRenderMode TV_POINT
   End If
   If Inp.IsKeyPressed(TV_KEY_3) = True Then
     s.SetRenderMode TV_SOLID
   End If
   
   If Inp.IsKeyPressed(TV_KEY_UP) = True Then
       PosX = PosX + Cos(Ang) * tv.TimeElapsed * 0.05
       PosZ = PosZ + Sin(Ang) * tv.TimeElapsed * 0.05
   End If
   If Inp.IsKeyPressed(TV_KEY_DOWN) = True Then
       PosX = PosX - Cos(Ang) * tv.TimeElapsed * 0.05
       PosZ = PosZ - Sin(Ang) * tv.TimeElapsed * 0.05
   End If
   If Inp.IsKeyPressed(TV_KEY_LEFT) = True Then
       Ang = Ang + tv.TimeElapsed * 0.005
   End If
   If Inp.IsKeyPressed(TV_KEY_RIGHT) = True Then
       Ang = Ang - tv.TimeElapsed * 0.005
   End If
   If Inp.IsKeyPressed(TV_KEY_SUBTRACT) = True Then
       PosY = PosY + tv.TimeElapsed * 0.05
   End If
   If Inp.IsKeyPressed(TV_KEY_ADD) = True Then
       PosY = PosY - tv.TimeElapsed * 0.05
   End If
   
  ' PosY = l.GetHeight(PosX, PosZ) + 10
   Scene.SetCamera PosX, PosY, PosZ, PosX + Cos(Ang), PosY, PosZ + Sin(Ang)
   
 Loop Until Inp.IsKeyPressed(TV_KEY_ESCAPE) = True

 Set tv = Nothing
End Sub




Sub Main11()
  tv.Initialize IntForm.hwnd
  IntForm.Show
  
  Dim M As Mesh8
  Dim s As New Scene8
  Set M = Scene.CreateMeshBuilder("")
  
  Dim file As New FileTVO
 Dim Car As Mesh8
  ' Set Car = Scene.CreateMeshBuilder("Car")
 
 'Car.LoadDXE "d:\truck\cc92.dxe"
''Car.LoadMesh "car1.tvo"
 'Car.ScaleMesh 5, 5, 5
 
 'Car.ComputeSphere
   
  file.OpenTVO "c:\essai3.msh", True
  'file.AddMesh Car, "Car"
  Set Car = file.LoadMesh("Car")
  file.CloseTVO
  
  'M.LoadFromT VO "c:\essai2.msh"
  M.ScaleMesh 1, 1, 1
  M.SetPosition 0, 0, 0
  
  Dim PosX As Single, PosY As Single, PosZ As Single, Ang As Single
  Do
   
   tv.Clear
  Car.Render
   tv.RenderToScreen
   
   
   If Inp.IsKeyPressed(TV_KEY_1) = True Then
     s.SetRenderMode TV_LINE
   End If
   If Inp.IsKeyPressed(TV_KEY_2) = True Then
     s.SetRenderMode TV_POINT
   End If
   If Inp.IsKeyPressed(TV_KEY_3) = True Then
     s.SetRenderMode TV_SOLID
   End If
   
   If Inp.IsKeyPressed(TV_KEY_UP) = True Then
       PosX = PosX + Cos(Ang) * tv.TimeElapsed * 0.05
       PosZ = PosZ + Sin(Ang) * tv.TimeElapsed * 0.05
   End If
   If Inp.IsKeyPressed(TV_KEY_DOWN) = True Then
       PosX = PosX - Cos(Ang) * tv.TimeElapsed * 0.05
       PosZ = PosZ - Sin(Ang) * tv.TimeElapsed * 0.05
   End If
   If Inp.IsKeyPressed(TV_KEY_LEFT) = True Then
       Ang = Ang + tv.TimeElapsed * 0.005
   End If
   If Inp.IsKeyPressed(TV_KEY_RIGHT) = True Then
       Ang = Ang - tv.TimeElapsed * 0.005
   End If
   If Inp.IsKeyPressed(TV_KEY_SUBTRACT) = True Then
       PosY = PosY + tv.TimeElapsed * 0.05
   End If
   If Inp.IsKeyPressed(TV_KEY_ADD) = True Then
       PosY = PosY - tv.TimeElapsed * 0.05
   End If
   
  ' PosY = l.GetHeight(PosX, PosZ) + 10
   s.SetCamera PosX, PosY, PosZ, PosX + Cos(Ang), PosY, PosZ + Sin(Ang)
   
 Loop Until Inp.IsKeyPressed(TV_KEY_ESCAPE) = True
End Sub

Sub main12()
  'Show the driver windows
  tv.ShowDriverDialog
  tv.DisplayFPS = True
  'Init the 3D stuff
  tv.Initialize ' IntForm.hwnd
  IntForm.Show
  
  'Set the default directory for the media files
  tv.SetSearchDirectory "c:\coindev\truevision8\ShootMontain\"
  
  
  'Load grass texture for the terrain
  'Note that TrueVision can load DDS textures.
  'You can create DDS textures with Dxtex delivred with DirectX8 sdk
  TexFactory.LoadTexture "snow.bmp", "terrain"
  

 'Set the general settings for the scene
  Scene.SetSceneBackGround 0, 0, 0
  Scene.SetViewFrustum 90, 1024
 
 'Load the sky (JPG are really bad compressed. Sorry about that)
 TexFactory.LoadTexture "down.jpg", "Up"
 TexFactory.LoadTexture "left.jpg", "Left"
 TexFactory.LoadTexture "up.jpg", "Down"
 TexFactory.LoadTexture "right.jpg", "Right"
 TexFactory.LoadTexture "front.jpg", "Front"
 TexFactory.LoadTexture "back.jpg", "Back"
 'LocalScreen.LoadBackground "c:\coindev\truevision8\rally\lol1.bmp"
 'Apply the sky in the scene
 Scene.SetSkyTexture GetTex("Front"), GetTex("Back"), GetTex("Left"), GetTex("Right"), GetTex("up"), GetTex("down")

   'TexFactory.LoadTexture "c:\coindev\truevision8\rally\cursor.bmp", "spr", , , RGBA(0, 0, 0, 1)
 'LANSCAPE CREATION
 'New function from TrueVision8
 'You can load any heightmap (any size)
 'and you choose the position and the size of the heightmap in the landscape
 'Note that there is a great AffineTerrain function that makes the terrain more curved.
 
 'I use here 4x4 terrains (1024x1024) but you can try numbers like 8 or 16 (4096x4096 !)
 'On My computer 4x4 runs at 60FPS and 16x16 runs at 40 FPS !
 
 'The heightmap has values from 0 to 255. You can scale them with this SetFactorY method.
 Land.SetFactorY 1
 Land.GenerateHugeTerrain "height.jpg", TV_PRECISION_AVERAGE, 4, 4, 0, 0, True
 
 'For testing the best of the terrain engine try this :
 'Land.SetFactorY 5
 'Land.GenerateHugeTerrain "height.jpg", TV_PRECISION_AVERAGE, 16, 16, 0, 0, True
 
 
 'Change the texture tiling
 Land.SetTextureScale 2, 2
 Land.SetTexture GetTex("Terrain")
 
' Car.SetMaterial 0
 'create trees
 Dim treeTex(2) As Texture8
 Set treeTex(1) = TexFactory.LoadTexture("tree1.dds", , , , RGBA(0, 0, 0, 1))
 Set treeTex(2) = TexFactory.LoadTexture("tree5.dds", , , , RGBA(0, 0, 0, 1))
 
 Dim x As Single, z As Single, y As Single
 Dim Trees(100) As Mesh8
  For i = 1 To 100
     x = Rnd * 1024
     z = Rnd * 1024
     y = Land.GetHeight(x, z) + 5
     Set Trees(i) = Scene.CreateBillboard(treeTex(Int(Rnd * 2) + 1), x, y, z, 40, -40)
     'Trees(i).SetPrimitiveType TV_TRIANGLESTRIP
     'Trees(i).AddWall treeTex(1), x, z + 20, x, z - 20, 40, 0
     Trees(i).SetPosition x, y + 35, z
     'Trees(i).SetTexture treeTex
     Trees(i).ComputeSphere
     'Trees(i).ScaleMesh 0, 0, 1
'     Debug.Print x, y, z
      
  Next i

'Enable mip mapping for more speed. Optional
Scene.EnableMipMapping


Dim Weapon As New Actor8
tv.OpenPAKFile "c:\sierra\half-life\valve\pak0.pak"
Weapon.Load "models/v_shotgun.MDL"
tv.ClosePAKFile

Weapon.SetAnimationName "idle"
Weapon.SetSpeed 1

Dim scr As New Screen8
Scene.LoadCursor "c:\coindev\truevision8\rally\cursor.bmp", TV_COLORKEY_BLACK

Dim PosX As Single, PosY As Single, PosZ As Single, Ang As Single, Fin As Integer
Dim CamPosX As Single, CamPosZ As Single, ang2 As Single, ang3 As Single, posy1 As Single
Dim posy2 As Single
 
 'Put the car in the center of the terrain
 PosX = 512
 PosZ = 512
 
 
 'Fade in  ( really simplified, you have to call it once with the desired
 'speed in milliseconds)
 Effects.FadeIn 3000
 
 'Set a fog effect for the terrain only
 'Effects.SetFog True, 0.5, 0.5, 0.5, 1, 1, 700
  
  TexFactory.LoadTexture "snowpar.bmp", "Snow", , , TV_COLORKEY_BLACK
  Land.InitRain 100, GetTex("Snow")
 'Game loop
Dim mx As Long, my As Long
 Do
   
  'Clear the screen
  tv.Clear

  
  
  'Render the entire landscape
 ' LocalScreen.DrawTexture GetTex("spr"), 0, 0, 300, 300, , True
    Scene.RenderSky
  
  Land.Render
  'inter.GetDevice3D.SetRenderState D3DRS_CULLMODE, D3DCULL_NONE
  
  'Cancel the fog for drawing the sky
  tv.Start2D
  
  'Render the sky (you have to call this method just after the terrain rendering)
     
     Scene.RenderAllMeshes
   Weapon.Render

  'Render the trees and the car
  
  'ScreenShot Taking takes a few seconds. TV has to convert the color format
  'BackBuffer formats supported : R5G6B5 & X8R8G8B8 & A8R8G8B8
  'other formats can give strange results !
 If Inp.IsKeyPressed(TV_KEY_S) = True Then
   tv.ScreenShot "c:\key.bmp"
  End If
  
  'Flip all on the screen
   
  'Input keyboard
   
   If Inp.IsKeyPressed(TV_KEY_1) = True Then
     s.SetRenderMode TV_LINE
   End If
   If Inp.IsKeyPressed(TV_KEY_2) = True Then
     s.SetRenderMode TV_POINT
   End If
   If Inp.IsKeyPressed(TV_KEY_3) = True Then
     s.SetRenderMode TV_SOLID
   End If
   
   If Inp.IsKeyPressed(TV_KEY_UP) = True Then
       PosX = PosX + Cos(Ang) * tv.TimeElapsed * 0.05
       PosZ = PosZ + Sin(Ang) * tv.TimeElapsed * 0.05
   End If
   If Inp.IsKeyPressed(TV_KEY_DOWN) = True Then
       PosX = PosX - Cos(Ang) * tv.TimeElapsed * 0.05
       PosZ = PosZ - Sin(Ang) * tv.TimeElapsed * 0.05
   End If
   If Inp.IsKeyPressed(TV_KEY_LEFT) = True Then
       Ang = Ang + tv.TimeElapsed * 0.005
   End If
   If Inp.IsKeyPressed(TV_KEY_RIGHT) = True Then
       Ang = Ang - tv.TimeElapsed * 0.005
   End If
   If Inp.IsKeyPressed(TV_KEY_SUBTRACT) = True Then
       PosY = PosY + tv.TimeElapsed * 0.05
   End If
   If Inp.IsKeyPressed(TV_KEY_ADD) = True Then
       PosY = PosY - tv.TimeElapsed * 0.05
   End If
   Inp.GetMouseState mx, my
   If Abs(mx) > 1 Then
     Ang = Ang - tv.TimeElapsed * 0.001 * mx

   End If
  ' If Abs(my) > 1 Then
  '   angy = angy - tv.TimeElapsed * 0.001 * my
  '   If Abs(angy) > 1.52 Then angy = Sgn(angy) * 1.52
  ' End If
   
   PosY = Land.GetHeight(PosX, PosZ) + 20
   Weapon.SetScale 0.2, 0.4, 0.2
   Weapon.SetPosition PosX, PosY, PosZ
   Weapon.SetRotation -90, -Ang * 180 / 3.14, 0
   Scene.SetCamera PosX, PosY, PosZ, PosX + Cos(Ang), PosY + Sin(angy), PosZ + Sin(Ang)
  tv.RenderToScreen
   
   'Change the position altitude according to the terrain altitude
   PosY = Land.GetHeight(PosX, PosZ) + 3
 Loop Until Inp.IsKeyPressed(TV_KEY_ESCAPE) = True
 Set tv = Nothing
 
End Sub

Public Sub Main13()
 'Show the driver windows
If tv.ShowDriverDialog = False Then Exit Sub

'Init the 3D stuff
tv.Initialize IntForm.hwnd
tv.DisplayFPS = True
'Set the default directory for the media files
tv.SetSearchDirectory "c:\coindev\truevision8\terrain\"
countd = 0

'Load grass texture for the terrain
'Note that TrueVision can load DDS textures.
'You can create DDS textures with Dxtex delivred with DirectX8 sdk
TexFactory.LoadTexture "grass.dds", "terrain"

'Set the general settings for the scene
Scene.SetSceneBackGround 0, 0, 0
Scene.SetViewFrustum 90, 1024

'Load the sky (JPG are really bad compressed. Sorry about that)
TexFactory.LoadTexture "down.jpg", "Up"
TexFactory.LoadTexture "left.jpg", "Left"
TexFactory.LoadTexture "up.jpg", "Down"
TexFactory.LoadTexture "right.jpg", "Right"
TexFactory.LoadTexture "front.jpg", "Front"
TexFactory.LoadTexture "back.jpg", "Back"
TexFactory.LoadTexture "weter2.bmp", "Water"

TexFactory.LoadTexture "sun.bmp", "SUN"

'Apply the sky in the scene
'Scene.SetSkyTexture GetTex("Front"), GetTex("Back"), GetTex("Left"), GetTex("Right"), GetTex("up"), GetTex("down")

'LANSCAPE CREATION
'New function from TrueVision8
'You can load any heightmap (any size)
'and you choose the position and the size of the heightmap in the landscape
'Note that there is a great AffineTerrain function that makes the terrain more curved.

'I use here 4x4 terrains (1024x1024) but you can try numbers like 8 or 16 (4096x4096 !)
'On My computer 4x4 runs at 60FPS and 16x16 runs at 40 FPS !

'The heightmap has values from 0 to 255. You can scale them with this SetFactorY method.
Land.SetFactorY 1
Land.GenerateHugeTerrain "height.jpg", TV_PRECISION_AVERAGE, 4, 4, 0, 0, True

Land.InitSun GetTex("SUN"), Vector(700, 300, 700), 1
 
'For testing the best of the terrain engine try this :
'Land.SetFactorY 5
'Land.GenerateHugeTerrain "height.jpg", TV_PRECISION_AVERAGE, 16, 16, 0, 0, True

'Change the texture tiling
Land.SetTextureScale 2, 2
Land.SetTexture GetTex("Terrain")

Land.SetWaterEnable True
Land.SetWaterAltitude 45
Land.SetWaterTexture GetTex("Water")
Land.SetWaterEffect True, , True

Scene.SetSceneBackGround 0, 0.6, 0.9
Dim PosX As Single, PosY As Single, PosZ As Single, Ang As Single, Fin As Integer

'Fade in ( really simplified, you have to call it once with the desired
'speed in milliseconds)
Effects.FadeIn 2000

'Set a fog effect for the terrain only
Effects.SetFog True, 0, 0.6, 0.9, 0, 1, 700
Scene.LoadCursor "c:\coindev\truevision8\rally\cursor.bmp", TV_COLORKEY_BLACK
'Game loop
Inp.ReAcquire True, True
Do

'Clear the screen
tv.Clear

'Render the entire landscape
Land.Render

'Cancel the fog for drawing the sky
tv.Start2D

'Render the sky (you have to call this method just after the terrain rendering)
Scene.RenderSky

'Flip all on the screen
tv.RenderToScreen

'Input keyboard
If Inp.IsKeyPressed(TV_KEY_1) = True Then
Scene.SetRenderMode TV_LINE
End If
If Inp.IsKeyPressed(TV_KEY_2) = True Then
Scene.SetRenderMode TV_POINT
End If
If Inp.IsKeyPressed(TV_KEY_3) = True Then
Scene.SetRenderMode TV_SOLID
End If

If Inp.IsKeyPressed(TV_KEY_UP) = True Then
PosX = PosX + Cos(Ang) * tv.TimeElapsed * 0.05
PosZ = PosZ + Sin(Ang) * tv.TimeElapsed * 0.05
End If
If Inp.IsKeyPressed(TV_KEY_DOWN) = True Then
PosX = PosX - Cos(Ang) * tv.TimeElapsed * 0.05
PosZ = PosZ - Sin(Ang) * tv.TimeElapsed * 0.05
End If
If Inp.IsKeyPressed(TV_KEY_LEFT) = True Then
Ang = Ang + tv.TimeElapsed * 0.005
End If
If Inp.IsKeyPressed(TV_KEY_RIGHT) = True Then
Ang = Ang - tv.TimeElapsed * 0.005
End If
If Inp.IsKeyPressed(TV_KEY_SUBTRACT) = True Then
PosY = PosY + tv.TimeElapsed * 0.05
End If
If Inp.IsKeyPressed(TV_KEY_ADD) = True Then
PosY = PosY - tv.TimeElapsed * 0.05
End If
If Inp.IsKeyPressed(TV_KEY_S) = True Then
tv.ScreenShot "C:\screen\scrshot" & countd & ".bmp"
countd = countd + 1
End If


'Change the position altitude according to the terrain altitude
PosY = Land.GetHeight(PosX, PosZ) + 15

Dim MP As CollisionResult8
Set MP = Scene.MousePicking(ActMX, ActMY, TV_COLLIDE_LANDSCAPE, TV_TESTTYPE_ACCURATETESTING)
If MP.IsCollision Then
   Land.ChangePointAltitude MP.GetImpactPoint.x, MP.GetImpactPoint.z, MP.GetImpactPoint.y + 2
End If


'Place the camera
Scene.SetCamera PosX, PosY, PosZ, PosX + Cos(Ang), PosY, PosZ + Sin(Ang)

'Test for the escape key. Fade out
If Inp.IsKeyPressed(TV_KEY_ESCAPE) = True Then
Fin = 1
Effects.FadeOut 2000
End If
Loop Until Effects.FadeFinished = True And Fin = 1

Set tv = Nothing

End Sub

Sub Main14()
 '1. Show the form in that the scene will be rendered.
   '  Form1.Show
    
    '2. Initialize the engine in windowed mode.
    '   Note that you have to use the Hwnd of the desired form or picturebox
    tv.Init3DWindowedMode IntForm.hwnd
    IntForm.Show
    '2b. Defines the data directory. Usually it's the application path
    tv.SetSearchDirectory App.Path
    
    '3. Create the room
    '3a : Create the mesh from the scene object
    Set Room = Scene.CreateMeshBuilder("Room")
    
    '3b : Add the walls to the room using the Mesh8.AddWall method
    '     We will set the texture later...
    Room.AddWall Nothing, -10, -10, 10, -10, 20
    Room.AddWall Nothing, 10, -10, 10, 10, 20
    Room.AddWall Nothing, 10, 10, -10, 10, 20
    Room.AddWall Nothing, -10, 10, -10, -10, 20
    
    '3c : Add the floor and the ceiling using the Mesh8.AddFloor method
    Room.AddFloor Nothing, -10, -10, 10, 10, 0
    Room.AddFloor Nothing, -10, -10, 10, 10, 20
    
    Dim TVO As New FileTVO
    TVO.OpenTVO "c:\land.Txt", True
    Set Land = TVO.LoadLandscape
    
    '3d : Load a brick texture. Note that TrueVision can load
    '     BMP, JPG, DDS, PNG, GIF picture files.
    TexFactory.LoadTexture "brick1.bmp", "BrickTexture"
    
    '3e : Apply the texture to the room
    Room.SetTexture GetTex("BrickTexture")
    
    '4 : Set the camera startpos
    Camera.SetCameraPosition 10, 100, 10
    
    'The main game loop :
    Do
      'Clear the screen. You must do this before rendering anything on the screen.
      tv.Clear
      
      'Call the room rendering method
      Scene.RenderAllMeshes
      Land.Render
      'Render everything on the screen
      tv.RenderToScreen
      
      'Move the scene according to the keyboard presses.
      If Inp.IsKeyPressed(TV_KEY_UP) = True Then Camera.MoveForward 20
      If Inp.IsKeyPressed(TV_KEY_DOWN) = True Then Camera.MoveForward -20
      If Inp.IsKeyPressed(TV_KEY_RIGHT) = True Then Camera.RotateCameraY -30
      If Inp.IsKeyPressed(TV_KEY_LEFT) = True Then Camera.RotateCameraY -30
      
    
    Loop Until Inp.IsKeyPressed(TV_KEY_ESCAPE) = True
    
    'Don't forget to shut down the engine
    Set tv = Nothing
    
End Sub

Sub Main15()
   
   tv.Initialize 'IntForm.hwnd
   tv.SetSearchDirectory App.Path + "\shader\"
   IntForm.Show
   Scene.LoadShaders "common.shader"
   tv.DisplayFPS = True
 Dim PosX As Single, PosY As Single, PosZ As Single, Ang As Single
 Dim Mesh As Mesh8, Mesh2 As Mesh8
 Dim Mirror As Mesh8
 Dim Room As Mesh8
 Set Mesh = Scene.CreateBillboard(Nothing, 0, 0, 0, 20, 40, , , , , RGBA(0, 0, 1, 1))
 Set Mesh2 = Scene.CreateBillboard(Nothing, 50, 0, 0, 40, 40, , , , , RGBA(0, 0, 1, 1))
 Set Mirror = Scene.CreateMeshBuilder("Mirror")
 Mirror.AddWall Nothing, -40, -20, 80, -20, -60, 60
'
LocTexFactory.LoadTexture "c:\coindev\brick1.bmp", "Brick"
Dim li As New LightEngine8
Dim t As Integer
t = li.CreatePointLight(Vector(-100, 30, -100), 100, 0, 30000, 30000, 1)
Set Room = Scene.CreateMeshBuilder("Room")
Room.AddWall GetTex("Brick"), -100, -100, -100, 100, 100
Room.AddWall GetTex("Brick"), -100, 100, 100, 100, 100
Room.AddWall GetTex("Brick"), 100, 100, 100, -100, 100
Room.AddWall GetTex("Brick"), 100, -100, -100, -100, 100
Room.AddFloor GetTex("Brick"), 100, 100, -100, -100, 0
Room.AddFloor GetTex("Brick"), 100, 100, -100, -100, 100

GetTex("brick").ApplyOn Room, , 1, 1, 1, 1, 20

'Room.SetBlendingMode TV_BLEND_ALPHA
Room.SetVertexType TV_NORMAL_VERTEX
Room.ComputeNormals
Dim Mat As New MaterialFactory8
Dim Material As Integer
Material = Mat.CreateMaterialQuick(0.2, 0.2, 0.2, 1, "Mat")
Mat.SetDiffuse Material, 1, 1, 1, 1
'Room.SetColor RGBA(1, 1, 1, 0.5)
Room.SetMaterial Material

 Dim MirrorRS As RenderSurface8
 Set MirrorRS = CreateMirrorEffect(Mirror, 256, 256)
' Set MirrorRS = Scene.CreateRenderSurface(100, 200, True)
' MirrorRS.SetCamera 20, 15, -30, 20, 15, -10
'Mirror.SetTexture MirrorRS.GetTexture


 Mesh.SetShader GetShader("Flame1")
 Mesh2.SetShader GetShader("Explosion")
 Mesh.ComputeSphere
 Mesh2.ComputeSphere
 Mirror.ComputeSphere
 Scene.SetSceneBackGround 0, 0, 0
 Dim src As New Screen8
 Do
   
'  If Mirror.IsVisible <> 0 Then
'   MirrorRS.StartRender
'  '  Room.Render
'  '  Mesh.Render
'  '  Mesh2.Render
'    src.DrawLine 5, 5, 10, 10, RGBA(1, 1, 1, 1)
'    src.DrawPoint 10, 10, RGBA(1, 0, 0, 0.5)
'   MirrorRS.EndRender
 ' End If
   
   tv.Clear
   
   Room.Render
   Mirror.Render
   
   Mesh.Render
   Mesh2.Render
   
   
   tv.RenderToScreen
   DoEvents
   a = a + tv.TimeElapsed * 0.001
   li.SetLightPosition t, Vector(Sin(a) * 100, 50, Cos(a) * 100)
   GetTex("brick").ApplyOn Room, , 1, 1, 1, 1, CSng(a)
   
   If Inp.IsKeyPressed(TV_KEY_1) = True Then
     s.SetRenderMode TV_LINE
   End If
   If Inp.IsKeyPressed(TV_KEY_2) = True Then
     s.SetRenderMode TV_POINT
   End If
   If Inp.IsKeyPressed(TV_KEY_3) = True Then
     s.SetRenderMode TV_SOLID
   End If
   
   If Inp.IsKeyPressed(TV_KEY_UP) = True Then
       PosX = PosX + Sin(Ang) * tv.TimeElapsed * 0.05
       PosZ = PosZ + Cos(Ang) * tv.TimeElapsed * 0.05
   End If
   If Inp.IsKeyPressed(TV_KEY_DOWN) = True Then
       PosX = PosX - Sin(Ang) * tv.TimeElapsed * 0.05
       PosZ = PosZ - Cos(Ang) * tv.TimeElapsed * 0.05
   End If
   If Inp.IsKeyPressed(TV_KEY_LEFT) = True Then
       Ang = Ang + tv.TimeElapsed * 0.005
   End If
   If Inp.IsKeyPressed(TV_KEY_RIGHT) = True Then
       Ang = Ang - tv.TimeElapsed * 0.005
   End If
   If Inp.IsKeyPressed(TV_KEY_SUBTRACT) = True Then
       PosY = PosY + tv.TimeElapsed * 0.05
   End If
   If Inp.IsKeyPressed(TV_KEY_ADD) = True Then
       PosY = PosY - tv.TimeElapsed * 0.05
   End If
   
  ' PosY = l.GetHeight(PosX, PosZ) + 10
  ' Scene.SetCamera PosX, PosY, PosZ, PosX + Cos(ang), PosY, PosZ + Sin(ang)
  
  Camera.SetCameraPosition PosX, PosY, PosZ
  Camera.RotateAngles 0, Ang * 180 / 3.14, 20
 Loop Until Inp.IsKeyPressed(TV_KEY_ESCAPE) = True

 Set tv = Nothing
 
End Sub
Function GetShader(ShaderName As String) As Shader8
  Dim i As Long
  For i = 1 To NbShaders
     If UCase$(ShaderName) = UCase$(Shaders(i).ShaderName) Then
       Set GetShader = Shaders(i).Object
       Exit Function
     End If
  Next i
  Set GetShader = Nothing
End Function


Sub Main16()
  Dim BSP As New BSPTree8
  tv.ShowDriverDialog
   IntForm.Show
  tv.Initialize IntForm.hwnd
  tv.DisplayFPS = True
 ' Debug.Print Inp.IsMouseConnectmained
 ' Scene.SetSceneBackGround 1, 1, 1
  tv.SetSearchDirectory "d:\quake3\raw\"
   
  ' Debug.Print "load"
  BSP.LoadShaderDirectory "scripts\"
  ' Exit Sub
  BSP.Load "maps/q3tourney2.bsp"
  'BSP.Load "d:\north_trail.bsp"
  Dim s As New Scene8

  Debug.Print "render"
  Dim PosX As Single, PosY As Single, PosZ As Single, Ang As Single
  Effects.ChangeGamma 1.2
  BSP.SetParameters True, True, TV_FRONT_CULL
  PosX = BSP.GetStartPlayerPosition.x
  PosY = BSP.GetStartPlayerPosition.y + 10
  PosZ = BSP.GetStartPlayerPosition.z
  Dim scr As New Screen8
  Dim Possx As Single, possy As Single, possz As Single
  Do
    'PosX = 0
    'PosY = 0
    'PosZ = 0
    'ang = 3.141592653 / 2
    'DoEvents
    tv.Clear
    BSP.Render
     ' scr.DrawLine3D PosX, PosY, PosZ, PosX + Cos(ang) * 20, PosY, PosZ + Sin(ang) * 20, RGBA(0, 1, 0, 1)
     ' If BSP.LineSight(Vector(PosX, PosY, PosZ), Vector(PosX + Cos(ang) * 20, PosY, PosZ + Sin(ang) * 20), 0) = True Then
     ' Else
     '   Scene.DrawText "Stop ", 30, 60
     '   Beep
     ' End If
    'Scene.DrawText CStr(PosX) + " " + CStr(PosY) + " " + CStr(PosZ), 60, 70
    'Scene.DrawText CStr(BSP.LineSight(Vector(PosX, PosY, PosZ), Vector(PosX + Cos(ang) * 10, PosY, PosZ + Sin(ang) * 10), 0)), 60, 100

    If Inp.IsKeyPressed(TV_KEY_S) = True Then
      tv.ScreenShot "c:\key.bmp"
    End If

    tv.RenderToScreen
       If Inp.IsKeyPressed(TV_KEY_1) = True Then
     s.SetRenderMode TV_LINE
   End If
   
   If Inp.IsKeyPressed(TV_KEY_2) = True Then
     s.SetRenderMode TV_POINT
   End If
   
   If Inp.IsKeyPressed(TV_KEY_3) = True Then
     s.SetRenderMode TV_SOLID
   End If
   Possx = PosX
   possy = PosY
   possz = PosZ
   If Inp.IsKeyPressed(TV_KEY_UP) = True Then
       Possx = PosX + Cos(Ang) * tv.TimeElapsed * 0.5
       possz = PosZ + Sin(Ang) * tv.TimeElapsed * 0.5
   End If
   
   If Inp.IsKeyPressed(TV_KEY_DOWN) = True Then
       Possx = PosX - Cos(Ang) * tv.TimeElapsed * 0.5
       possz = PosZ - Sin(Ang) * tv.TimeElapsed * 0.5
   End If
   
   If Inp.IsKeyPressed(TV_KEY_LEFT) = True Then
       Ang = Ang + tv.TimeElapsed * 0.005
   End If
   
   If Inp.IsKeyPressed(TV_KEY_RIGHT) = True Then
       Ang = Ang - tv.TimeElapsed * 0.005
   End If
   If Inp.IsKeyPressed(TV_KEY_SUBTRACT) = True Then
       possy = PosY + tv.TimeElapsed * 0.05
   End If
   If Inp.IsKeyPressed(TV_KEY_ADD) = True Then
       possy = PosY - tv.TimeElapsed * 0.05
   End If
   If Inp.IsKeyPressed(TV_KEY_C) = True Then
    d = Not d
   End If
    d = True
   'If d = True Then
     'If BSP.AdvancedSphereCollision(Vector3(PosX, PosY, PosZ), Vector3(Possx, possy, possz), 3).IsCollision = False Then
     ' PosX = Possx
     ' PosZ = possz
     ' PosY = possy
     'End If
      Dim Ret As D3DVECTOR
      If d = True Then
        If BSP.SlidingCollision(Vector3(PosX, PosY, PosZ), Vector3(Possx, possy, possz), Ret, 2) = True Then
          PosX = Ret.x
          PosY = Ret.y
          PosZ = Ret.z
        End If
        PosY = BSP.StayOnFloor(Vector3(Possx, possy - 40, possz), , , 2) + 40
      End If
      
      
     ' PosZ = possz
    

      
   'Else
   '   PosX = Possx
   '   PosY = possy
   '   PosZ = possz
   'End If
      s.SetCamera PosX, PosY, PosZ, PosX + Cos(Ang), PosY, PosZ + Sin(Ang)
     Loop Until Inp.IsKeyPressed(TV_KEY_ESCAPE)
  Set tv = Nothing
  
  
  
End Sub

Sub Main18()
 'Show the driver windows
  tv.ShowDriverDialog
  tv.DisplayFPS = True
  'Init the 3D stuff
  tv.Initialize IntForm.hwnd
  IntForm.Show
  
  'Set the default directory for the media files
  tv.SetSearchDirectory "c:\coindev\truevision8\carsample\"
  
  
  'Load grass texture for the terrain
  'Note that TrueVision can load DDS textures.
  'You can create DDS textures with Dxtex delivred with DirectX8 sdk
  TexFactory.LoadTexture "grass.dds", "terrain"
  

 'Set the general settings for the scene
  Scene.SetSceneBackGround 0, 0, 0
  Scene.SetViewFrustum 90, 1024
 
 'Load the sky (JPG are really bad compressed. Sorry about that)
 TexFactory.LoadTexture "down.jpg", "Up"
 TexFactory.LoadTexture "left.jpg", "Left"
 TexFactory.LoadTexture "up.jpg", "Down"
 TexFactory.LoadTexture "right.jpg", "Right"
 TexFactory.LoadTexture "front.jpg", "Front"
 TexFactory.LoadTexture "back.jpg", "Back"
 
 
 

 'LocalScreen.LoadBackground "c:\coindev\truevision8\rally\lol1.bmp"
 'Apply the sky in the scene
 Scene.SetSkyTexture GetTex("Front"), GetTex("Back"), GetTex("Left"), GetTex("Right"), GetTex("up"), GetTex("down")

   'TexFactory.LoadTexture "c:\coindev\truevision8\rally\cursor.bmp", "spr", , , RGBA(0, 0, 0, 1)
 'LANSCAPE CREATION
 'New function from TrueVision8
 'You can load any heightmap (any size)
 'and you choose the position and the size of the heightmap in the landscape
 'Note that there is a great AffineTerrain function that makes the terrain more curved.
 
 'I use here 4x4 terrains (1024x1024) but you can try numbers like 8 or 16 (4096x4096 !)
 'On My computer 4x4 runs at 60FPS and 16x16 runs at 40 FPS !
 
 'The heightmap has values from 0 to 255. You can scale them with this SetFactorY method.
 Land.SetFactorY 0.3
 'Land.SetLandscapeMode TV_LANDMODE_ADVANCEDLAND
 Land.GenerateHugeTerrain "terr.bmp", TV_PRECISION_AVERAGE, 4, 4, 0, 0, True
 Dim tex(1) As Texture8
 Set tex(0) = GetTex("Up")
 'Land.AdvSetTextureTable 1, Tex()
 
 'For testing the best of the terrain engine try this :
 'Land.SetFactorY 5
 'Land.GenerateHugeTerrain "height.jpg", TV_PRECISION_AVERAGE, 16, 16, 0, 0, True
 
 'Load the car
' Set Car = Scene.CreateMeshBuilder("Car")
 'Car.LoadDXE "d:\truck\cc92.dxe"
 '"Car.SaveMesh "car1.tvo"
 'and his texture
 
 'Change the texture tiling
 Land.SetTextureScale 1, 1
 Land.SetTexture GetTex("Terrain")
 Land.SetWaterAltitude 30
 Land.SetWaterTexture TexFactory.LoadTexture("c:\coindev\truevision8\carsample\water.bmp", "terrains", 128, 128)
 Land.SetWaterTexture GetTex("terrains")
 Land.SetWaterTextureScale 2
 
 Land.SetWaterEffect True, , True, , , True
 Land.SetWaterEnable True
 'create trees
 Dim treeTex(2) As Texture8
 Set treeTex(1) = TexFactory.LoadTexture("tree3c.dds", , , , RGBA(0, 0, 0, 1))
 Set treeTex(2) = TexFactory.LoadTexture("tree4c.dds", , , , RGBA(0, 0, 0, 1))
 
 Dim x As Single, z As Single, y As Single
 Dim Trees(100) As Mesh8
 
'Enable mip mapping for more speed. Optional



Scene.LoadTexture "texturewater.bmp", , , "Water"
'Land.SetWaterEnable True
'Land.SetWaterAltitude 50
Land.SetWaterTexture GetTex("Water")
'Land.SetWaterEffect True, , True

Dim scr As New Screen8
Scene.LoadCursor "c:\coindev\truevision8\rally\cursor.bmp", TV_COLORKEY_BLACK

Dim PosX As Single, PosY As Single, PosZ As Single, Ang As Single, Fin As Integer
Dim CamPosX As Single, CamPosZ As Single, ang2 As Single, ang3 As Single, posy1 As Single
Dim posy2 As Single
 
 'Put the car in the center of the terrain
 PosX = 512
 PosZ = 512
 
 
 'Fade in  ( really simplified, you have to call it once with the desired
 'speed in milliseconds)
 'Effects.FadeIn 3000
 
 'Set a fog effect for the terrain only
 'Effects.SetFog True, 0, 0, 0, 0, 1, 700
  
 'Game loop
 tv.SetSearchDirectory "c:\coindev\truevision8\lensflare\"
 
 'Land.InitSun
' Land.InitLensFlare 8
 
 For i = 1 To 5
  TexFactory.LoadTexture "flare" + CStr(i - 1) + ".bmp", "Flare" + CStr(i), , , TV_COLORKEY_BLACK
 Next i
 
 'Land.SetLensFlare 1, 2 * 5, GetTex("Flare5"), 40, RGBA(1, 1, 1, 1), RGBA(1, 1, 1, 1)
 'Land.SetLensFlare 2, 2 * 1, GetTex("Flare5"), 18, RGBA(1, 1, 1, 1), RGBA(1, 1, 1, 1)
 'Land.SetLensFlare 3, 2 * 1.8, GetTex("Flare4"), 15, RGBA(1, 1, 1, 1), RGBA(0.7, 1, 1, 1)
 'Land.SetLensFlare 4, 2 * 1, GetTex("Flare5"), 6, RGBA(1, 0.1, 0, 1), RGBA(0.5, 1, 1, 1)
 'Land.SetLensFlare 5, 2 * 0.5, GetTex("Flare3"), 2, RGBA(1, 1, 1, 1), RGBA(0.5, 1, 1, 1)
 'Land.SetLensFlare 6, 2 * 1, GetTex("Flare5"), -4, RGBA(1, 1, 1, 1), RGBA(1, 1, 1, 1)
 'Land.SetLensFlare 7, 2 * 0.3, GetTex("Flare1"), 0.3, RGBA(1, 1, 1, 1), RGBA(0.5, 1, 1, 1)
 'Land.SetLensFlare 8, 2 * 0.2, GetTex("Flare2"), -7, RGBA(1, 1, 1, 1), RGBA(0.5, 1, 1, 1)
 

 TexFactory.LoadTexture "shine2.bmp", "Sun", , , TV_COLORKEY_BLACK
 'Land.InitSun GetTex("Sun"), Vector(-500, 500, -500)
 

 'Land.CreateDynTextures 256, 256, True
 Dim inter As New InternalObjects8
 Do
   
  'Clear the screen
  
  tv.Clear
  'Device.SetRenderState D3DRS_ZENABLE, 1
  'Device.SetRenderState D3DRS_ZWRITEENABLE, 1
  'Scene.RenderSky
  
  
  'Render the entire landscape

 ' LocalScreen.DrawTexture GetTex("spr"), 0, 0, 300, 300, , True
  Land.Render
  'Scene.RenderAllMeshes
  'inter.GetDevice3D.SetRenderState D3DRS_CULLMODE, D3DCULL_NONE
  
  'Cancel the fog for drawing the sky
 ' tv.Start2D
  
  'Render the sky (you have to call this method just after the terrain rendering)

  
  'Render the trees and the car
  
  'ScreenShot Taking takes a few seconds. TV has to convert the color format
  'BackBuffer formats supported : R5G6B5 & X8R8G8B8 & A8R8G8B8
  'other formats can give strange results !
 
  
  'Flip all on the screen
   
  'Input keyboard
   If Inp.IsKeyPressed(TV_KEY_1) = True Then
     Scene.SetRenderMode TV_LINE
   End If
   If Inp.IsKeyPressed(TV_KEY_2) = True Then
     Scene.SetRenderMode TV_POINT
   End If
   If Inp.IsKeyPressed(TV_KEY_3) = True Then
     Scene.SetRenderMode TV_SOLID
   End If
   
 
   Dim MP As CollisionResult8
   Dim mx As Long, my As Long, b1 As Integer
   
   Land.RenderLensFlare
   If Inp.IsKeyPressed(TV_KEY_S) = True Then
   tv.ScreenShot "c:\key.bmp"
  End If
  tv.RenderToScreen
     Inp.GetAbsMouseState mx, my, b1
    Set MP = Scene.MousePicking(mx, my, TV_COLLIDE_LANDSCAPE, TV_TESTTYPE_ACCURATETESTING)
   If MP.IsCollision = True And b1 <> 0 Then
      Land.DynDrawTexture treeTex(1), MP.GetImpactPoint.x - 100, MP.GetImpactPoint.z - 100, MP.GetImpactPoint.x + 100, MP.GetImpactPoint.z + 100, RGBA(1, 1, 1, 1), True
   '    ' Trees(1).SetPosition MP.GetImpactPoint.x, MP.GetImpactPoint.y + 40, MP.GetImpactPoint.z
   '    Land.AdvEnableChunk False, MP.GetImpactPoint.x, MP.GetImpactPoint.z
   'PosX = MP.GetImpactPoint.x
   'PosY = MP.GetImpactPoint.y
   'PosZ = MP.GetImpactPoint.z
   'Trees(1).SetPosition MP.GetImpactPoint.x, MP.GetImpactPoint.y, MP.GetImpactPoint.z
   End If
   'Change the position altitude according to the terrain altitude
   'PosY = Land.GetHeight(PosX, PosZ) + 5
   

   If Inp.IsKeyPressed(TV_KEY_UP) = True Then
       PosX = PosX + Cos(Ang) * tv.TimeElapsed * 0.05
       PosZ = PosZ + Sin(Ang) * tv.TimeElapsed * 0.05
   End If
   
   If Inp.IsKeyPressed(TV_KEY_DOWN) = True Then
       PosX = PosX - Cos(Ang) * tv.TimeElapsed * 0.05
       PosZ = PosZ - Sin(Ang) * tv.TimeElapsed * 0.05
   End If
   
   If Inp.IsKeyPressed(TV_KEY_LEFT) = True Then
       Ang = Ang + tv.TimeElapsed * 0.005
   End If
   
   If Inp.IsKeyPressed(TV_KEY_RIGHT) = True Then
       Ang = Ang - tv.TimeElapsed * 0.005
   End If
   If Inp.IsKeyPressed(TV_KEY_SUBTRACT) = True Then
       PosY = PosY + tv.TimeElapsed * 0.05
   End If
   If Inp.IsKeyPressed(TV_KEY_ADD) = True Then
       PosY = PosY - tv.TimeElapsed * 0.05
   End If
   
   'Place the camera
         Scene.SetCamera PosX, PosY, PosZ, PosX + Cos(Ang), PosY, PosZ + Sin(Ang)
   'Scene.SetCamera CamPosX, Land.GetHeight(CamPosX, CamPosZ) + 30, CamPosZ, PosX, PosY, PosZ
    
    'Test for the escape key. Fade out
    If Inp.IsKeyPressed(TV_KEY_ESCAPE) = True Then
      Fin = 1
      'Effects.FadeOut 2000
    End If
 Loop Until Fin = 1
 
 Unload IntForm
 Set tv = Nothing
End Sub
Sub Main19()
 Dim Path As New Path8
 

 
 tv.Init3DWindowedMode IntForm.hwnd
'If tv.ShowDriverDialog = False Then Exit Sub
'tv.Initialize
 IntForm.Show
 tv.SetSearchDirectory App.Path + "\cloud\"
 
 TexFactory.LoadTexture "cloud1.dds", "Cloud1", , , TV_COLORKEY_BLACK
 TexFactory.LoadTexture "cloud2.dds", "Cloud2", , , TV_COLORKEY_BLACK
 TexFactory.LoadTexture "terrain.jpg", "Terrain"
 TexFactory.LoadDecalTexture "sun.bmp", "Sun"
 
 Scene.SetSceneBackGround 0.4, 0.6, 0.9
 
 
 Land.GenerateHugeTerrain "c:\coindev\truevision8\cloud\height.jpg", TV_PRECISION_LOW, 10, 10, 0, 0, True
 
 
 Land.InitSun GetTex("Sun"), Vector(-500, 500, -500), 2
 
 Land.InitClouds GetTex("Cloud1"), TV_CLOUD_MOVE, 400, 1, 3, 1, 1
 Land.InitClouds GetTex("Cloud2"), TV_CLOUD_MOVE, 450, 2, 3, 1, 1
 Land.InitClouds GetTex("Cloud2"), TV_CLOUD_MOVE, 500, 3, 3, 1, 1
 Land.SetTextureScale 2, 2
 Land.SetCloudVelocity 1, 0.03, 0.01
 
 Land.SetCloudVelocity 2, 0.05, 0.02
 Land.SetCloudVelocity 3, 0.02, 0.03
 
 Land.SetTexture GetTex("Terrain")
 Dim s As Single
 Do
   tv.Clear
  Land.Render
   Pos
   Dim a As D3DVECTOR
   Dim b As D3DVECTOR
'   Scene.SetCamera a.x, a.y, a.z, b.x, b.y, b.z
   tv.RenderToScreen
   DoEvents
 
 Loop Until Inp.IsKeyPressed(TV_KEY_ESCAPE)
 Set tv = Nothing
End Sub


Sub Main40()
  tv.Init3DWindowedMode IntForm.hwnd
  IntForm.Show
  tv.DisplayFPS = True
  Dim P As Mesh8
  Dim P2 As Mesh8
  Set P = Scene.CreateMeshBuilder()
  Dim li As New LightEngine8
  
  'P.LoadXFile "D:\DXVCSDK\samples\Multimedia\Media\tiger.x"
  P.Load3DsMesh "D:\3drev\53\girl3.3ds"
  Set P2 = P.DuplicateMesh("Girl2")
  P2.SetPosition 100, 100, 100
  P.ComputeSphere
  P2.ComputeSphere
  'P.InitLOD
  'P.SetLOD 50
  Scene.SetSceneBackGround 0, 1, 1
  
  Dim tr As Integer
  tr = li.CreatePointLight(Vector(-2000, -2000, -2000), 10000, 1, 0, 0, 1)
   Do
   tv.Clear
    P.Render
    P2.Render
  '  Device.SetRenderState D3DRS_SHADEMODE, D3DSHADE_GOURAUD
   tv.RenderToScreen
   a = a + tv.TimeElapsed * 0.005
   li.SetLightPosition tr, Vector(Cos(a) * 4000, -2000, Sin(a) * 4000)
  'li.SetLightAttenuation tr, 5, 0, 0
  ' P.SetLODVertexes 20
   P.SetRotation 90, 0, 0
   Pos
   DoEvents
  Loop Until Inp.IsKeyPressed(TV_KEY_ESCAPE)
  
End Sub

Public Sub main9()
  '1. Initialize TrueVision
  'Here we will use windowed mode
  'ATTENTION ! TrueVision supports only
  '16 bits video modes at the moment
  'for windowed mode ! Set your desktop
  'video mode to 16bits one.
  tv.Initialize IntForm.hwnd
  IntForm.Show
  tv.DisplayFPS = True
  Dim Triangle As Mesh8
  '2. Create the mesh
  'Here we will create a simple triangle
  Set Triangle = Scene.CreateMeshBuilder("Triangle")
  
  'Note that you can use the Name Macro to have
  'access to the meshes.
  Scene.SetSceneBackGround 0.2, 0.5, 0.4
  Triangle.SetPrimitiveType TV_TRIANGLESTRIP
  Triangle.SetVertexType TV_COLOR_VERTEX
  Triangle.AddFace Nothing, False
  Triangle.AddVertex -5, -5, 0, RGBA(1, 0, 0, 1), 0, 0
  Triangle.AddVertex 5, -5, 0, RGBA(0, 1, 0, 1), 0, 0
  Triangle.AddVertex -5, 0, 0, RGBA(0, 0, 1, 1), 0, 0
   Scene.LoadCursor "c:\coindev\truevision8\rally\cursor.bmp", TV_COLORKEY_BLACK, 20, 23

  'Place the triangle at (0,0,10) in the world space
  Triangle.SetPosition 0, 0, 10
  
  'Set the camera
  Scene.SetCamera 0, 0, -10, 0, 0, 0
  Dim a As Single
  
  'The main loop.
  Dim mx As Long, my As Long
  Inp.MouseSensitivity = 1
  Do
    'Clear the screen
    tv.Clear
    
    'Render the triangle
    Triangle.Render
    a = a + tv.TimeElapsed * 0.04
    Triangle.SetRotation a, 0, 0
    Inp.GetAbsMouseState mx, my
     
    If Scene.MousePicking(mx, my, TV_COLLIDE_MESH, TV_TESTTYPE_BOUNDINGBOX).IsCollision Then
      Beep
    End If
     LocalScreen.DrawText CStr(mx) + " " + CStr(my), 10, 40, RGBA(1, 1, 1, 1)
    'Copy all to the screen
    tv.RenderToScreen
    
    

    'Test if the Escape Key is pressed
  Loop Until Inp.IsKeyPressed(TV_KEY_ESCAPE) = True
   
  'Shut down the engine
  Set tv = Nothing
  
  
  
End Sub
Public Sub Main8()
  Dim Gl As New Globals8
  'Show the driver windows
  tv.ShowDriverDialog
  tv.DisplayFPS = True
  'Init the 3D stuff
  tv.Initialize IntForm.hwnd
  IntForm.Show
  
  'Set the default directory for the media files
  tv.SetSearchDirectory "c:\coindev\truevision8\carsample\"
  
  
  'Load grass texture for the terrain
  'Note that TrueVision can load DDS textures.
  'You can create DDS textures with Dxtex delivred with DirectX8 sdk
  TexFactory.LoadTexture "grass.dds", "terrain"
  

 'Set the general settings for the scene
  Scene.SetSceneBackGround 0, 0, 0
  Scene.SetViewFrustum 90, 1024
 
 'Load the sky (JPG are really bad compressed. Sorry about that)
 TexFactory.LoadTexture "down.jpg", "Up"
 TexFactory.LoadTexture "left.jpg", "Left"
 TexFactory.LoadTexture "up.jpg", "Down"
 TexFactory.LoadTexture "right.jpg", "Right"
 TexFactory.LoadTexture "front.jpg", "Front"
 TexFactory.LoadTexture "back.jpg", "Back"
 'LocalScreen.LoadBackground "c:\coindev\truevision8\rally\lol1.bmp"
 'Apply the sky in the scene
 Scene.SetSkyTexture GetTex("Front"), GetTex("Back"), GetTex("Left"), GetTex("Right"), GetTex("up"), GetTex("down")

   'TexFactory.LoadTexture "c:\coindev\truevision8\rally\cursor.bmp", "spr", , , RGBA(0, 0, 0, 1)
 'LANSCAPE CREATION
 'New function from TrueVision8
 'You can load any heightmap (any size)
 'and you choose the position and the size of the heightmap in the landscape
 'Note that there is a great AffineTerrain function that makes the terrain more curved.
 
 'I use here 4x4 terrains (1024x1024) but you can try numbers like 8 or 16 (4096x4096 !)
 'On My computer 4x4 runs at 60FPS and 16x16 runs at 40 FPS !
 
 'The heightmap has values from 0 to 255. You can scale them with this SetFactorY method.
 Land.SetFactorY 0.4
 'Land.SetLandscapeMode TV_LANDMODE_ADVANCEDLAND
 Land.GenerateHugeTerrain "height.jpg", TV_PRECISION_AVERAGE, 4, 4, 0, 0, True
 Dim tex(1) As Texture8
 Set tex(0) = GetTex("Up")
 'Land.AdvSetTextureTable 1, Tex()
 
 'For testing the best of the terrain engine try this :
 'Land.SetFactorY 5
 'Land.GenerateHugeTerrain "height.jpg", TV_PRECISION_AVERAGE, 16, 16, 0, 0, True
 
 'Load the car
Set Car = Scene.CreateMeshBuilder("Car")
 'Car.LoadDXE "d:\truck\cc92.dxe"
 'Dim TVO3 As New FileTVO
 '  TVO3.OpenTVO "c:\essai3.msh"
 ' Set Car = TVO3.LoadMesh("Car")
 ' TVO3.CloseTVO
 'Car.LoadFromTVO "c:\essai3.msh"
 Car.ScaleMesh 5, 5, 5

 Car.ComputeSphere
 '"Car.SaveMesh "car1.tvo"
 'and his texture
 TexFactory.LoadTexture "cartex.jpg", "CarTexture"
 Car.SetTexture GetTex("CarTexture")
 
 'Change the texture tiling
 Land.SetTextureScale 1, 1
 Land.SetTexture GetTex("Terrain")
 
 Car.SetMaterial 0
 'create trees
 Dim treeTex(2) As Texture8
 Set treeTex(1) = TexFactory.LoadTexture("tree3c.dds", , , , RGBA(0, 0, 0, 1))
 Set treeTex(2) = TexFactory.LoadTexture("tree4c.dds", , , , RGBA(0, 0, 0, 1))
 
 Dim x As Single, z As Single, y As Single
 Dim Trees(100) As Mesh8
  For i = 1 To 100
     x = Rnd * 1024
     z = Rnd * 1024
     y = Land.GetHeight(x, z) + 5
     Set Trees(i) = Scene.CreateBillboard(treeTex(Int(Rnd * 2) + 1), x, y, z, 40, -40)
     'Trees(i).SetPrimitiveType TV_TRIANGLESTRIP
     'Trees(i).AddWall treeTex(1), x, z + 20, x, z - 20, 40, 0
     Trees(i).SetPosition x, y + 35, z
     'Trees(i).SetTexture treeTex
     Trees(i).ComputeSphere
     'Trees(i).ScaleMesh 0, 0, 1
'     Debug.Print x, y, z
      
  Next i

'Enable mip mapping for more speed. Optional


Scene.EnableMipMapping

'Scene.LoadTexture "texturewater.bmp", , , "Water"
'Land.SetWaterEnable True
'Land.SetWaterAltitude 50
'Land.SetWaterTexture GetTex("Water")
'Land.SetWaterEffect True, , True

Dim scr As New Screen8
Scene.LoadCursor "c:\coindev\truevision8\rally\cursor.bmp", TV_COLORKEY_BLACK

Dim PosX As Single, PosY As Single, PosZ As Single, Ang As Single, Fin As Integer
Dim CamPosX As Single, CamPosZ As Single, ang2 As Single, ang3 As Single, posy1 As Single
Dim posy2 As Single
 
 'Put the car in the center of the terrain
 PosX = 512
 PosZ = 512
 
 
 'Fade in  ( really simplified, you have to call it once with the desired
 'speed in milliseconds)
 Effects.FadeIn 3000
 
 'Set a fog effect for the terrain only
 'Effects.SetFog True, 0, 0, 0, 0, 1, 700
  
 'Game loop

  Dim TVO As New FileTVO
  TVO.OpenTVO "c:\land.txt", False
  TVO.AddLandscape
   TVO.CloseTVO
'

 Land.CreateDynTextures 256, 256
 Dim inter As New InternalObjects8
 Do
   
  'Clear the screen
  
  tv.Clear
  Device.SetRenderState D3DRS_ZENABLE, 1
  Device.SetRenderState D3DRS_ZWRITEENABLE, 1
  Gl.SetUserClipPlane False, 0, 0, 1, 0, 20
  Scene.RenderSky
  
  
  'Render the entire landscape

 ' LocalScreen.DrawTexture GetTex("spr"), 0, 0, 300, 300, , True
   Gl.SetUserClipPlane True, 0, 0, 1, 0, -50
   Land.Render
   Gl.SetUserClipPlane False, 0, 0, 1, 0, 20
  Scene.RenderAllMeshes
  
  'inter.GetDevice3D.SetRenderState D3DRS_CULLMODE, D3DCULL_NONE
  
  'Cancel the fog for drawing the sky
  Dim a As Single
  a = a + tv.TimeElapsed * 0.01
  tv.Start2D
  scr.DrawTextureRotated treeTex(1), 100, 100, 500, 500, a, , False
  scr.DrawTexture treeTex(1), 100, 100, 200, 200, , False
  
  'Render the sky (you have to call this method just after the terrain rendering)

  
  'Render the trees and the car
  
  'ScreenShot Taking takes a few seconds. TV has to convert the color format
  'BackBuffer formats supported : R5G6B5 & X8R8G8B8 & A8R8G8B8
  'other formats can give strange results !
 If Inp.IsKeyPressed(TV_KEY_S) = True Then
   tv.ScreenShot "c:\key.bmp"
  End If
  
  'Flip all on the screen
   
  'Input keyboard
   If Inp.IsKeyPressed(TV_KEY_1) = True Then
     Scene.SetRenderMode TV_LINE
   End If
   If Inp.IsKeyPressed(TV_KEY_2) = True Then
     Scene.SetRenderMode TV_POINT
   End If
   If Inp.IsKeyPressed(TV_KEY_3) = True Then
     Scene.SetRenderMode TV_SOLID
   End If
   
   If Inp.IsKeyPressed(TV_KEY_UP) = True Then
     Speed = Speed - 0.01 * tv.TimeElapsed * (Speed < 2)
   End If
   
   If Inp.IsKeyPressed(TV_KEY_DOWN) = True Then
     Speed = Speed + 0.01 * tv.TimeElapsed * (Speed > -0.1)
   End If
   PosX = PosX + Cos(Ang) * Speed * tv.TimeElapsed * 0.05
   PosZ = PosZ + Sin(Ang) * Speed * tv.TimeElapsed * 0.05
   If Inp.IsKeyPressed(TV_KEY_LEFT) = True Then
       Ang = Ang + tv.TimeElapsed * 0.005
   End If
   If Inp.IsKeyPressed(TV_KEY_RIGHT) = True Then
       Ang = Ang - tv.TimeElapsed * 0.005
   End If
   If Inp.IsKeyPressed(TV_KEY_SUBTRACT) = True Then
       PosY = PosY + tv.TimeElapsed * 0.05
   End If
   If Inp.IsKeyPressed(TV_KEY_ADD) = True Then
       PosY = PosY - tv.TimeElapsed * 0.05
   End If
   Dim MP As CollisionResult8
   Dim mx As Long, my As Long, b1 As Integer
   
 
  tv.RenderToScreen
     Inp.GetAbsMouseState mx, my, b1
    Set MP = Scene.MousePicking(mx, my, TV_COLLIDE_LANDSCAPE, TV_TESTTYPE_ACCURATETESTING)
   If MP.IsCollision = True And b1 <> 0 Then
      Land.DynDrawTexture treeTex(1), MP.GetImpactPoint.x - 10, MP.GetImpactPoint.z - 10, MP.GetImpactPoint.x + 10, MP.GetImpactPoint.z + 10
   '    ' Trees(1).SetPosition MP.GetImpactPoint.x, MP.GetImpactPoint.y + 40, MP.GetImpactPoint.z
   '    Land.AdvEnableChunk False, MP.GetImpactPoint.x, MP.GetImpactPoint.z
   'PosX = MP.GetImpactPoint.x
   'PosY = MP.GetImpactPoint.y
   'PosZ = MP.GetImpactPoint.z
   Trees(1).SetPosition MP.GetImpactPoint.x, MP.GetImpactPoint.y, MP.GetImpactPoint.z
   End If
   'Change the position altitude according to the terrain altitude
   PosY = Land.GetHeight(PosX, PosZ) + 3
   CamPosX = PosX - Cos(Ang) * 20
   CamPosZ = PosZ - Sin(Ang) * 20
   
   'Check the <
   posy1 = Land.GetHeight(PosX + Cos(Ang) * 10, PosZ + Sin(Ang) * 10)
   posy2 = Land.GetHeight(PosX - Cos(Ang) * 10, PosZ - Sin(Ang) * 10)
   
   ang2 = Atn((posy1 - posy2) / 20)
   posy1 = Land.GetHeight(PosX - Sin(Ang) * 4, PosZ - Cos(Ang) * 4)
   posy2 = Land.GetHeight(PosX + Sin(Ang) * 4, PosZ + Cos(Ang) * 4)

   ang3 = Atn((posy1 - posy2) / 8)
   
   Car.SetRotation -ang2 * 180 / 3.14, 90 - Ang * 180 / 3.14, 360 - ang3 * 180 / 3.14
  Car.SetPosition PosX, PosY, PosZ
   
   
   
   'Place the camera
   Scene.SetCamera CamPosX, Land.GetHeight(CamPosX, CamPosZ) + 30, CamPosZ, PosX, PosY, PosZ
   'Camera.PurchaseFollowing Car, Vector(0, 3, -4), Vector(0, 0, 0), 100, False, 100
   Camera.SetCameraPosition Camera.GetCameraPosition.x, Land.GetHeight(Camera.GetCameraPosition.x, Camera.GetCameraPosition.z) + 20, Camera.GetCameraPosition.z
    
    'Test for the escape key. Fade out
    If Inp.IsKeyPressed(TV_KEY_ESCAPE) = True Then
      Fin = 1
      Effects.FadeOut 2000
    End If
 Loop Until Effects.FadeFinished = True And Fin = 1
 
 Unload IntForm
 Set tv = Nothing
  
 
End Sub
Sub Main()
Dim b As Integer

Dim l As New Landscape8
Dim s As New Scene8
Dim t As New TextureFactory8
'Dim So As New SoundEngine8
Dim BSP As New BSPTree8


 tv.ShowDriverDialog
 tv.Initialize ' IntForm.hwnd
 tv.DisplayFPS = True
 IntForm.Show
 't.LoadTexture "c:\3drev\15\tex.bmp", "Terrain"
 t.LoadTexture "d:\grass.dds", "terrain"
 s.SetSceneBackGround 0.5, 0.9, 1#
l.SetFactorY 0.5
 s.SetViewFrustum 90, 4096
tv.SetSearchDirectory "c:\coindev\truevision7\media\"

tv.OpenPAKFile "c:\sierra\half-life\valve\pak0.pak"
BSP.OpenPackWAD "c:\sierra\half-life\valve\halflife.wad"
'BSP.Load "maps/c1a4j.bsp", True, True, False, "c:\coindev\truevision7\media\", False, False
BSP.Load "d:\tut7b.bsp", True, True, False, "c:\coindev\truevision7\media\", False, False

'BSP.Load "mapams/snark_pit.bsp", True, True, False, , False, False
'BSP.SetPareters True, True, TV_DOUBLESIDED
BSP.ClosePackWAD
'tv.OpenPAKFile "c:\sierra\half-life\valve\pak0.pak"
'BSP.OpenPackWAD "c:\sierra\half-life\cs\de_aztec.wad"
'BSP.Load "C:\Sierra\Half-Life\cstrike\maps\de_aztec.bsp", True, True, False, , False, False
'BSP.SetPareters True, True, TV_DOUBLESIDED
'BSP.ClosePackWAD

tv.ClosePAKFile
't.LoadTexture "c:\3drev\15\down.jpg", "Up"
''t.LoadTexture "c:\3drev\15\left.jpg", "Left"
't.LoadTexture "c:\3drev\15\up.jpg", "Down"
't.LoadTexture "c:\3drev\15\right.jpg", "Right"
't.LoadTexture "c:\3drev\15\front.jpg", "Front"
't.LoadTexture "c:\3drev\15\back.jpg", "Back"'

'S.SetSkyTexture GetTex("Front"), GetTex("Back"), GetTex("Left"), GetTex("Right"), GetTex("up"), GetTex("down")

'l.GenerateHugeTerrain "c:\3drev\15\height.jpg", TV_PRECISION_AVERAGE, 4, 4, 0, 0, True
 'l.GenerateTerrain "C:\coindev\truevision8\essai\height.jpg", TV_PRECISION_HIGH, 0, 0
'l.GenerateTerrain "C:\coindev\truevision8\essai\height.jpg", TV_PRECISION_HIGH, 256, 0
'l.GenerateTerrain "C:\coindev\truevision8\essai\height.jpg", TV_PRECISION_HIGH, 0, 256
'l.GenerateTerrain "C:\coindev\truevision8\essai\height.jpg", TV_PRECISION_HIGH, 256, 256
 l.SetTextureScale 4, 4
 l.SetTexture GetTex("Terrain")
'So.LoadSound "c:\mere.wav", False, "Mere"
'So.Play GetSound("Mere")
d = True
On Error GoTo gg
Dim PosX As Single, PosY As Single, PosZ As Single, Ang As Single
 PosX = BSP.GetStartPlayerPosition.x
 PosY = BSP.GetStartPlayerPosition.y
 PosZ = BSP.GetStartPlayerPosition.z
  s.LoadCursor "c:\coindev\truevision8\rally\cursor.bmp", TV_COLORKEY_BLACK, 32, 32
 Dim Eff As New GraphicEffect8
 'Eff.FadeIn 4000
 Dim Possx As Single, possy As Single, possz As Single
 'Eff.SetFog True, 0, 0, 0.1, 1, 1, 300
 s.SetCollisionPrecision 10
 Dim mx As Long, my As Long, b1 As Integer
 Dim MP As CollisionResult8
 Do
   
   tv.Clear
 ' l.Render
 ' S.RenderSky
   BSP.Render
   Scene.RenderAllMeshes
    Inp.GetAbsMouseState mx, my, b1
    
    If Inp.IsKeyPressed(TV_KEY_S) = True Then
     tv.ScreenShot "c:\essai.bmp"
    End If
    If b1 <> 0 Then
      Set MP = Scene.MousePicking(mx, my, TV_COLLIDE_BSPTREE, TV_TESTTYPE_ACCURATETESTING)
      If MP.IsCollision = True Then
         CreateDecal MP.GetImpactPoint, VNormalize(MP.GetCollisionNormal), Nothing, 20, 0
      End If
    End If
    
   tv.RenderToScreen
   Possx = PosX
   possy = PosY
   possz = PosZ
   If Inp.IsKeyPressed(TV_KEY_1) = True Then
     s.SetRenderMode TV_LINE
   End If
   If Inp.IsKeyPressed(TV_KEY_2) = True Then
     s.SetRenderMode TV_POINT
   End If
   If Inp.IsKeyPressed(TV_KEY_3) = True Then
     s.SetRenderMode TV_SOLID
   End If
   
   If Inp.IsKeyPressed(TV_KEY_UP) = True Then
       Possx = PosX + Cos(Ang) * tv.TimeElapsed * 0.2
       possz = PosZ + Sin(Ang) * tv.TimeElapsed * 0.2
   End If
   If Inp.IsKeyPressed(TV_KEY_DOWN) = True Then
       Possx = PosX - Cos(Ang) * tv.TimeElapsed * 0.2
       possz = PosZ - Sin(Ang) * tv.TimeElapsed * 0.2
   End If
   If Inp.IsKeyPressed(TV_KEY_LEFT) = True Then
       Ang = Ang + tv.TimeElapsed * 0.005
   End If
   If Inp.IsKeyPressed(TV_KEY_RIGHT) = True Then
       Ang = Ang - tv.TimeElapsed * 0.005
   End If
   If Inp.IsKeyPressed(TV_KEY_SUBTRACT) = True Then
       possy = PosY + tv.TimeElapsed * 0.05
   End If
   If Inp.IsKeyPressed(TV_KEY_Q) = True Then
       possy = PosY - tv.TimeElapsed * 0.05
   End If
   If Inp.IsKeyPressed(TV_KEY_C) = True Then
    d = Not d
   End If
    d = True
   If d = True Then
     If BSP.DetectSphereCollision(Vector3(Possx, possy, possz), 3) = False Then
      PosX = Possx
      PosY = possy
      PosZ = possz

     End If
   Else
      PosX = Possx
      PosY = possy
      PosZ = possz
   End If
'   Else
'      Debug.Print "eeyre"
'   End If
   
  ' PosY = l.GetHeight(PosX, PosZ) + 10
   s.SetCamera PosX, PosY, PosZ, PosX + Cos(Ang), PosY, PosZ + Sin(Ang)
    If Inp.IsKeyPressed(TV_KEY_ESCAPE) = True Then
      Fin = 1
    '  Eff.FadeOut 5000
    End If
 Loop Until Fin = 1
 Set BSP = Nothing
 Set tv = Nothing

  Exit Sub
gg:
 AddLog CStr(Err.Number) + " " + Err.Description
 Resume Next
End Sub
Function CreateDecal(Position As D3DVECTOR, normal As D3DVECTOR, Texture As Texture8, Size As Single, Optional DeathTime As Single = 0) As Mesh8
   Set CreateDecal = LocalScene.CreateMeshBuilder("Decal")
   ' Calculate right component of view vector
   'L_dVR = VCrossProduct(L_dVDefaultUp, L_dVView)
   Dim V1 As D3DVECTOR, V2 As D3DVECTOR, v3 As D3DVECTOR
   V1 = Vector(0, 1, 0)
   V2 = normal
   D3DXVec3Cross v3, V1, V2
   
   ' Calculate up component of view vector
   D3DXVec3Cross V1, V2, v3
   
    'L_dVU = VCrossProduct(L_dVView, L_dVR)
        
   ' Normalize right and up
   V1 = VNormalize(V1)
   V2 = VNormalize(v3)
   
   'fix the y-plane bug
   If VCompare(normal, Vector(0, 1, 0)) <> 0 Then
     V1.x = 1
     V2.z = 1
   End If
   If VCompare(normal, Vector(0, -1, 0)) <> 0 Then
     V1.x = -1
     V2.z = -1
   End If
   
   Dim s As Single
   s = Size / 2
   
   
   Dim V(4) As D3DVECTOR
   V(1) = VScale(VAdd(VNegate(V1), VNegate(V2)), s)
   V(2) = VScale(VAdd(V1, VNegate(V2)), s)
   V(3) = VScale(VAdd(VNegate(V1), V2), s)
   V(4) = VScale(VAdd(V1, V2), s)
   
   
   CreateDecal.SetPosition Position.x + normal.x * 1, Position.y + normal.y * 1, Position.z + normal.z * 1
   CreateDecal.SetDeathTime DeathTime
   CreateDecal.AddFaceFromPoint Texture, V(1).x, V(1).y, V(1).z, V(2).x, V(2).y, V(2).z, V(3).x, V(3).y, V(3).z, V(4).x, V(4).y, V(4).z
   CreateDecal.SetPrimitiveType TV_TRIANGLESTRIP
   CreateDecal.SetVertexType TV_COLOR_VERTEX
   CreateDecal.SetBlendingMode TV_BLEND_COLOR
End Function
Function GetSound(SoundName As String) As Integer
  For i = 1 To NBSounds
     
     
     If UCase$(SoundName) = UCase$(Sounds(i).SoundName) Then
       GetSound = i
       Exit Function
     End If
  Next i
  GetSound = 0
End Function

Sub Main2()
  tv.Initialize
  Dim d() As Byte, b As Byte
  Dim tex As Direct3DTexture8
  Open "c:\lpe.bmp" For Binary As 2
     ReDim Preserve d(LOF(2))
     Dim bm As BITMAPINFOHEADER, bm2 As BITMAPHEADER
     Get #2, , d
     Get #2, 4, b
     Get #2, 15, bm
     Get #2, 1, bm2
     For i = 0 To 53
      
      Debug.Print Format(d(i), "000"); " ";
     Next i
     Debug.Print bm.biBitCount, bm.biWidth, bm.biHeight, bm.biPlanes, bm.biSize
     Debug.Print bm2.magic, bm2.offset, bm2.Size
     
   
     Set tex = D3DX.CreateTextureFromFileInMemory(Device, d(0), LOF(2))
    Close
     Dim sprite As D3DXSprite
    Set sprite = D3DX.CreateSprite(Device)
    Dim Rot As D3DVECTOR2
    Dim Scl As D3DVECTOR2
    Dim tra As D3DVECTOR2
    Rot.x = 5
    Rot.y = 5
    Scl.x = 1
    Scl.y = 1
    tra.x = 100
    tra.y = 100
Do
 tv.Clear
 r = r + tv.TimeElapsed * 0.002
 sprite.Draw tex, ByVal 0, Scl, Rot, r, tra, &HFFFFFFFF
 tv.RenderToScreen

Loop Until Inp.IsKeyPressed(TV_KEY_ESCAPE) = True

  Set tv = Nothing
End Sub

Sub Main3()
    Dim a As Direct3DTexture8
    Dim b(54) As Byte
    f = Array(255, 0, 0, _
              0, 255, 0, _
              0, 0, 255, _
              255, 255, 255, _
              0, 0, 0, _
              255, 255, 255, _
              0, 0, 0, _
              255, 255, 255, _
              0, 0, 0, _
              255, 255, 255, _
              128, 128, 128, _
              128, 128, 128, _
              255, 0, 0, _
              255, 0, 0, _
              255, 0, 0, _
              255, 255, 0, _
              255, 255, 0, _
              255, 255, 0 _
              )
    For i = 0 To 53
      b(i) = f(i)
    Next i
    Set a = LoadTextureFromMemory(3, 5, 24, b)
End Sub


Public Sub Main4()
    Dim s As New Scene8
    Dim b As New ParticleSystem8
    Dim d As New ParticleSystem8
    Dim t As Texture8
    tv.ShowDriverDialog
    tv.Initialize ' IntForm.Hwnd
   tv.DisplayFPS = True
    Set t = s.LoadTexture("c:\coindev\truevision7\particle\snow.bmp", , , "sprite")
   b.CreateBillboardSystem 200, 0, 0.2, Vector(10, 10, 10), 0, t
   b.SetParticleSpeed 0.005
   b.SetGeneratorSpeed 30
   b.SetPraticleAutoGenerateMode True, 1, 1, 1, 1, 16, -0.2, 1, -0.2, 0.4, 0.5, 0.4
   b.SetGravity 1, 0.5
   b.SetAlphaBlendingMode TV_CHANGE_NO
   b.SetParticleTexture t, 0
   
   
   d.CreateBillboardSystem 200, 0, 0.2, Vector(260, 10, 10), 0, t
   d.SetParticleSpeed 0.005
   d.SetGeneratorSpeed 20
   d.SetPraticleAutoGenerateMode True, 1, 0, 0, 1, 16, -0.2, 1, -0.2, 0.4, 0.5, 0.4
   d.SetGravity 1, 0.5
   d.SetAlphaBlendingMode TV_CHANGE_NO
   d.SetParticleTexture t, 0
   
   
    Dim PosX As Single, PosY As Single, PosZ As Single, Ang As Single
    Do
   
   tv.Clear
   b.RenderParticles
   b.UpdateParticles TV_UPDATE_GENERATOR Or TV_UPDATE_BOTH Or TV_UPDATE_BOUNCE_ON_Y0_PLANE
   
 
   d.RenderParticles
   d.UpdateParticles TV_UPDATE_GENERATOR Or TV_UPDATE_BOTH Or TV_UPDATE_BOUNCE_ON_Y0_PLANE
   tv.RenderToScreen
   
   
   If Inp.IsKeyPressed(TV_KEY_1) = True Then
     s.SetRenderMode TV_LINE
   End If
   If Inp.IsKeyPressed(TV_KEY_2) = True Then
     s.SetRenderMode TV_POINT
   End If
   If Inp.IsKeyPressed(TV_KEY_3) = True Then
     s.SetRenderMode TV_SOLID
   End If
   
   If Inp.IsKeyPressed(TV_KEY_UP) = True Then
       PosX = PosX + Cos(Ang) * tv.TimeElapsed * 0.05
       PosZ = PosZ + Sin(Ang) * tv.TimeElapsed * 0.05
   End If
   If Inp.IsKeyPressed(TV_KEY_DOWN) = True Then
       PosX = PosX - Cos(Ang) * tv.TimeElapsed * 0.05
       PosZ = PosZ - Sin(Ang) * tv.TimeElapsed * 0.05
   End If
   If Inp.IsKeyPressed(TV_KEY_LEFT) = True Then
       Ang = Ang + tv.TimeElapsed * 0.005
   End If
   If Inp.IsKeyPressed(TV_KEY_RIGHT) = True Then
       Ang = Ang - tv.TimeElapsed * 0.005
   End If
   If Inp.IsKeyPressed(TV_KEY_SUBTRACT) = True Then
       PosY = PosY + tv.TimeElapsed * 0.05
   End If
   If Inp.IsKeyPressed(TV_KEY_ADD) = True Then
       PosY = PosY - tv.TimeElapsed * 0.05
   End If
   
  ' PosY = l.GetHeight(PosX, PosZ) + 10
   s.SetCamera PosX, PosY, PosZ, PosX + Cos(Ang), PosY, PosZ + Sin(Ang)
   
 Loop Until Inp.IsKeyPressed(TV_KEY_ESCAPE) = True

 Set tv = Nothing
 
End Sub

Sub Main6()
   tv.Initialize IntForm.hwnd
    tv.DisplayFPS = True
   IntForm.Show
    On Error Resume Next
    Dim Mesh As Mesh8, s As New Scene8
    s.SetSceneBackGround 0, 0, 0
    Dim l As New LightEngine8
   ' L.CreatePointLight Vector(100, 100, 100), 10000, 30, 30, 30, 1
   ' L.CreatePointLight Vector(1000, 1000, 1000), 100000, 30, 30, 30, 10

    tv.SetSearchDirectory "c:\coindev\truevision8\md3\"
   ' l.CreateDirectionalLight Vector(1, -1, 0), 1, 1, 1, 1
   Dim Actor As New Actor8
   Dim Actor2 As New Actor8
   Dim actor3 As New Actor8

     Actor.Load "c:\coindev\truevision8\md3\lower_2.md3"
  '    Actor2.Load "c:\models\barney.mdl"
 '    Actor.SetScale 1, 1, 1
  '    Actor2.AttachTo Actor, 0
      Actor2.Load "c:\coindev\truevision8\md3\upper_2.md3"
      actor3.Load "c:\coindev\truevision8\md3\head_2.md3"
      Actor2.AttachTo Actor, 0
      actor3.AttachTo Actor2, 0
      
      LocTexFactory.LoadTexture "c:\coindev\truevision8\md3\blue.jpg", "blue"
      Actor.SetMD3Texture GetTex("blue")
      Actor2.SetMD3Texture GetTex("blue")
      actor3.SetMD3Texture GetTex("blue")
      
   
   ' Set Mesh = S.CreateMeshBuilder
    'LoadDXE "d:\truck\cc92.dxe", Mesh
   ' LocTexFactory.LoadTexture "d:\truck\cc92.bmp", "Merc"
   ' LocTexFactory.LoadTexturmaie "d:\truck\truck.jpg", "Truck"
    'Mesh.SetTexture GetTex("Truck"), 1
    'Mesh.SetTexture GetTex("Merc")
    'Mesh.SetPrimitiveType TV_TRIANGLELIST
    'Mesh.SaveMesh "d:\car1.tvo"
    'Mesh.LoadMesh "d:\car1.tvo"
     Mesh.ScaleMesh 3, 3, 3
    Dim PosX As Single, PosY As Single, PosZ As Single, Ang As Single
    Dim Arbre As Mesh8
    '   Scene.LoadCursor "c:\coindev\truevision8\arrow.bmp", TV_COLORKEY_BLACK, 20, 23
    'Dim ArbreTexture As Texture8
    'Set ArbreTexture = LocTexFactory.LoadTexture("c:\coindev\truevision8\carsample\tree1.bmp", "ee", 256, 256, 0)
    '
    'Set Arbre = S.CreateBillboard(ArbreTexture, 0, 0, 0, 40, 40, "Tree")
    'Arbre.SetTexture ArbreTexture, 1
   'Arbre.SetGroupPointer 1
   ' Arbre.ScaleMesh -1, -1, -1
    Actor.SetSpeed 1
    Actor2.SetSpeed 1
    actor3.SetSpeed 1
    
    Actor.SetScale 1, 1, 1
    'Actor2.SetSpeed 0
    'actor3.SetSpeed 0
    
    Actor.SetRotation 0, 0, 0
    Dim mx As Long, my As Long, proj As D3DVECTOR, near As D3DVECTOR
    Dim Touch As Integer
    Actor.SetScale 1, 1, 1
    'Debug.Print Actor.GetModelInfo.NumBoneControllers, Actor.GetModelInfo.NumSequences
    Do
    
    tv.Clear
    Actor.Render
    Actor2.Render
    actor3.Render
    
  '  Inp.GetAbsMouseState mx, my
  '  x = x + tv.TimeElapsed * 0.0009
  '  Effects.ChangeGamma (x - Int(x)) * 2
    
  '  Actor.SetRotation 0, x, 0
  '  GetProjetedVector mx, my, near, proj
  '  Actor.Collide near, proj, TV_TESTTYPE_MDL_HITBOXES, Touch
  '  If Touch <> 0 Then
  '    Debug.Print Actor.GetBoneNameFromID(Touch)
  '  End If
    ' Mesh.Render
   If Inp.IsKeyPressed(TV_KEY_1) = True Then
     s.SetRenderMode TV_LINE
   End If
   
   If Inp.IsKeyPressed(TV_KEY_2) = True Then
     s.SetRenderMode TV_POINT
   End If
   
   If Inp.IsKeyPressed(TV_KEY_3) = True Then
     s.SetRenderMode TV_SOLID
   End If
   
   If Inp.IsKeyPressed(TV_KEY_UP) = True Then
       PosX = PosX + Cos(Ang) * tv.TimeElapsed * 0.5
       PosZ = PosZ + Sin(Ang) * tv.TimeElapsed * 0.5
   End If
   
   If Inp.IsKeyPressed(TV_KEY_DOWN) = True Then
       PosX = PosX - Cos(Ang) * tv.TimeElapsed * 0.5
       PosZ = PosZ - Sin(Ang) * tv.TimeElapsed * 0.5
   End If
   
   If Inp.IsKeyPressed(TV_KEY_LEFT) = True Then
       Ang = Ang + tv.TimeElapsed * 0.005
   End If
   
   If Inp.IsKeyPressed(TV_KEY_RIGHT) = True Then
       Ang = Ang - tv.TimeElapsed * 0.005
   End If
   If Inp.IsKeyPressed(TV_KEY_SUBTRACT) = True Then
       PosY = PosY + tv.TimeElapsed * 0.05
   End If
   If Inp.IsKeyPressed(TV_KEY_ADD) = True Then
       PosY = PosY - tv.TimeElapsed * 0.05
   End If
   
      s.SetCamera PosX, PosY, PosZ, PosX + Cos(Ang), PosY, PosZ + Sin(Ang)
     s.DrawText CStr(Actor.GetFrame) + " ee" + CStr(Actor2.GetFrame) + " " + CStr(actor3.GetFrame), 10, 20
   
   tv.RenderToScreen
    Loop Until Inp.IsKeyPressed(TV_KEY_ESCAPE) = True
    Set tv = Nothing
End Sub
Sub Main5()
    tv.Init3DWindowedMode IntForm.hwnd

    On Error Resume Next
    Dim Mesh As Mesh8, s As New Scene8
    s.SetSceneBackGround 0.5, 0.5, 0.5
    Set Mesh = s.CreateMeshBuilder("Mesh1")
    s.LoadTexture "c:\", , , "Sprite"
    'Mesh.LoadXFile "D:\DXVBSDK\samples\Multimedia\VBSamples\Media\skybox2.x"
    'Mesh.Load3DsMesh "d:\alphonse.3ds"
    Mesh.Load3DsMesh "c:\coindev\truevision8\tutorial3\gor2.3ds"
    'Mesh.AddWall GetTex("Sprite"), -5, -5, 5, 5, 20, 0
    'Mesh.AddWall GetTex("Sprite"), 50, -5, 50, 5, 20, 0
    
    Dim PosX As Single, PosY As Single, PosZ As Single, Ang As Single
    Do
    tv.Clear
   
    Mesh.Render
   If Inp.IsKeyPressed(TV_KEY_1) = True Then
     s.SetRenderMode TV_LINE
   End If
   
   If Inp.IsKeyPressed(TV_KEY_2) = True Then
     s.SetRenderMode TV_POINT
   End If
   
   If Inp.IsKeyPressed(TV_KEY_3) = True Then
     s.SetRenderMode TV_SOLID
   End If
   
   If Inp.IsKeyPressed(TV_KEY_UP) = True Then
       PosX = PosX + Cos(Ang) * tv.TimeElapsed * 0.05
       PosZ = PosZ + Sin(Ang) * tv.TimeElapsed * 0.05
   End If
   
   If Inp.IsKeyPressed(TV_KEY_DOWN) = True Then
       PosX = PosX - Cos(Ang) * tv.TimeElapsed * 0.05
       PosZ = PosZ - Sin(Ang) * tv.TimeElapsed * 0.05
   End If
   
   If Inp.IsKeyPressed(TV_KEY_LEFT) = True Then
       Ang = Ang + tv.TimeElapsed * 0.005
   End If
   
   If Inp.IsKeyPressed(TV_KEY_RIGHT) = True Then
       Ang = Ang - tv.TimeElapsed * 0.005
   End If
   If Inp.IsKeyPressed(TV_KEY_SUBTRACT) = True Then
       PosY = PosY + tv.TimeElapsed * 0.05
   End If
   If Inp.IsKeyPressed(TV_KEY_ADD) = True Then
       PosY = PosY - tv.TimeElapsed * 0.05
   End If
      s.SetCamera PosX, PosY, PosZ, PosX + Cos(Ang), PosY, PosZ + Sin(Ang)
   tv.RenderToScreen
    Loop Until Inp.IsKeyPressed(TV_KEY_ESCAPE) = True
    Set tv = Nothing
End Sub

Sub Main7()
  tv.Initialize IntForm.hwnd
   IntForm.Show
    On Error Resume Next
    Dim Mesh As Mesh8, s As New Scene8
    s.SetSceneBackGround 0, 0, 0

    Set Mesh = s.CreateMeshBuilder
    'Mesh.CreateTeapot
    'Mesh.CreateSphere Nothing, 5, 12, 12
    Mesh.ScaleMesh 4, 4, 4
    Mesh.Load3DsMesh "d:\alphonse.3ds"
    s.LoadTexture "c:\spheremap.bmp", , , "Sphere"
    Mesh.SetTexture GetTex("Sphere")
    'Mesh.EnableSphereMapping True
    Device.SetRenderState D3DRS_NORMALIZENORMALS, 1
    Dim PosX As Single, PosY As Single, PosZ As Single, Ang As Single
    Dim a As Single
    Do
    
    tv.Clear
    
    a = a + tv.TimeElapsed * 0.02
    Mesh.SetRotation 0, 0, a
    Mesh.Render
     'Mesh.Render
   If Inp.IsKeyPressed(TV_KEY_1) = True Then
     s.SetRenderMode TV_LINE
   End If
   
   If Inp.IsKeyPressed(TV_KEY_2) = True Then
     s.SetRenderMode TV_POINT
   End If
   
   If Inp.IsKeyPressed(TV_KEY_3) = True Then
     s.SetRenderMode TV_SOLID
   End If
   
   If Inp.IsKeyPressed(TV_KEY_UP) = True Then
       PosX = PosX + Cos(Ang) * tv.TimeElapsed * 0.05
       PosZ = PosZ + Sin(Ang) * tv.TimeElapsed * 0.05
   End If
   
   If Inp.IsKeyPressed(TV_KEY_DOWN) = True Then
       PosX = PosX - Cos(Ang) * tv.TimeElapsed * 0.05
       PosZ = PosZ - Sin(Ang) * tv.TimeElapsed * 0.05
   End If
   
   If Inp.IsKeyPressed(TV_KEY_LEFT) = True Then
       Ang = Ang + tv.TimeElapsed * 0.005
   End If
   
   If Inp.IsKeyPressed(TV_KEY_RIGHT) = True Then
       Ang = Ang - tv.TimeElapsed * 0.005
   End If
   If Inp.IsKeyPressed(TV_KEY_SUBTRACT) = True Then
       PosY = PosY + tv.TimeElapsed * 0.05
   End If
   If Inp.IsKeyPressed(TV_KEY_ADD) = True Then
       PosY = PosY - tv.TimeElapsed * 0.05
   End If
      s.SetCamera PosX, PosY, PosZ, PosX + Cos(Ang), PosY, PosZ + Sin(Ang)
   tv.RenderToScreen
    Loop Until Inp.IsKeyPressed(TV_KEY_ESCAPE) = True
    Set s = Nothing
    Set Mesh = Nothing
    Set tv = Nothing
End Sub
Public Sub Main30()
   
   
   '1. Show the driver window
   tv.ShowDriverDialog
   
   '2. Initialize the engine with the selected mode
   IntForm.Show
   tv.Initialize IntForm.hwnd
   
   
   '3. Set the default path for the medias
   tv.SetSearchDirectory App.Path
   
   '----------------------------------------
   ' Create a teapot mesh with chroma effect
   '----------------------------------------
   'The teapot mesh is a standard mesh in D3DX8
   Set Teapot = Scene.CreateMeshBuilder("Teapot")
   Teapot.CreateTeapot
   
   'Load the spheremap like a normal texture
   'Note : See the spheremap bitmap to understand the texture
   '       type you have to load in order to have chroma effect
   Scene.LoadTexture "chromekey/spheremap.bmp", , , "SphereMapTexture"
   
   'Apply the sphere map onto the teapot
   Teapot.SetTexture GetTex("SphereMapTexture")
   
   'Enable the chroma effect
   Teapot.EnableSphereMapping True, 1
   
   Dim a As Single
   '------------------------
   'And the usual do-loop :
   '------------------------
   
   'Set the camera in front of the teapot*
   Scene.SetCamera 0, 0, -8, 0, 0, 0
   
   Do
    'Clear the screen
    tv.Clear
    
    'Rotate the teapot
    a = a + tv.TimeElapsed * 0.02
    Teapot.SetRotation 0, a, a
    
    'Display it
    Teapot.Render
    
    'And render all to the screen
    tv.RenderToScreen
   
   Loop Until Inp.IsKeyPressed(TV_KEY_ESCAPE) = True
   
   Set tv = Nothing
   
   
End Sub

Sub Plane()
  Dim a As D3DPLANE
  Dim b As D3DPLANE
  b.a = 1
  b.b = 1
  b.C = 1
  b.d = 40
  D3DXPlaneNormalize b, b
  Debug.Print D3DXPlaneIntersectLine(a, b, Vector(0, 0, 0), Vector(0, 10, 0))
  
  Debug.Print a.a, a.b, a.C, a.d
  
  
  D3DXPlaneFromPointNormal a, Vector(0, -6, 0), Vector(-0.707, 0.707, 0)
  Debug.Print a.a, a.b, a.C, a.d
End Sub

Sub Pos()
   Static PosX As Single, PosY As Single, PosZ As Single, Ang As Single
   If Inp.IsKeyPressed(TV_KEY_UP) = True Then
       PosX = PosX + Cos(Ang) * tv.TimeElapsed * 0.05
       PosZ = PosZ + Sin(Ang) * tv.TimeElapsed * 0.05
   End If
   If Inp.IsKeyPressed(TV_KEY_DOWN) = True Then
       PosX = PosX - Cos(Ang) * tv.TimeElapsed * 0.05
       PosZ = PosZ - Sin(Ang) * tv.TimeElapsed * 0.05
   End If
   If Inp.IsKeyPressed(TV_KEY_LEFT) = True Then
       Ang = Ang + tv.TimeElapsed * 0.005
   End If
   If Inp.IsKeyPressed(TV_KEY_RIGHT) = True Then
       Ang = Ang - tv.TimeElapsed * 0.005
   End If
   If Inp.IsKeyPressed(TV_KEY_SUBTRACT) = True Then
       PosY = PosY + tv.TimeElapsed * 0.05
   End If
   If Inp.IsKeyPressed(TV_KEY_ADD) = True Then
       PosY = PosY - tv.TimeElapsed * 0.05
   End If
   
  ' PosY = l.GetHeight(PosX, PosZ) + 10
   Scene.SetCamera PosX, PosY, PosZ, PosX + Cos(Ang), PosY, PosZ + Sin(Ang)
End Sub


Sub test()
   Dim w As Long, h As Long
   Dim offset As Long
   Open "d:\lightmap\5.txt" For Binary As 1
   ReDim d(LOF(1) - 1) As Byte
   
   Get #1, , w
   Get #1, , h

   Get #1, , d
   For i = 0 To h - 1
     a$ = ""
     For x = 0 To w - 1
      a$ = a$ + Format(d((i * w + x) * 3), "000") + " " + Format(d((i * w + x) * 3 + 1), "000") + " " + Format(d((i * w + x) * 3 + 2), "000") + "  "
     Next x
     
     Debug.Print a$
   Next i
   ReDim by(w * h * 2#) As Byte
   a = Timer
   offset1 = 0
   offset = 0
   For i = 0 To w * h - 1
      by(offset1) = (d(offset) And &HF8) Or (d(offset + 1) And &HE0) \ 32
      by(offset1 + 1) = (d(offset + 1) And &H1C) * 8 Or (d(offset + 2) And &HF8) \ 8
     offset1 = offset1 + 2
     offset = offset + 3
   Next i
   Debug.Print Timer - a
   Close
    For i = 0 To h - 1
     a$ = ""
     For x = 0 To w - 1
      a$ = a$ + Format(by((i * w + x) * 2), "000") + " " + Format(by((i * w + x) * 2 + 1), "000") + " "
     Next x
     
     Debug.Print a$
   Next i
End Sub


Sub TrySort()
  Dim t(10000) As Integer, s(10000) As Integer
  Dim ie(10000) As Integer
  Dim r As Long
  For i = 1 To 10
    t(i) = Rnd * 32000
    s(i) = t(i)
    ie(i) = i
  Next i
  Dim f As LARGE_INTEGER
  Debug.Print f.lowpart, f.highpart
  
  'r = GetTickCount
  
  QueryPerformanceCounter f
  r = f.lowpart
  QSort t(), ie(), 1, 10
  QueryPerformanceCounter f
  r = f.lowpart - r
  
  'r = GetTickCount - r
  Debug.Print r
  For i = 1 To 10
   Debug.Print ie(i), t(i), s(ie(i))
  Next i
  
End Sub


