VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Texture8"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'----------------
' Texture class
'----------------

Private TextureIndex As Long
Public Sub ApplyOn(MeshObj As Mesh8, Optional Group As Integer = -1, Optional scalex As Single = 1, Optional scaley As Single = 1, Optional ShiftX As Single, Optional ShiftY As Single, Optional Rotation As Single = 0, Optional LightMapToo As Boolean)
 '##BD Apply this texture on a mesh or on a mesh group (created with AddWall or AddFloor). A advantage : The texture coordinates are automatically generated according to the texture size.
 '##PD Mesh Mesh on that the texture will be applied
 '##PD Group Mesh group. Nothing for applying to the entire mesh.
 '##PD ScaleX x-Scale for the texture
 '##PD ScaleY y-scale for the texture
 '##PD ShiftX Texture shift along the x-axis (tex coord u)
 '##PD ShiftY Texture shift along the y-axis (tex coord v)
 Dim w As Single, h As Single
 Dim MI As Integer, V1 As D3DVECTOR, V2 As D3DVECTOR, V(7) As D3DVECTOR
 Dim uu As Single, vv As Single
 Dim v3 As D3DVECTOR
 w = Textures(TextureIndex).TextureWidth
 h = Textures(TextureIndex).TextureHeight
 
 MI = MeshObj.GetMeshIndex
 
 'Put the Rotation Matrix ready
 Dim Matrix As D3DMATRIX
 D3DXMatrixRotationZ Matrix, Rotation * 3.1415 / 180

 With Mesh(MI).Features
   For i = 1 To .NumGroup
     If Group = -1 Or i = Group Then
        For z = 0 To .Groups(i).IndicesCount - 1
         V(z) = Vert2(.LVertex(.Groups(i).VertexOffset + z))
        Next z
        
         V2 = VScale(VNormalize(VSubtract(V(1), V(0))), scalex)
         V1 = VScale(VNormalize(VSubtract(V(2), V(0))), scaley)

        For z = 0 To .Groups(i).IndicesCount - 1
         v3.x = (V(z).x * V1.x + V(z).y * V1.y + V(z).z * V1.z + ShiftX)
         v3.y = (V(z).x * V2.x + V(z).y * V2.y + V(z).z * V2.z + ShiftY)
         
         D3DXVec3TransformCoord v3, v3, Matrix
         uu = v3.x
         vv = v3.y
         
         
         .LVertex(.Groups(i).VertexOffset + z).tu1 = uu / w
         .LVertex(.Groups(i).VertexOffset + z).tv1 = vv / h
         .Vertex(.Groups(i).VertexOffset + z).tu1 = uu / w
         .Vertex(.Groups(i).VertexOffset + z).tv1 = vv / h
        Next z

  
     End If
   Next i
   
 End With
End Sub

Friend Function GetTexIndex() As Long
   GetTexIndex = TextureIndex
End Function

Friend Function SetTexIndex(Index As Long)
   TextureIndex = Index
End Function


