VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "TrueVision8"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'-----------------------
' TrueVision 8 Classes
'-----------------------

Const TV_INITWINDOWED_INTERNAL = -1

Private mvarisInitialized       As Boolean

Public Event RestoreObjectsAfterResize()

Public Property Get Console() As Boolean
    Console = DisplayConsole
End Property

Public Property Let Console(bool As Boolean)
  DisplayConsole = bool
End Property
Public Property Get DisplayFPS() As Boolean
    DisplayFPS = FPSDraw
End Property

Public Property Let DisplayFPS(OnOff As Boolean)
   FPSDraw = OnOff
End Property

Public Sub EnableHardwareTL(OnOff As Boolean)
  '##BD Enable the hardware Transform & Lighting card capability. You have to call this function before creating the device.
   SaveSetting "TrueVision8", "Driver", "T&L", CStr(OnOff)
End Sub

Sub GetVideoMode(width As Long, height As Long, Format As Long)
   width = TVApp.PresentMode.BackBufferWidth
   height = TVApp.PresentMode.BackBufferHeight
   Format = TVApp.PresentMode.BackBufferFormat
End Sub

Sub Init3DFullscreen(width As Long, height As Long, BPP As Long)
     SetEngineMode width, height, BPP, True, 0
     Initialize
End Sub


Public Function Init3DWindowedMode(formHandle As Long) As Boolean
    Init3DWindowedMode = Initialize(formHandle)
End Function
Public Function ResizeDevice() As Boolean
Dim r           As RECT
Dim Mat         As D3DMATRIX
Dim FontS       As IFont

If mvarisInitialized Then
With TVApp
    .DeviceType = Ref
    .Fullscreen = False
    GetClientRect .hwnd, r
    .PresentMode.hDeviceWindow = .hwnd
    .PresentMode.BackBufferWidth = r.Right - r.Left
    .PresentMode.BackBufferHeight = r.Bottom - r.Top
    .PresentMode.Windowed = 1
End With
    
Device.Reset TVApp.PresentMode
    
AddLog "DEVICE INIT : RE-Creating Matrices"
D3DXMatrixLookAtLH ViewMatrix, Vector(0, 0, 0), Vector(0, 0, 1), Vector(0, 1, 0)
D3DXMatrixIdentity WorldMatrix

If farPlane = 0 Then farPlane = 4096
If AngleFOV = 0 Then AngleFOV = 3.1415 / 2

AddLog "DEVICE INIT : Viewport Resized (" + CStr(r.Right - r.Left) + " " + CStr(r.Bottom - r.Top) + ")"
D3DXMatrixPerspectiveFovLH ProjectionMatrix, AngleFOV, (r.Bottom - r.Top) / (r.Right - r.Left), 1, farPlane
Aspect = (r.Bottom - r.Top) / (r.Right - r.Left)
AddLog "DEVICE INIT : Re-Setting the viewport..."
With Viewport
    .width = r.Right - r.Left
    .height = r.Bottom - r.Top
    .x = 0
    .y = 0
    .MinZ = 0#
    .maxZ = 1#
End With
Device.SetViewport Viewport

Device.SetTransform D3DTS_PROJECTION, ProjectionMatrix
Device.SetTransform D3DTS_WORLD, WorldMatrix
Device.SetTransform D3DTS_VIEW, ViewMatrix

AddLog "DEVICE INIT : RE-Creating Spherical environment mapping matrix."
Mat.m11 = 0.5: Mat.m12 = 0#:    Mat.m13 = 0#: Mat.m14 = 0#
Mat.m21 = 0#:   Mat.m22 = -0.5:  Mat.m23 = 0#: Mat.m24 = 0#
Mat.m31 = 0#:   Mat.m32 = 0#:     Mat.m33 = 1#: Mat.m34 = 0#
Mat.m41 = 0.5:  Mat.m42 = 0.5:    Mat.m43 = 0#: Mat.m44 = 1#
SphereMappingMatrix = Mat

AddLog "DEVICE INIT : Re-Setting RenderStates"
Device.SetTextureStageState 0, D3DTSS_MINFILTER, D3DTEXF_LINEAR
Device.SetTextureStageState 0, D3DTSS_MAGFILTER, D3DTEXF_LINEAR
Device.SetTextureStageState 1, D3DTSS_MINFILTER, D3DTEXF_LINEAR
Device.SetTextureStageState 1, D3DTSS_MAGFILTER, D3DTEXF_LINEAR
Device.SetRenderState D3DRS_AMBIENT, &HFFFFFFFF
Device.SetRenderState D3DRS_FILLMODE, D3DFILL_SOLID

Device.SetRenderState D3DRS_ZENABLE, 1
Device.SetRenderState D3DRS_ZWRITEENABLE, 1

Device.SetRenderState D3DRS_ALPHABLENDENABLE, False
Device.SetRenderState D3DRS_CULLMODE, D3DCULL_NONE
Device.SetRenderState D3DRS_SHADEMODE, D3DSHADE_GOURAUD
Device.SetRenderState D3DRS_LIGHTING, 0
Device.SetTextureStageState 0, D3DTSS_TEXCOORDINDEX, D3DTSS_TCI_PASSTHRU

Set FontS = IntForm.Font
Set D3DFont = Nothing
Set D3DFont = D3DX.CreateFont(Device, FontS.hFont)
Set FontS = Nothing

ResizeDevice = True
End If
End Function
' Keep the TV 7 compability
Public Function InitCurrentVideoMode() As Boolean
 InitCurrentVideoMode = Initialize(0)
End Function
Public Sub OpenPAKFile(Filename As String)
'##BD This method open the specified pak file and loads the PAK file directory. When you have called this method, each time the engine will try to load a file (graphic, music, model...), it will search the file in the specified PAK file too. Do not forget to call ClosePakFile when PAK file operations are finished.

'##PD filename Path and name of the PAK file to use. <i>Example: App.Path & "\Models\Models.pak"</i>

Dim i As Long
If PakEnable = False Then
  On Error GoTo Fin
 Open Filename For Binary Lock Read As 80  '80 will be used for all PAK operations
  Get #80, , PakHeader
  Seek #80, PakHeader.dirofs + 1 '+1 because c++ byte count is 0-based
  Get #80, , PakFiles()
  For i = 0 To 4096
   If Len(PakFiles(i).named) < 3 Then Exit For
   'Remove Chr(0)
   PakFiles(i).named = Trim(Left(PakFiles(i).named, InStr(PakFiles(i).named, Chr(0)) - 1))
  Next i
 NBFileInPak = Int(PakHeader.dirlen / Len(PakFiles(1)))
 PackedFile = Filename
 
 PakEnable = True
  AddLog "PAK MANAGER : Pak " + Filename + " opened : " + CStr(NBFileInPak) + " files listed"
 Exit Sub
 End If
Fin:
 AddLog "PAK MANAGER : Error loading PAK files " + Err.Description
 PakEnable = False
End Sub
Sub Clear()
   Device.Clear 0, ByVal 0, D3DCLEAR_TARGET Or D3DCLEAR_ZBUFFER, BackGroundColor, 1, 0
   LocalScreen.DrawBackGround
   NumFaceDisplayed = 0
   Device.SetTransform D3DTS_VIEW, ViewMatrix
   Device.BeginScene
End Sub
 
Function GetFPS() As Single
    GetFPS = FPS
End Function
'---------------------------------
' TrueVision8 Class
'--------------------------------
'
' * Init & Global render functions.
'
' started 15/11/00
'
Public Function Initialize(Optional hwnd As Long = 0) As Boolean
  '##BD Initialize Initialize the engine. You should call this function at the beginning of the program.
  '##PD hwnd Window or PictureBox handle. Pass nothing if you want to use the default TrueVision  fullscreen mode

 'Most important function.
 'Initialize all!
 
 'Get the registry settings.
 Dim width As Long, height As Long, Format As Long
 Dim Ref As Long, Adapter As Long, ZB As Long
 
 Ref = IIf(val(GetSetting("TrueVision8", "Driver", "Direct3D", "0")) = 0, D3DDEVTYPE_HAL, D3DDEVTYPE_REF)
 width = val(GetSetting("TrueVision8", "Driver", "Width", "640"))
 height = val(GetSetting("TrueVision8", "Driver", "Height", "480"))
 Format = val(GetSetting("TrueVision8", "Driver", "Format", "23"))
 Adapter = val(GetSetting("TrueVision8", "Driver", "Adapter", "0"))
 TNLSelected = GetSetting("TrueVision8", "Driver", "T&L", False)
 
 Dim Temp3DS As D3DADAPTER_IDENTIFIER8
 D3D.GetAdapterIdentifier Adapter, 0, Temp3DS
 AddLog "VENDOR INFO : Video card :" & StrConv(Temp3DS.Description, vbUnicode) & " / " & Temp3DS.VendorId
 
 If D3D.CheckDepthStencilMatch(Adapter, D3DDEVTYPE_HAL, Format, Format, D3DFMT_D16) >= 0 Then
   AddLog "SOME TEST : Basic 16bits Z buffer on current format seems to work"
 End If
 If D3D.CheckDepthStencilMatch(Adapter, D3DDEVTYPE_HAL, D3DFMT_R5G6B5, D3DFMT_R5G6B5, D3DFMT_D16) >= 0 Then
   AddLog "SOME TEST : Basic 16bits Z buffer seems to work with R5G6B5 "
 End If
 If D3D.CheckDeviceType(Adapter, D3DDEVTYPE_HAL, Format, Format, IIf(hwnd = 0, 1, 0)) Then
   AddLog "SOME TEST : Your adapter seems to work this the current format"
 End If
 
 If D3D.CheckDeviceFormat(Adapter, D3DDEVTYPE_HAL, Format, D3DUSAGE_DEPTHSTENCIL, D3DRTYPE_SURFACE, D3DFMT_D16) >= 0 Then
   AddLog "DEVICE INIT : The 16bits Z-Buffer is present"
   ZB = D3DFMT_D16
 Else
   AddLog "DEVICE INIT : The Z-Buffer format seems not be compatible with TV8 at the moment"
   AddLog "DEVICE INIT : TV should crashs"
 End If
 
 'Check 32 bits mode Zbuffer
 If D3D.CheckDeviceFormat(Adapter, D3DDEVTYPE_HAL, Format, D3DUSAGE_DEPTHSTENCIL, D3DRTYPE_SURFACE, D3DFMT_D32) >= 0 Then
   AddLog "DEVICE INIT : The 32bits Z-Buffer is present"
   ZB = D3DFMT_D32
 Else
   AddLog "DEVICE INIT : No 32 bits ZBuffer"
 End If
 
 'Check for some cards problem :
 'If ZB = D3DFMT_D32 Then
 '  If Format = D3DFMT_R5G6B5 Then
 '    ZB = D3DFMT_D16
 '  End If
 'End If
 'If ZB = D3DFMT_D16 Then
 '  If Format = D3DFMT_A8R8G8B8 Or Format = D3DFMT_X8R8G8B8 Then
 '    ZB = D3DFMT_D32
 '  End If
 'End If
 
 'Try for the fullscreen mode :
 If hwnd = 0 Then
 
 With TVApp
   .DeviceType = Ref
   .Fullscreen = True
   .hwnd = IntForm.hwnd
   .PresentMode.BackBufferCount = 1
   .PresentMode.SwapEffect = D3DSWAPEFFECT_COPY
   If ZB = 0 Then
   .PresentMode.EnableAutoDepthStencil = False
   Else
   .PresentMode.AutoDepthStencilFormat = ZB
   .PresentMode.EnableAutoDepthStencil = True
   End If
   .PresentMode.BackBufferFormat = Format
   .PresentMode.BackBufferWidth = width
   .PresentMode.BackBufferHeight = height
   .PresentMode.Windowed = False
   '.PresentMode.hDeviceWindow =
 End With
   
 Else
 Dim RectClient As RECT
 
 
 With TVApp
   Dim Mode As D3DDISPLAYMODE
   .DeviceType = Ref
   .Fullscreen = False
   .hwnd = IIf(hwnd = -1, IntForm.hwnd, hwnd)
   GetClientRect .hwnd, RectClient

   .PresentMode.BackBufferCount = 1
   .PresentMode.SwapEffect = D3DSWAPEFFECT_COPY
   If ZB = 0 Then
   .PresentMode.EnableAutoDepthStencil = False
   Else
   .PresentMode.AutoDepthStencilFormat = ZB
   .PresentMode.EnableAutoDepthStencil = True
   End If
          
    D3D.GetAdapterDisplayMode Adapter, Mode
   .PresentMode.BackBufferFormat = Mode.Format
   .PresentMode.BackBufferWidth = RectClient.Right - RectClient.Left
   .PresentMode.BackBufferHeight = RectClient.Bottom - RectClient.Top
   width = .PresentMode.BackBufferWidth
   height = .PresentMode.BackBufferHeight
   .PresentMode.Windowed = True
 End With
 End If
 
 ' IntForm.Show
 On Error Resume Next
  Err.Clear
 
 AddLog "DEVICE INIT : Create the device with " + CStr(TVApp.PresentMode.BackBufferWidth) + "x" + CStr(TVApp.PresentMode.BackBufferHeight) + " ane the DX8 format " + CStr(TVApp.PresentMode.BackBufferFormat) + " / Depth Buffer : " + CStr(IIf(ZB = D3DFMT_D16, 16, 32))
 
 'Get some info on the device caps
 Dim Caps As D3DCAPS8, TNL As Boolean, Pure As Boolean
 D3D.GetDeviceCaps Adapter, Ref, Caps
 If Caps.DevCaps And D3DDEVCAPS_HWTRANSFORMANDLIGHT Then
    AddLog "DEVICE INIT : T&L Card detected. Creating the device with Hardware VertexProcessing"
    TNL = True
 End If
 If Caps.DevCaps And D3DDEVCAPS_PUREDEVICE Then
    AddLog "DEVICE INIT : Pure device Card detected. TV supports pure devices."
    Pure = True
 End If
 If Caps.MaxSimultaneousTextures > 1 Then
   AddLog "DEVICE INIT : Your device supports Single pass Multitexturing. Pixel Shaders & Lightmapping will use it"
   MultiTexturing = True
 Else
   AddLog "DEVICE INIT : Your device doesn't support Single Pass Texturing. Pixel Shaders & LMapping will use Double-Pass."
   MultiTexturing = False
 End If
 
 'Try to create the selected device
 ' T&L Support
  Dim DeviceC As Long
  DeviceC = D3DCREATE_SOFTWARE_VERTEXPROCESSING
  If TNLSelected = True Then
  If TNL = True Then
      DeviceC = D3DCREATE_HARDWARE_VERTEXPROCESSING
 '     If Pure = True Then
 '       DeviceC = DeviceC Or D3DCREATE_PUREDEVICE
 '     End If
  'Else
  '  If Pure = True Then
  '     DeviceC = D3DCREATE_PUREDEVICE
 '  End If
   End If
 End If
  Set Device = D3D.CreateDevice(Adapter, Ref, TVApp.hwnd, DeviceC, TVApp.PresentMode)
  
   '*****************************************
  'added 1/22/01 for global device caps check
  Device.GetDeviceCaps TVApp.Caps
  TVApp.ParticleSize = TVApp.Caps.MaxPointSize
  '*****************************************
 
 If Err.Number And Ref = D3DDEVTYPE_HAL Then
   'try with reference
   AddLog "DEVICE INIT ERROR : Try with the Reference Rasterizer (Software)"
   Err.Clear
 
  
   Set Device = D3D.CreateDevice(Adapter, D3DDEVTYPE_REF, TVApp.hwnd, D3DCREATE_SOFTWARE_VERTEXPROCESSING, TVApp.PresentMode)
 
   If Err.Number Then
     MsgBox "Can't create the device. Contact Sylvain at sylvain@truevision3d.com" + vbCrLf + "NB : DirectX8 has a lot of compabitility problems. Check if your 3D card has new drivers compatible with DirectX8" + vbCrLf + "Please send the debug file too c:\debug8.dat", vbCritical, "TV8"
     Initialize = False
     Exit Function
   End If
   
   'if it works
   TVApp.DeviceType = D3DDEVTYPE_REF
  End If
 
  TVApp.Initialized = True
  AddLog "DEVICE INIT : Device initialized without problem."
  
  
  'Set some main stuff
  AddLog "DEVICE INIT : Create Matrices"
  D3DXMatrixLookAtLH ViewMatrix, Vector(0, 0, 0), Vector(0, 0, 1), Vector(0, 1, 0)
  'D3DXMatrixOrthoLH ProjectionMatrix, width, height, 1, 10000
  D3DXMatrixIdentity WorldMatrix
  If farPlane = 0 Then farPlane = 4096
  If AngleFOV = 0 Then AngleFOV = 3.1415 / 2
  With Device
  AddLog "DEVICE INIT : Viewport size (" + CStr(width) + " " + CStr(height) + ")"
  D3DXMatrixPerspectiveFovLH ProjectionMatrix, AngleFOV, height / width, 1, farPlane
  Aspect = height / width
  AddLog "DEVICE INIT : Set the viewport..."
  With Viewport
    .width = width
    .height = height
    .x = 0
    .y = 0
    .MinZ = 0#
    .maxZ = 1#
  End With
  .SetViewport Viewport
  
  .SetTransform D3DTS_PROJECTION, ProjectionMatrix
  .SetTransform D3DTS_WORLD, WorldMatrix
  .SetTransform D3DTS_VIEW, ViewMatrix
  
   AddLog "DEVICE INIT : Create Spherical environment mapping matrix."
   Dim Mat As D3DMATRIX
   Mat.m11 = 0.5: Mat.m12 = 0#:    Mat.m13 = 0#: Mat.m14 = 0#
   Mat.m21 = 0#:   Mat.m22 = -0.5:  Mat.m23 = 0#: Mat.m24 = 0#
   Mat.m31 = 0#:   Mat.m32 = 0#:     Mat.m33 = 1#: Mat.m34 = 0#
   Mat.m41 = 0.5:  Mat.m42 = 0.5:    Mat.m43 = 0#: Mat.m44 = 1#
   SphereMappingMatrix = Mat
  
 AddLog "DEVICE INIT : Set RenderStates"
 .SetTextureStageState 0, D3DTSS_MINFILTER, D3DTEXF_LINEAR
 .SetTextureStageState 0, D3DTSS_MAGFILTER, D3DTEXF_LINEAR
 .SetTextureStageState 1, D3DTSS_MINFILTER, D3DTEXF_LINEAR
 .SetTextureStageState 1, D3DTSS_MAGFILTER, D3DTEXF_LINEAR
 .SetRenderState D3DRS_AMBIENT, &HFFFFFFFF
 .SetRenderState D3DRS_FILLMODE, D3DFILL_SOLID
 
.SetRenderState D3DRS_ZENABLE, 1
.SetRenderState D3DRS_ZWRITEENABLE, 1
  
 .SetRenderState D3DRS_ALPHABLENDENABLE, False
 .SetRenderState D3DRS_CULLMODE, D3DCULL_NONE
 .SetRenderState D3DRS_SHADEMODE, D3DSHADE_GOURAUD
 .SetRenderState D3DRS_LIGHTING, 0
 .SetTextureStageState 0, D3DTSS_TEXCOORDINDEX, D3DTSS_TCI_PASSTHRU
 
End With
 'Create blank material
 ReDim Materials(1)
 Materials(0).MaterialName = "Blank"
 Materials(0).Mat.Ambient = DXColor(1, 1, 1, 1)
 Materials(0).Mat.Diffuse = DXColor(1, 1, 1, 1)
 Materials(0).Mat.emissive = DXColor(1, 1, 1, 1)
 Materials(0).Mat.Specular = DXColor(1, 1, 1, 1)
 
  TestTextureFormats
 
  AddLog "DEVICE INIT : Create the TrueVision System Font"
  Initialize = True
  Dim FontS As IFont
  Set FontS = IntForm.Font
  Set D3DFont = Nothing
  Set D3DFont = D3DX.CreateFont(Device, FontS.hFont)
  Set FontS = Nothing
  AddLog "DEVICE INIT : Initialization finished ..."
End Function
Sub Pause(milliseconds As Long)
   Dim OldPause As Long
   Do
    DoEvents
   Loop Until GetTickCount - OldPause > milliseconds
End Sub

Sub RenderToScreen()
   
   If SEFogEnabled = True Then Device.SetRenderState D3DRS_FOGENABLE, 0
   
   UpdateFPS
   DrawFade
   If CursorEnable = True Then LocalScene.RenderCursor
   Device.EndScene
   
   FlipToScreen
   
   If TVApp.KeyboardInit = True Then
         Dim mx As Long, my As Long
         DIKeyboardDevice.Poll
         DIKeyboardDevice.GetDeviceStateKeyboard KeyboardState
         DIMouseDevice.GetDeviceStateMouse MouseState
         mx = (MouseState.lX - MouseX) '* mvarMouseSensitivity
         my = (MouseState.lY - MouseY) '* mvarMouseSensitivity
         If mx < 0 Then MouseX = MouseState.lX: mx = 0
         If my < 0 Then MouseY = MouseState.lY: my = 0
         If mx > TVApp.PresentMode.BackBufferWidth Then mx = TVApp.PresentMode.BackBufferWidth: MouseX = MouseState.lX - TVApp.PresentMode.BackBufferWidth '* mvarMouseSensitivity
         If my > TVApp.PresentMode.BackBufferHeight Then my = TVApp.PresentMode.BackBufferHeight: MouseY = MouseState.lY - TVApp.PresentMode.BackBufferHeight '* mvarMouseSensitivity
         ActMX = mx: ActMY = my
         RelMX = (MouseState.lX - AmouseX)
         RelMY = (MouseState.lY - AmouseY)
         AmouseX = MouseState.lX
         AmouseY = MouseState.lY
   End If
   
   If SEFogEnabled = True Then Device.SetRenderState D3DRS_FOGENABLE, 1
   
   ' Compute the new clips planes
   ComputeClipPlanes
   
   'Restart the shaders
   Dim i As Long
   For i = 1 To NBMesh
    Mesh(i).Modified = False
   Next i
   
   'On Local Error Resume Next
   'Dim d As Single
   'd = d / 0
'
'   On Local Error GoTo 0
   
End Sub

Sub ResetDevice()
  Device.Reset TVApp.PresentMode
End Sub

Sub ScreenShot(file As String)
  'Take a screen shot of the current scene
    
  Dim Surface As Direct3DSurface8, Surf2 As Direct3DSurface8
  
  Dim Data() As Byte
  Set Surface = Device.GetBackbuffer(0, D3DBACKBUFFER_TYPE_MONO)
  
  Dim w As Long, h As Long
  Dim Desc As D3DSURFACE_DESC
  Surface.GetDesc Desc
   
  Debug.Print Desc.width, Desc.Format, Desc.height, Desc.Size
  Set Surf2 = Device.CreateImageSurface(Desc.width, Desc.height, Desc.Format)
  
  Device.CopyRects Surface, ByVal 0, 0, Surf2, ByVal 0
  Surf2.GetDesc Desc
  
  ReDim Preserve Data(Desc.Size) As Byte
  Dim RECT As D3DLOCKED_RECT
  'If TVApp.Fullscreen = True Then
   
   Surf2.LockRect RECT, ByVal 0, 0
   DXCopyMemory Data(0), ByVal RECT.pBits, Desc.Size
   Surf2.UnlockRect
   
    Dim MemoryCount As Long, y As Long, temp As Byte
   Dim data2() As Byte
   ReDim data2(Desc.Size) As Byte
   For y = 0 To Desc.height - 1
      DXCopyMemory data2(y * RECT.Pitch), Data((Desc.height - y - 1) * RECT.Pitch), RECT.Pitch
   Next y
    Dim offset As Long, offset2 As Long
    offset = 0
    offset2 = 0
   
   If Desc.Format = D3DFMT_R5G6B5 Then
    '16bits modes
    ReDim Data3(Desc.Size * 3 / 2) As Byte
     For i = 0 To Desc.Size / 2 - 1
      Data3(offset + 2) = data2(offset2 + 1) And &HF8
      Data3(offset + 1) = (data2(offset2 + 1) And &H7) * 32 + (data2(offset2) And &HE0) \ 8
      Data3(offset + 0) = (data2(offset2) And &H1F) * 8
      offset = offset + 3
      offset2 = offset2 + 2
     Next i
   Else
    '32bits modes, alpha is unsignifiant
    ReDim Data3(Desc.Size * 3 / 4) As Byte
     For i = 0 To Desc.Size / 4 - 1
      Data3(offset + 2) = data2(offset2 + 1)
      Data3(offset + 1) = data2(offset2 + 2)
      Data3(offset + 0) = data2(offset2 + 3)
      offset = offset + 3
      offset2 = offset2 + 4
     Next i
   End If
  MemoryCount = UBound(Data3) + 54
  Dim bm As BITMAPHEADER
  Dim bm2 As BITMAPINFOHEADER
  bm.magic = 19778
  bm.Size = MemoryCount
  bm.offset = 54
  bm2.biBitCount = 24
  bm2.biWidth = Desc.width
  bm2.biHeight = Desc.height
  bm2.biSize = 40
  bm2.biPlanes = 1
  bm2.biSizeImage = MemoryCount - 54
  bm2.biCompression = 0
  bm2.biXPelsPerMeter = 50
  bm2.biYPelsPerMeter = 50
   
   Close 1
   Open file For Binary As 1
    Put #1, , bm
    Put #1, , bm2
    Put #1, , Data3()
       
   Close
  'End If
  Erase Data()
  Set Surface = Nothing
End Sub
Public Function SetEngineMode(width As Long, height As Long, BPP As Long, Hardware As Boolean, Optional Adapter As Integer = 0)
 Dim i As Long, Format As CONST_D3DFORMAT, Hard As CONST_D3DDEVTYPE
   SaveSetting "TrueVision8", "Driver", "Width", width
   SaveSetting "TrueVision8", "Driver", "Height", height
   
   
   Format = D3DFMT_R5G6B5
    
   If BPP = 16 Then
     Format = D3DFMT_R5G6B5
   End If
   If BPP = 32 Then
     Format = D3DFMT_A8R8G8B8
   End If
   
   If Hardware = True Then
     Hard = 0
   Else
     Hard = 1
   End If
   
   SaveSetting "TrueVision8", "Driver", "Format", Format
   SaveSetting "TrueVision8", "Driver", "Direct3D", Hard
   SaveSetting "TrueVision8", "Driver", "Adapter", Adapter
   
End Function

Sub SetSearchDirectory(Path As String)
'##BD This method sets the path on the system the engine will look in when files are needed to be loaded. <br> <i>Example: Call SetSearchDirectory (App.Path)</i>
  If Right(Path, 1) <> "\" Then Path = Path + "\"
  ChDrive Left(Path, 1)
  
  ChDir Path
  AppPath = Path
End Sub
Sub ClosePAKFile()
'##BD Close the opened packed file. You have to call this when you have finished your PAK file operations.
 If PakEnable = True Then
  AddLog "PAK MANAGER : Pak Closed."
  PakEnable = False
  Close 80
 End If
End Sub

Public Sub SetWindowTitle(Title As String)
   IntForm.Caption = Title
End Sub

Public Function ShowDriverDialog() As Boolean
    AddLog "DEVICE INIT : Show Driver Dialog"
     DriverForm.Tag = ""
    DriverForm.Show 1
    If DriverForm.Tag = "OK" Then
      ShowDriverDialog = True
    Else
      ShowDriverDialog = False
    End If
   Unload DriverForm
End Function

Sub Start2D()
   'disable the fog for drawing 2d things
   If SEFogEnabled = True Then Device.SetRenderState D3DRS_FOGENABLE, 0
End Sub

Function TickCount() As Long
    TickCount = GetTickCount()
End Function

Function TimeElapsed() As Long
    TimeElapsed = SystemFrame
End Function

Private Sub UpdateFPS()
  Dim Tick As Long
  Tick = GetTickCount
  NBImage = NBImage + 1
  SystemFrame = Tick - OldSys
  If SystemFrame > 200 Then SystemFrame = 50
  OldSys = Tick
  If OldFPS < Tick - 1000 Then
    OldFPS = Tick
    FPS = NBImage
    NBImage = 0
  End If
  If DisplayFPS = True Then
  D3DX.DrawText D3DFont, &HFFFF0000, CStr(FPS) + " FPS", REC(10, 10, 0, 0), 0

End If

End Sub

Private Sub Class_Initialize()
  ' Create the log file
   AddLog "", True

  ' Create the Direct3D object
  Set D3D = DirectX.Direct3DCreate
  
  'Set Console by default
  DisplayConsole = True
End Sub

Private Sub Class_Terminate()
     
   On Error Resume Next
   UnloadAll
   AddLog "Unload Screen"
   
   Set LocalScreen = Nothing
   
   
   AddLog "Unload Scene"
   Set LocalScene = Nothing
   AddLog "Unload BSP tree"
   
   Set BSPTree = Nothing
    AddLog "Unload Local "
   
   Set LocalLand = Nothing
   AddLog "Unload Font"
   
   Set D3DFont = Nothing
    AddLog "Unload Device"
   
   Set Device = Nothing
   AddLog "Unload D3D"
   
   Set D3D = Nothing
      AddLog "Unload DX"

   Set DirectX = Nothing
   Err.Clear
End Sub


